*
*     QCD O(alpha_s^2) leading correction to \rho
*
      complex*16 function drho_at1_as2 (alpha,alphas,mz,mw,mh,mtp)
        implicit none!
        real*8 ctw2,stw2,nf,gfermi,xt,lzt
        real*8 alpha,alphas,mz,mw,mh,mtp
        real*8 c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13
        include "constants.h"

        nf = 6
        ctw2 = mw**2/mz**2
        stw2 = 1-ctw2
        gfermi = pi*alpha/sqrt(2d0)/stw2/mw**2
        xt = sqrt(2d0)*gfermi*mtp**2/16/pi**2

*     L. Avdeev et al., hep-ph/946362
*     \delta^(2)_QCD OS: Eq.(20), p.5
        c1  =  157d0/648
        c2  = -3313d0/162
        c3  = -308d0/27
        c4  =  143d0/18
        c5  = -4d0/3
        c6  =  441d0/8
        c7  = -1d0/9
        c8  = -1d0/18
        c9  = -1d0/18
        c10 = 13d0/9
        c11 = -4d0/9

        drho_at1_as2 =
     &   +1d0/pi**2*(
     &       c1 + c2*z2 + c3*z3 + c4*z4 + c5*z2*ln2 +
     &       c6*s2 + c7*b4 + c8*d3 + (c9 + c10*z2 + c11*z3)*nf
     &              )
*     drho_at_as2 = -1.478 684 237 779 7 ! paper number
*     drho_at_as2 = -1.478 684 238 056 8 ! in real life
*     print *, drho_at_as2

*     K. Chetyrkin et al., hep-ph/9504413
*     \delta^(2)_QCD OS with O((mz/mtp)^4): p.6
        c1  = -17.224d0
        c2  =   0.08829d0
        c3  =   0.4722d0
        c4  =  22.6367d0
        c5  =   1.2527d0
        c6  =  -0.8519d0
        c7  =  -7.7781d0
        c8  =  -0.07226d0
        c9  =   0.004938d0
        c10 =  21.497d0
        c11 =   0.05794d0
        c12 =  -0.006584d0
        c13 = -21.0799d0
        lzt =  2*log(mz/mtp)

        drho_at1_as2 = drho_at1_as2
     &   +1d0/pi**2*(
     &     (mz/mtp)**2*(
     &       c1 + c2*lzt + c3*lzt**2 + (c4 + c5*lzt + c6*lzt**2)*stw2
     &                )
     &    +(mz/mtp)**4*(
     &       c7 + c8*lzt + c9*lzt**2 + (c10 + c11*lzt + c12*lzt**2)*stw2 +
     &       c13*stw2**2
     &                 )
     &              )

        drho_at1_as2 = 3*xt*alphas**2*drho_at1_as2

        return
      end
