#ifndef PARTONDISTRIBUTIONS_H
#define PARTONDISTRIBUTIONS_H

#include <string>
using std::string;

namespace SANC {

class PDF {
protected:
  string pdfname;
  int idA, idB, pdfmember;

public:
  PDF() {}
  PDF(string name, int mem) : pdfname(name), pdfmember(mem) {}
  void init() {
    if (pdfname != "")
      _init();
  }
  void init(string name, int mem) {
    pdfname = name;
    pdfmember = mem;
    _init();
  }
  double xfA(int i, double x, double Q2) { return _xfA(i, x, Q2); }
  double xfB(int i, double x, double Q2) { return _xfB(i, x, Q2); }
  double AlfasQ(double Q) { return _AlfasQ(Q); }
  double Q2min() { return _Q2min(); }
  string name() { return pdfname; }
  virtual int pdfID() = 0;
  virtual ~PDF() = default;

private:
  virtual void _init() = 0;
  virtual double _xfA(int i, double x, double Q2) = 0;
  virtual double _xfB(int i, double x, double Q2) = 0;
  virtual double _AlfasQ(double Q) = 0;
  virtual double _Q2min() = 0;
};

} // namespace SANC

#endif // PARTONDISTRIBUTIONS_H
