#ifndef RENESANCE_PP_H
#define RENESANCE_PP_H
#include <fstream>

class TRandom;

namespace SANC {

class Settings;
class Info;
class ModulesInterface;
class Time;
class Process;
class DataSaver;
class PDF;

class ReneSANCe_pp {
public:
  ReneSANCe_pp(Settings &_cfg, Info &_info, Process &_proc, PDF *_pdf, ModulesInterface &_mod,
               Time &_time, DataSaver &_ds);
  ~ReneSANCe_pp() {}
  void generateGrid();
  void generateEvents();

private:
  Settings &cfg;
  Time &timing;
  Info &info;
  Process &proc;
  PDF *pdf;
  ModulesInterface &modules;
  DataSaver &ds;
  double xwgtup;
  long loop;
  double MCresult, MCerror, MCwt;
  double branch[8] = {0.}, branch_err[8] = {0.};
  TRandom *PseRan;
  std::ofstream output_brn;
  std::ofstream output_tot;
};

} // namespace SANC
#endif // RENESANCE_PP_H
