************************************************************************
* sanc_cc_v1.40 package.
************************************************************************
* File (cc_ff_1314_1516.F) is created on Tue Aug  9 22:35:26 MSD 2011.
************************************************************************
* This is the FORTRAN module (cc_ff_1314_1516) to calculate 1-loop EW
* form factors for the anti-up + dn -> mn + mo^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2011.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ff_1314_1516 (qs,ts,us)
        implicit none!
#include "looptools.h"
#include "s2n_declare.h"

        complex*16 ff_ew_ll,ff_ew_ld,ff_ew_rd

        real*8 a0fw,a0fz,a0fh,a0fmo
        complex*16 b0pmozmo,b0pmohmo,b0pmocw
        complex*16 b0fqswz,b0fqswh,b0fqswc,b0fmowc,b0fmozmo,b0ftsmoc,b0ft
     &   scc,b0fcwmo,b0fmohmo,b0fqsmoc,b0fqscc
        complex*16 c0mocqswcz,c0mocqszmow,c0mocqshmow,c0moctsmozc,c0mocts
     &   cwc,c0mocusmozc,c0ccqswcz,c0cctscwmo,c0cctsczc,c0ccuscwmo,c0mocqs
     &   mozc,c0mocqscmow,c0ccqsczc
        complex*16 b0d2mozmo
        complex*16 d0ccmocqstswczmo,d0ccmocqstszcwc,d0cccmoqsuswczc,d0ccc
     &   moqsuszcwmo
        complex*16 javsubqstscmow,javsubqsuscmow
        real*8 sdet3icmoqs,sdet3icmots,sdet3icmous
        real*8 invfmow
        complex*16 propwqs,propiwqs

        common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
        common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     &   zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
        common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

        cmw2 = mw2

        propiwqs = (cmw2+qs)
        propwqs = 1d0/propiwqs
        a0fw = log(rwm2/thmu2) - 1d0
        a0fz = log(rzm2/thmu2) - 1d0
        a0fh = log(rhm2/thmu2) - 1d0
        a0fmo = log(rmom2/thmu2) - 1d0
        b0pmozmo = b0p(-rmom2,zm2,mom2)
        b0pmohmo = b0p(-rmom2,hm2,mom2)
        b0pmocw = b0p(-rmom2,cm2,wm2)
        b0fqswz = b0f(qs,thmu2,wm2,zm2)
        b0fqswh = b0f(qs,thmu2,wm2,hm2)
        b0fqswc = b0f(qs,thmu2,mw2,cm2)
        b0fmowc = b0f(-rmom2,thmu2,wm2,cm2)
        b0fmozmo = b0f(-rmom2,thmu2,zm2,mom2)
        b0ftsmoc = b0f(ts,thmu2,mom2,cm2)
        b0ftscc = b0f(ts,thmu2,cm2,cm2)
        b0fcwmo = b0f(0d0,thmu2,wm2,mom2)
        b0fmohmo = b0f(-rmom2,thmu2,hm2,mom2)
        b0fqsmoc = b0f(qs,thmu2,mom2,cm2)
        b0fqscc = b0f(qs,thmu2,cm2,cm2)
        c0mocqswcz = c01(-rmom2,1d-6,qs,wm2,cm2,zm2)
        c0mocqszmow = c01(-rmom2,1d-6,qs,zm2,mom2,wm2)
        c0mocqshmow = c01(-rmom2,1d-6,qs,hm2,mom2,wm2)
        c0moctsmozc = c01(-rmom2,0d0,ts,mom2,zm2,cm2)
        c0moctscwc = c01(-rmom2,0d0,ts,cm2,wm2,cm2)
        c0mocusmozc = c01(-rmom2,0d0,us,mom2,zm2,cm2)
        c0ccqswcz = c01(0d0,0d0,qs,wm2,cm2,zm2)
        c0cctscwmo = c01(0d0,0d0,ts,cm2,wm2,mom2)
        c0cctsczc = c01(0d0,0d0,ts,cm2,zm2,cm2)
        c0ccuscwmo = c01(0d0,0d0,us,cm2,wm2,mom2)
        c0mocqsmozc = c01(-rmom2,0d0,qs,mom2,zm2,cm2)
        c0mocqscmow = dreal(c01(-rmom2,0d0,qs,cm2,mom2,mw2))
        c0ccqsczc = c01(0d0,0d0,qs,cm2,zm2,cm2)
        b0d2mozmo = b0d2(-rmom2,thmu2,zm2,mom2)
        d0ccmocqstswczmo =
     &   d0(0d0,0d0,rmom2,0d0,-qs,-ts,rwm2,0d0,rzm2,rmom2)
        d0ccmocqstszcwc =
     &   d0(0d0,0d0,rmom2,0d0,-qs,-ts,rzm2,0d0,rwm2,0d0)
        d0cccmoqsuswczc =
     &   d0(0d0,0d0,0d0,rmom2,-qs,-us,rwm2,0d0,rzm2,0d0)
        d0cccmoqsuszcwmo =
     &   d0(0d0,0d0,0d0,rmom2,-qs,-us,rzm2,0d0,rwm2,rmom2)
        javsubqstscmow = javsub(qs,ts,cm2,mom2,mw2)
        javsubqsuscmow = javsub(qs,us,cm2,mom2,mw2)
        sdet3icmoqs = 1d0/(qs+(mmo)**2)
        sdet3icmots = 1d0/(ts+(mmo)**2)
        sdet3icmous = 1d0/(us+(mmo)**2)
        invfmow = 1d0/(1d0-rmom2/rwm2)

        ff_ew_ll =
     &   +mmo**2*(1d0/16/mw**2+1d0/8*vmamo/mw**2-1d0/8*vpamo/mw**2-2*sdet3
     &   icmoqs**2*qmo*mw**2+2*sdet3icmoqs**2*ctw**2*qmo*mw**2-1d0/8*b0d2m
     &   ozmo/ctw**2*vmamo**2)
     &   +mmo**4*(2*sdet3icmoqs**2*qmo-2*sdet3icmoqs**2*ctw**2*qmo)
     &   +propwqs*a0fw*(-1d0/12/ctw**2*mw**2-1d0/12*mh**2-5*mw**2+3*mw**4/
     &   mh**2)
     &   +propwqs*a0fz*(1d0/12/ctw**4*mw**2+3d0/2/ctw**4*mw**4/mh**2+2d0/3
     &   /ctw**2*mw**2-2*mw**2)
     &   +propwqs*a0fh*(-1d0/12/qs*mh**4+1d0/2*mh**2)
     &   +propwqs*b0fqswz*(1d0/12/ctw**4*mw**2+4d0/3/ctw**2*mw**2-17d0/3*m
     &   w**2-4*ctw**2*mw**2)
     &   +propwqs*b0fqswh*(-1d0/12/qs*mh**4-1d0/3*mh**2+mw**2)
     &   +propwqs*b0fqswc*(-4*mw**2+4*ctw**2*mw**2)
     &   +propwqs*(1d0/ctw**4*mw**4/mh**2-1d0/6/ctw**2*mw**2-1d0/6*mh**2-6
     &   4d0/9*mw**2-mw**2*zmwzwbos+2*mw**4/mh**2)
     &   +propiwqs*mmo**2*(-8*qdn*qmo/ts/us+8*ctw**2*qdn*qmo/ts/us-4*sdet3
     &   icmoqs*qdn*qmo/qs-8*sdet3icmoqs*qdn*qmo/ts-8*sdet3icmoqs*qdn*qmo/
     &   us+4*sdet3icmoqs*ctw**2*qdn*qmo/qs+8*sdet3icmoqs*ctw**2*qdn*qmo/t
     &   s+8*sdet3icmoqs*ctw**2*qdn*qmo/us+2*sdet3icmots*qdn*qmo/us-2*sdet
     &   3icmots*ctw**2*qdn*qmo/us)
     &   +propiwqs*d0ccmocqstswczmo*mmo**2*(1d0/4/ctw**6*vpadn*vpamo/qs/us
     &   *mw**4+1d0/4/ctw**6*vpadn*vpamo/us**2*mw**4-1d0/4/ctw**4*vpadn*vm
     &   amo/qs*mw**2-1d0/4/ctw**4*vpadn*vmamo/us*mw**2-1d0/4/ctw**4*vpadn
     &   *vpamo/qs/us*mw**4+1d0/4/ctw**4*vpadn*vpamo/qs*mw**2+1d0/2/ctw**4
     &   *vpadn*vpamo/us*mw**2+1d0/2/ctw**4*vpadn*vpamo*ts/us**2*mw**2+1d0
     &   /4/ctw**2*vpadn*vmamo/qs*mw**2-1d0/4/ctw**2*vpadn*vmamo/us*mw**2+
     &   1d0/4/ctw**2*vpadn*vmamo*ts/us-1d0/4/ctw**2*vpadn*vpamo/qs*mw**2-
     &   1d0/4/ctw**2*vpadn*vpamo/us**2*mw**4+1d0/4/ctw**2*vpadn*vpamo/us*
     &   mw**2-1d0/4/ctw**2*vpadn*vpamo+1d0/ctw**2*vpadn*vpamo*ts/us**2*mw
     &   **2-1d0/4/ctw**2*vpadn*vpamo*ts/us-3d0/4/ctw**2*vpadn*vpamo*ts**2
     &   /us**2)
     &   +propiwqs*d0ccmocqstswczmo*mmo**4*(1d0/4/ctw**6*vpadn*vpamo/qs/us
     &   **2*mw**4-1d0/4/ctw**4*vpadn*vmamo/qs/us*mw**2+1d0/4/ctw**4*vpadn
     &   *vpamo/qs/us*mw**2+1d0/4/ctw**2*vpadn*vmamo/us+1d0/2/ctw**2*vpadn
     &   *vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo/us-3d0/4/ctw**2*vpadn
     &   *vpamo*ts/us**2)
     &   +propiwqs*d0ccmocqstswczmo*mmo**6*(-1d0/4/ctw**2*vpadn*vpamo/us**
     &   2)
     &   +propiwqs*d0ccmocqstswczmo*(-1d0/4/ctw**6*vpadn*vpamo*ts/us**2*mw
     &   **4-1d0/2/ctw**4*vpadn*vpamo/us*mw**4-1d0/2/ctw**4*vpadn*vpamo*ts
     &   /us**2*mw**4+1d0/2/ctw**4*vpadn*vpamo*ts**2/us**2*mw**2-1d0/4/ctw
     &   **2*vpadn*vpamo*ts/us**2*mw**4-1d0/4/ctw**2*vpadn*vpamo*ts+1d0/2/
     &   ctw**2*vpadn*vpamo*ts**2/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo*ts*
     &   *3/us**2)
     &   +propiwqs*d0ccmocqstszcwc*mmo**2*(-1d0/4/ctw**6*vpaup*vpamn/us**2
     &   *mw**4-1d0/4/ctw**4*vpaup*vpamn/qs/us*mw**4-1d0/4/ctw**4*vpaup*vp
     &   amn/qs*mw**2+1d0/2/ctw**4*vpaup*vpamn*ts/us**2*mw**2+1d0/4/ctw**2
     &   *vpaup*vpamn/qs/us*mw**4+1d0/4/ctw**2*vpaup*vpamn/qs*mw**2+1d0/4/
     &   ctw**2*vpaup*vpamn/us**2*mw**4+1d0/4/ctw**2*vpaup*vpamn/us*mw**2-
     &   1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2)
     &   +propiwqs*d0ccmocqstszcwc*mmo**4*(1d0/4/ctw**2*vpaup*vpamn/qs/us*
     &   *2*mw**4+1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2)
     &   +propiwqs*d0ccmocqstszcwc*(-1d0/4/ctw**6*vpaup*vpamn*ts/us**2*mw*
     &   *4-1d0/2/ctw**4*vpaup*vpamn/us*mw**4-1d0/2/ctw**4*vpaup*vpamn*ts/
     &   us**2*mw**4+1d0/2/ctw**4*vpaup*vpamn*ts**2/us**2*mw**2-1d0/4/ctw*
     &   *2*vpaup*vpamn*ts/us**2*mw**4-1d0/4/ctw**2*vpaup*vpamn*ts+1d0/2/c
     &   tw**2*vpaup*vpamn*ts**2/us**2*mw**2-1d0/4/ctw**2*vpaup*vpamn*ts**
     &   3/us**2)
     &   +propiwqs*d0cccmoqsuswczc*(1d0/2/ctw**2*vpadn*vpamn*us)
     &   +propiwqs*d0cccmoqsuszcwmo*mmo**2*(-1d0/4/ctw**4*vpaup*vmamo/qs*m
     &   w**2+1d0/4/ctw**2*vpaup*vmamo/qs*mw**2+1d0/4/ctw**2*vpaup*vmamo+1
     &   d0/2/ctw**2*vpaup*vpamo)
     &   +propiwqs*d0cccmoqsuszcwmo*mmo**4*(1d0/4/ctw**2*vpaup*vmamo/qs/us
     &   *mw**2+1d0/4/ctw**2*vpaup*vmamo/us)
     &   +propiwqs*d0cccmoqsuszcwmo*(1d0/2/ctw**2*vpaup*vpamo*us)
     &   +propiwqs*c0mocqswcz*mmo**2*(2/ctw**4*vpaup*vpamn/ts/us*mw**2+1d0
     &   /4/ctw**2*vpaup*vpamn/us**2*mw**2+1d0/4/ctw**2*vpaup*vpamn/us+sde
     &   t3icmoqs/ctw**4*vpaup*vpamn/qs*mw**2+2*sdet3icmoqs/ctw**4*vpaup*v
     &   pamn/ts*mw**2+2*sdet3icmoqs/ctw**4*vpaup*vpamn/us*mw**2-1d0/2*sde
     &   t3icmoqs/ctw**2*vpaup*vpamn/qs*mw**2)
     &   +propiwqs*c0mocqswcz*mmo**4*(1d0/4/ctw**2*vpaup*vpamn/qs/us**2*mw
     &   **2+1d0/4/ctw**2*vpaup*vpamn/qs/us)
     &   +propiwqs*c0mocqswcz*(-1d0/ctw**4*vpaup*vpamn/qs*mw**2-1d0/4/ctw*
     &   *4*vpaup*vpamn/us*mw**2-1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2-1
     &   d0/2/ctw**2*vpadn*vpamn+1d0/2/ctw**2*vpaup*vpamn/qs*mw**2-1d0/4/c
     &   tw**2*vpaup*vpamn/us*mw**2+3d0/4/ctw**2*vpaup*vpamn-1d0/4/ctw**2*
     &   vpaup*vpamn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2+2
     &   *sdet3icmoqs/ctw**4*vpaup*vpamn*mw**2-1d0/2*sdet3icmoqs/ctw**2*vp
     &   aup*vpamn*mw**2+1d0/2*sdet3icmoqs/ctw**2*vpaup*vpamn*us+1d0/2*sde
     &   t3icmoqs/ctw**2*vpaup*vpamn*ts+sdet3icmoqs**2/ctw**4*vpaup*vpamn*
     &   us*mw**2+sdet3icmoqs**2/ctw**4*vpaup*vpamn*ts*mw**2)
     &   +propiwqs*c0mocqszmow*mmo**2*(1d0/4/ctw**4*vpadn*vpamo/us**2*mw**
     &   2-1d0/4/ctw**2*vpadn*vmamo/us+2/ctw**2*vpadn*vpamo/ts/us*mw**2+1d
     &   0/2/ctw**2*vpadn*vpamo/us+1d0/4/ctw**2*vpadn*vpamo*ts/us**2+1d0/4
     &   /ctw**2*vpaup*vmamo/us-1d0/2*sdet3icmoqs/ctw**4*vpadn*vpamo/qs*mw
     &   **2+sdet3icmoqs/ctw**2*vpadn*vpamo/qs*mw**2+2*sdet3icmoqs/ctw**2*
     &   vpadn*vpamo/ts*mw**2+2*sdet3icmoqs/ctw**2*vpadn*vpamo/us*mw**2-sd
     &   et3icmoqs/ctw**2*vpadn*vpamo-sdet3icmoqs**2/ctw**2*vpadn*vpamo*us
     &   -sdet3icmoqs**2/ctw**2*vpadn*vpamo*ts)
     &   +propiwqs*c0mocqszmow*mmo**4*(1d0/4/ctw**4*vpadn*vpamo/qs/us**2*m
     &   w**2-1d0/4/ctw**2*vpadn*vmamo/qs/us+1d0/4/ctw**2*vpadn*vpamo/qs/u
     &   s-2/ctw**2*vpadn*vpamo/ts/us+1d0/4/ctw**2*vpaup*vmamo/qs/us-2*sde
     &   t3icmoqs/ctw**2*vpadn*vpamo/ts-2*sdet3icmoqs/ctw**2*vpadn*vpamo/u
     &   s)
     &   +propiwqs*c0mocqszmow*(1d0/2/ctw**4*vpadn*vpamo/qs*mw**2-1d0/4/ct
     &   w**4*vpadn*vpamo/us*mw**2-1d0/4/ctw**4*vpadn*vpamo*ts/us**2*mw**2
     &   -1d0/ctw**2*vpadn*vpamo/qs*mw**2-1d0/4/ctw**2*vpadn*vpamo/us*mw**
     &   2+1d0/4/ctw**2*vpadn*vpamo-1d0/4/ctw**2*vpadn*vpamo*ts/us**2*mw**
     &   2+1d0/4/ctw**2*vpadn*vpamo*ts**2/us**2-1d0/2/ctw**2*vpaup*vpamo-1
     &   d0/2*sdet3icmoqs/ctw**4*vpadn*vpamo*mw**2+2*sdet3icmoqs/ctw**2*vp
     &   adn*vpamo*mw**2+sdet3icmoqs**2/ctw**2*vpadn*vpamo*us*mw**2+sdet3i
     &   cmoqs**2/ctw**2*vpadn*vpamo*ts*mw**2)
     &   +propiwqs*c0moctsmozc*mmo**2*(1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**
     &   2-1d0/4/ctw**2*vpadn*vmamo/qs+1d0/4/ctw**2*vpadn*vmamo/us+1d0/4/c
     &   tw**2*vpadn*vpamo/qs+1d0/4/ctw**2*vpadn*vpamo/us**2*mw**2-1d0/2/c
     &   tw**2*vpadn*vpamo*ts/us**2+1d0/2*sdet3icmots/ctw**4*vpadn*vpamo/u
     &   s*mw**2)
     &   +propiwqs*c0moctsmozc*mmo**4*(-1d0/4/ctw**2*vpadn*vpamo/us**2)
     &   +propiwqs*c0moctsmozc*(1d0/4/ctw**4*vpadn*vpamo*ts/us**2*mw**2+1d
     &   0/4/ctw**2*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpamo*ts
     &   /us-1d0/4/ctw**2*vpadn*vpamo*ts**2/us**2)
     &   +propiwqs*c0moctscwc*mmo**2*(1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2
     &   +1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2+1d0/4/ctw**2*vpaup*vpamn/qs
     &   -1d0/4/ctw**2*vpaup*vpamn*ts/us**2+1d0/2*sdet3icmots/ctw**2*vpaup
     &   *vpamn/us*mw**2)
     &   +propiwqs*c0moctscwc*(1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2+1d0
     &   /4/ctw**2*vpaup*vpamn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpamn*ts/
     &   us-1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2)
     &   +propiwqs*c0mocusmozc*mmo**2*(-1d0/4/ctw**2*vpaup*vmamo/qs)
     &   +propiwqs*c0mocusmozc*mmo**4*(-1d0/4/ctw**2*vpaup*vmamo/qs/us)
     &   +propiwqs*c0ccqswcz*mmo**2*(-1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2
     &   -1d0/4/ctw**2*vpadn*vmamo/us-1d0/4/ctw**2*vpadn*vpamo/us**2*mw**2
     &   +1d0/4/ctw**2*vpadn*vpamo/us+1d0/2/ctw**2*vpadn*vpamo*ts/us**2-1d
     &   0/4/ctw**2*vpaup*vmamo/us+1d0/4/ctw**2*vpaup*vpamn*ts/us**2)
     &   +propiwqs*c0ccqswcz*mmo**4*(1d0/4/ctw**2*vpadn*vpamo/us**2)
     &   +propiwqs*c0ccqswcz*(-1d0/4/ctw**4*vpadn*vpamo/us*mw**2-1d0/4/ctw
     &   **4*vpadn*vpamo*ts/us**2*mw**2-1d0/4/ctw**4*vpaup*vpamn/us*mw**2-
     &   1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo/
     &   us*mw**2+1d0/4/ctw**2*vpadn*vpamo-1d0/4/ctw**2*vpadn*vpamo*ts/us*
     &   *2*mw**2+1d0/4/ctw**2*vpadn*vpamo*ts**2/us**2-1d0/2/ctw**2*vpadn*
     &   vpamn-1d0/2/ctw**2*vpaup*vpamo-1d0/4/ctw**2*vpaup*vpamn/us*mw**2+
     &   1d0/4/ctw**2*vpaup*vpamn-1d0/4/ctw**2*vpaup*vpamn*ts/us**2*mw**2+
     &   1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2)
     &   +propiwqs*c0cctscwmo*mmo**2*(-1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**
     &   2-1d0/4/ctw**4*vpadn*vpamo/us**2*mw**2+1d0/4/ctw**2*vpadn*vmamo/q
     &   s+1d0/4/ctw**2*vpadn*vmamo/us-1d0/4/ctw**2*vpadn*vpamo/qs-1d0/4/c
     &   tw**2*vpadn*vpamo/us-1d0/4/ctw**2*vpadn*vpamo*ts/us**2-qdn*qmo*ts
     &   /us**2+ctw**2*qdn*qmo*ts/us**2)
     &   +propiwqs*c0cctscwmo*mmo**4*(-1d0/4/ctw**4*vpadn*vpamo/qs/us**2*m
     &   w**2+1d0/4/ctw**2*vpadn*vmamo/qs/us-1d0/4/ctw**2*vpadn*vpamo/qs/u
     &   s)
     &   +propiwqs*c0cctscwmo*(1d0/4/ctw**4*vpadn*vpamo*ts/us**2*mw**2+1d0
     &   /4/ctw**2*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpamo*ts/
     &   us-1d0/4/ctw**2*vpadn*vpamo*ts**2/us**2+qdn*qmo*ts/us**2*mw**2+qd
     &   n*qmo*ts/us-qdn*qmo*ts**2/us**2-ctw**2*qdn*qmo*ts/us**2*mw**2-ctw
     &   **2*qdn*qmo*ts/us+ctw**2*qdn*qmo*ts**2/us**2)
     &   +propiwqs*c0cctsczc*mmo**2*(-1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2
     &   -1d0/4/ctw**2*vpaup*vpamn/qs-1d0/4/ctw**2*vpaup*vpamn/us**2*mw**2
     &   -1d0/4/ctw**2*vpaup*vpamn/us)
     &   +propiwqs*c0cctsczc*mmo**4*(-1d0/4/ctw**2*vpaup*vpamn/qs/us**2*mw
     &   **2-1d0/4/ctw**2*vpaup*vpamn/qs/us)
     &   +propiwqs*c0cctsczc*(1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2+1d0/
     &   4/ctw**2*vpaup*vpamn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpamn*ts/u
     &   s-1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2)
     &   +propiwqs*c0ccuscwmo*mmo**2*(1d0/4/ctw**2*vpaup*vmamo/qs+qup*qmo/
     &   qs-ctw**2*qup*qmo/qs)
     &   +propiwqs*a0fw*(-4/qs+3/qs*mw**2/mh**2)
     &   +propiwqs*a0fz*mmo**2*(-1d0/2*sdet3icmoqs/ctw**2*vpaup*vpamn/qs)
     &   +propiwqs*a0fz*(3d0/2/ctw**4/qs*mw**2/mh**2+1d0/2/ctw**2*vpaup*vp
     &   amn/qs-1d0/2*sdet3icmoqs/ctw**2*vpaup*vpamn)
     &   +propiwqs*a0fmo*mmo**2*(8*stw**2*qdn*qmo/ts/us+8*sdet3icmoqs*stw*
     &   *2*qdn*qmo/ts+8*sdet3icmoqs*stw**2*qdn*qmo/us-2*sdet3icmots*stw**
     &   2*qdn*qmo/us)
     &   +propiwqs*b0fmowc*mmo**2*(-2/ctw**2*vpaup*vpamn/ts/us-sdet3icmoqs
     &   /ctw**2*vpaup*vpamn/qs-2*sdet3icmoqs/ctw**2*vpaup*vpamn/ts-2*sdet
     &   3icmoqs/ctw**2*vpaup*vpamn/us+1d0/2*sdet3icmots/ctw**2*vpaup*vpam
     &   n/us)
     &   +propiwqs*b0fmowc*(1d0/ctw**2*vpaup*vpamn/qs-2*sdet3icmoqs/ctw**2
     &   *vpaup*vpamn-sdet3icmoqs**2/ctw**2*vpaup*vpamn*us-sdet3icmoqs**2/
     &   ctw**2*vpaup*vpamn*ts)
     &   +propiwqs*b0fmozmo*mmo**2*(-2/ctw**2*vpadn*vpamo/ts/us-sdet3icmoq
     &   s/ctw**2*vpadn*vpamo/qs-2*sdet3icmoqs/ctw**2*vpadn*vpamo/ts-2*sde
     &   t3icmoqs/ctw**2*vpadn*vpamo/us+1d0/2*sdet3icmots/ctw**2*vpadn*vpa
     &   mo/us)
     &   +propiwqs*b0fmozmo*(1d0/ctw**2*vpadn*vpamo/qs-2*sdet3icmoqs/ctw**
     &   2*vpadn*vpamo-sdet3icmoqs**2/ctw**2*vpadn*vpamo*us-sdet3icmoqs**2
     &   /ctw**2*vpadn*vpamo*ts)
     &   +propiwqs*b0fqswz*mmo**2*(2/ctw**2*vpadn*vpamo/ts/us+2/ctw**2*vpa
     &   up*vpamn/ts/us+1d0/2*sdet3icmoqs/ctw**2*vpadn*vpamo/qs+2*sdet3icm
     &   oqs/ctw**2*vpadn*vpamo/ts+2*sdet3icmoqs/ctw**2*vpadn*vpamo/us+1d0
     &   /2*sdet3icmoqs/ctw**2*vpaup*vpamn/qs+2*sdet3icmoqs/ctw**2*vpaup*v
     &   pamn/ts+2*sdet3icmoqs/ctw**2*vpaup*vpamn/us)
     &   +propiwqs*b0fqswz*(5d0/6/ctw**2/qs-1d0/2/ctw**2*vpadn*vpamo/qs-1d
     &   0/2/ctw**2*vpadn*vpamo/us-1d0/2/ctw**2*vpaup*vpamn/qs-1d0/2/ctw**
     &   2*vpaup*vpamn/us-53d0/12/qs-14d0/3*ctw**2/qs+3d0/2*sdet3icmoqs/ct
     &   w**2*vpadn*vpamo+3d0/2*sdet3icmoqs/ctw**2*vpaup*vpamn+sdet3icmoqs
     &   **2/ctw**2*vpadn*vpamo*us+sdet3icmoqs**2/ctw**2*vpadn*vpamo*ts+sd
     &   et3icmoqs**2/ctw**2*vpaup*vpamn*us+sdet3icmoqs**2/ctw**2*vpaup*vp
     &   amn*ts)
     &   +propiwqs*b0fqswh*(11d0/12/qs)
     &   +propiwqs*b0fqswc*mmo**2*(8*qdn*qmo/ts/us-8*ctw**2*qdn*qmo/ts/us+
     &   2*sdet3icmoqs*qdn*qmo/qs+8*sdet3icmoqs*qdn*qmo/ts+8*sdet3icmoqs*q
     &   dn*qmo/us-2*sdet3icmoqs*ctw**2*qdn*qmo/qs-8*sdet3icmoqs*ctw**2*qd
     &   n*qmo/ts-8*sdet3icmoqs*ctw**2*qdn*qmo/us)
     &   +propiwqs*b0fqswc*(-14d0/3/qs-2*qdn*qmo/qs-2*qdn*qmo/us+14d0/3*ct
     &   w**2/qs+2*ctw**2*qdn*qmo/qs+2*ctw**2*qdn*qmo/us+6*sdet3icmoqs*qdn
     &   *qmo-6*sdet3icmoqs*ctw**2*qdn*qmo+4*sdet3icmoqs**2*qdn*qmo*us+4*s
     &   det3icmoqs**2*qdn*qmo*ts-4*sdet3icmoqs**2*ctw**2*qdn*qmo*us-4*sde
     &   t3icmoqs**2*ctw**2*qdn*qmo*ts)
     &   +propiwqs*b0ftsmoc*mmo**2*(-1d0/2*sdet3icmots/ctw**2*vpadn*vpamo/
     &   us-2*sdet3icmots*qdn*qmo/us+2*sdet3icmots*ctw**2*qdn*qmo/us)
     &   +propiwqs*b0ftsmoc*(1d0/2/ctw**2*vpadn*vpamo/us+2*qdn*qmo/us-2*ct
     &   w**2*qdn*qmo/us)
     &   +propiwqs*b0ftscc*mmo**2*(-1d0/2*sdet3icmots/ctw**2*vpaup*vpamn/u
     &   s)
     &   +propiwqs*b0ftscc*(1d0/2/ctw**2*vpaup*vpamn/us)
     &   +propiwqs*b0fcwmo*mmo**2*(1d0/2*sdet3icmoqs/ctw**2*vpadn*vpamo/qs
     &   +2*sdet3icmoqs*qdn*qmo/qs-2*sdet3icmoqs*ctw**2*qdn*qmo/qs)
     &   +propiwqs*b0fcwmo*(-1d0/2/ctw**2*vpadn*vpamo/qs-2*qdn*qmo/qs+2*ct
     &   w**2*qdn*qmo/qs+1d0/2*sdet3icmoqs/ctw**2*vpadn*vpamo+2*sdet3icmoq
     &   s*qdn*qmo-2*sdet3icmoqs*ctw**2*qdn*qmo)
     &   +propiwqs*(1d0/ctw**4/qs*mw**2/mh**2-1d0/6/ctw**2/qs-64d0/9/qs+2/
     &   qs*mw**2/mh**2+4*qdn*qmo/qs-4*ctw**2*qdn*qmo/qs-8*sdet3icmoqs*qdn
     &   *qmo+8*sdet3icmoqs*ctw**2*qdn*qmo-4*sdet3icmoqs**2*qdn*qmo*us-4*s
     &   det3icmoqs**2*qdn*qmo*ts+4*sdet3icmoqs**2*ctw**2*qdn*qmo*us+4*sde
     &   t3icmoqs**2*ctw**2*qdn*qmo*ts)
     &   +javsubqstscmow*mmo**2*(qdn*qmo/us**2*mw**4+qdn*qmo-4*qdn*qmo*ts/
     &   us**2*mw**2+3*qdn*qmo*ts**2/us**2-ctw**2*qdn*qmo/us**2*mw**4-ctw*
     &   *2*qdn*qmo+4*ctw**2*qdn*qmo*ts/us**2*mw**2-3*ctw**2*qdn*qmo*ts**2
     &   /us**2)
     &   +javsubqstscmow*mmo**4*(-2*qdn*qmo/us**2*mw**2+3*qdn*qmo*ts/us**2
     &   +2*ctw**2*qdn*qmo/us**2*mw**2-3*ctw**2*qdn*qmo*ts/us**2)
     &   +javsubqstscmow*mmo**6*(qdn*qmo/us**2-ctw**2*qdn*qmo/us**2)
     &   +javsubqstscmow*(qdn*qmo*ts/us**2*mw**4+qdn*qmo*ts-2*qdn*qmo*ts**
     &   2/us**2*mw**2+qdn*qmo*ts**3/us**2-ctw**2*qdn*qmo*ts/us**2*mw**4-c
     &   tw**2*qdn*qmo*ts+2*ctw**2*qdn*qmo*ts**2/us**2*mw**2-ctw**2*qdn*qm
     &   o*ts**3/us**2)
     &   +javsubqsuscmow*mmo**2*(-qup*qmo/qs*mw**2-3*qup*qmo+ctw**2*qup*qm
     &   o/qs*mw**2+3*ctw**2*qup*qmo)
     &   +javsubqsuscmow*mmo**4*(-qup*qmo/qs/us*mw**2-qup*qmo/us+ctw**2*qu
     &   p*qmo/qs/us*mw**2+ctw**2*qup*qmo/us)
     &   +javsubqsuscmow*(-2*qup*qmo*us+2*ctw**2*qup*qmo*us)
     &   +c0mocqswcz*mmo**2*(vpamn+1d0/2*sdet3icmoqs/ctw**4*vpamn*mw**2-sd
     &   et3icmoqs**2/ctw**4*vpamn*mw**4)
     &   +c0mocqswcz*(-1d0/ctw**2*vpamn*mw**2-vpamn*mw**2+sdet3icmoqs/ctw*
     &   *2*vpamn*mw**4)
     &   +c0mocqszmow*mmo**2*(-1d0/2/ctw**2*vpamo+3d0/2*vmamo-1d0/2*vpamo-
     &   1d0/4*sdet3icmoqs/ctw**2*vmamo*mw**2+3d0/4*sdet3icmoqs/ctw**2*vpa
     &   mo*mw**2+1d0/2*sdet3icmoqs*vmamo*mw**2+1d0/2*sdet3icmoqs*vpamo*mw
     &   **2+sdet3icmoqs**2*vpamo*mw**4)
     &   +c0mocqszmow*mmo**4*(-1d0/4*vmamo/mw**2+1d0/4*vpamo/mw**2+1d0/4*s
     &   det3icmoqs/ctw**2*vmamo+1d0/4*sdet3icmoqs/ctw**2*vpamo-sdet3icmoq
     &   s*vmamo-1d0/4*sdet3icmoqs**2*vmamo*mw**2-7d0/4*sdet3icmoqs**2*vpa
     &   mo*mw**2)
     &   +c0mocqszmow*mmo**6*(1d0/2*sdet3icmoqs*vmamo/mw**2-1d0/2*sdet3icm
     &   oqs*vpamo/mw**2+1d0/2*sdet3icmoqs**2*vmamo+1d0/2*sdet3icmoqs**2*v
     &   pamo)
     &   +c0mocqszmow*mmo**8*(-1d0/4*sdet3icmoqs**2*vmamo/mw**2+1d0/4*sdet
     &   3icmoqs**2*vpamo/mw**2)
     &   +c0mocqszmow*(1d0/ctw**2*vpamo*mw**2+vpamo*mw**2-sdet3icmoqs/ctw*
     &   *2*vpamo*mw**4)
     &   +c0mocqshmow*mmo**2*(1d0/2+1d0/4*sdet3icmoqs*mh**2-1d0/2*sdet3icm
     &   oqs*mw**2)
     &   +c0mocqshmow*mmo**4*(-1d0/4/mw**2-1d0/4*sdet3icmoqs/mw**2*mh**2-1
     &   d0/4*sdet3icmoqs**2*mw**2)
     &   +c0mocqshmow*mmo**6*(1d0/2*sdet3icmoqs/mw**2+1d0/2*sdet3icmoqs**2
     &   )
     &   +c0mocqshmow*mmo**8*(-1d0/4*sdet3icmoqs**2/mw**2)
     &   +c0mocqsmozc*mmo**2*(-1d0/2*sdet3icmoqs/ctw**4*vpamn*vpamo*mw**2+
     &   1d0/2*sdet3icmoqs**2/ctw**6*vpamn*vpamo*mw**4)
     &   +c0mocqsmozc*(1d0/ctw**4*vpamn*vpamo*mw**2+1d0/2/ctw**2*vpamn*vpa
     &   mo*us+1d0/2/ctw**2*vpamn*vpamo*ts-1d0/2*sdet3icmoqs/ctw**6*vpamn*
     &   vpamo*mw**4)
     &   +c0mocqscmow*mmo**2*(-stw**2/us*mw**2-2*stw**2+stw**2*ts/us-8*stw
     &   **2*qdn/ts/us*mw**4-stw**2*qdn/us*mw**2+2*stw**2*qdn+stw**2*qdn*t
     &   s/us-2*sdet3icmoqs*stw**2*mw**2-4*sdet3icmoqs*stw**2*qdn/qs*mw**4
     &   -8*sdet3icmoqs*stw**2*qdn/ts*mw**4-8*sdet3icmoqs*stw**2*qdn/us*mw
     &   **4-2*sdet3icmoqs**2*stw**2*mw**4-sdet3icmous*stw**2*mw**2+sdet3i
     &   cmous*stw**2*ts-sdet3icmous*stw**2*qdn*mw**2+sdet3icmous*stw**2*q
     &   dn*ts)
     &   +c0mocqscmow*mmo**4*(-stw**2/qs/us*mw**2-stw**2*qdn/qs/us*mw**2+1
     &   6*stw**2*qdn/ts/us*mw**2+2*sdet3icmoqs*stw**2+16*sdet3icmoqs*stw*
     &   *2*qdn/ts*mw**2+16*sdet3icmoqs*stw**2*qdn/us*mw**2+4*sdet3icmoqs*
     &   *2*stw**2*mw**2-sdet3icmous*stw**2/qs*mw**2-sdet3icmous*stw**2/us
     &   *mw**2+sdet3icmous*stw**2*ts/us-sdet3icmous*stw**2*qdn/qs*mw**2-s
     &   det3icmous*stw**2*qdn/us*mw**2+sdet3icmous*stw**2*qdn*ts/us)
     &   +c0mocqscmow*mmo**6*(-8*stw**2*qdn/ts/us-8*sdet3icmoqs*stw**2*qdn
     &   /ts-8*sdet3icmoqs*stw**2*qdn/us-2*sdet3icmoqs**2*stw**2-sdet3icmo
     &   us*stw**2/qs/us*mw**2-sdet3icmous*stw**2*qdn/qs/us*mw**2)
     &   +c0mocqscmow*(4*stw**2*qdn/qs*mw**4-4*sdet3icmoqs*stw**2*qdn*mw**
     &   4)
     &   +c0ccqswcz*(-1d0/ctw**2*vpadn/qs*mw**4+1d0/ctw**2*vpadn*mw**2+1d0
     &   /ctw**2*vpaup/qs*mw**4-1d0/ctw**2*vpaup*mw**2+vpadn*mw**2-vpaup*m
     &   w**2)
     &   +c0ccqsczc*mmo**2*(1d0/2/ctw**2*vpaup*vpadn)
     &   +c0ccqsczc*(-1d0/2/ctw**6*vpaup*vpadn/qs*mw**4+1d0/ctw**4*vpaup*v
     &   padn*mw**2+1d0/2/ctw**2*vpaup*vpadn*us+1d0/2/ctw**2*vpaup*vpadn*t
     &   s)
     &   +c0cctscwmo*mmo**2*(qdn*qmo/us**2*mw**4+qdn*qmo-4*qdn*qmo*ts/us**
     &   2*mw**2+3*qdn*qmo*ts**2/us**2-ctw**2*qdn*qmo/us**2*mw**4-ctw**2*q
     &   dn*qmo+4*ctw**2*qdn*qmo*ts/us**2*mw**2-3*ctw**2*qdn*qmo*ts**2/us*
     &   *2)
     &   +c0cctscwmo*mmo**4*(-2*qdn*qmo/us**2*mw**2+3*qdn*qmo*ts/us**2+2*c
     &   tw**2*qdn*qmo/us**2*mw**2-3*ctw**2*qdn*qmo*ts/us**2)
     &   +c0cctscwmo*mmo**6*(qdn*qmo/us**2-ctw**2*qdn*qmo/us**2)
     &   +c0cctscwmo*(qdn*qmo*ts/us**2*mw**4+qdn*qmo*ts-2*qdn*qmo*ts**2/us
     &   **2*mw**2+qdn*qmo*ts**3/us**2-ctw**2*qdn*qmo*ts/us**2*mw**4-ctw**
     &   2*qdn*qmo*ts+2*ctw**2*qdn*qmo*ts**2/us**2*mw**2-ctw**2*qdn*qmo*ts
     &   **3/us**2)
     &   +c0ccuscwmo*mmo**2*(-qup*qmo/qs*mw**2-3*qup*qmo+ctw**2*qup*qmo/qs
     &   *mw**2+3*ctw**2*qup*qmo)
     &   +c0ccuscwmo*mmo**4*(-qup*qmo/qs/us*mw**2-qup*qmo/us+ctw**2*qup*qm
     &   o/qs/us*mw**2+ctw**2*qup*qmo/us)
     &   +c0ccuscwmo*(-2*qup*qmo*us+2*ctw**2*qup*qmo*us)
     &   +a0fw*mmo**2*(1d0/8*sdet3icmoqs+1d0/8*sdet3icmoqs*vmamo-1d0/8*sde
     &   t3icmoqs*vpamo)
     &   +a0fw*(65d0/8+1d0/12/ctw**2/qs*mw**2+1d0/12/qs*mh**2+23d0/6/qs*mw
     &   **2-3/qs*mw**4/mh**2-3*mw**2/mh**2-1d0/2*vpadn/qs*mw**2+vpadn+1d0
     &   /2*vpaup/qs*mw**2-vpaup-qdn/qs*mw**2+2*qdn+qup/qs*mw**2-2*qup+ctw
     &   **2*qdn/qs*mw**2-2*ctw**2*qdn-ctw**2*qup/qs*mw**2+2*ctw**2*qup-1d
     &   0/2*sdet3icmoqs*vpamo*mw**2-sdet3icmoqs*qmo*mw**2+sdet3icmoqs*ctw
     &   **2*qmo*mw**2+7d0/8*invfmow+invfmow*vpamo+2*invfmow*qmo-2*invfmow
     &   *ctw**2*qmo-3d0/8*invfmow**2)
     &   +a0fz*(-1d0/12/ctw**4/qs*mw**2-3d0/2/ctw**4/qs*mw**4/mh**2-3d0/2/
     &   ctw**4*mw**2/mh**2+1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-7d0/12/ctw**
     &   2/qs*mw**2+1d0/16/ctw**2*vmamo**2+1d0/8/ctw**2*vpamo*vmamo-1d0/16
     &   /ctw**2*vpamo**2-1d0/2/ctw**2*vpamn*vpamo+1d0/8/ctw**2*vpamn**2-1
     &   d0/2/ctw**2*vpadn/qs*mw**2+1d0/8/ctw**2*vpadn**2+1d0/2/ctw**2*vpa
     &   up/qs*mw**2-1d0/ctw**2*vpaup*vpadn+1d0/8/ctw**2*vpaup**2+2d0/3/qs
     &   *mw**2-vpamn+vpadn-vpaup+1d0/4*sdet3icmoqs/ctw**4*vpamn*vpamo*mw*
     &   *2+1d0/2*sdet3icmoqs/ctw**2*vpamn*mw**2)
     &   +a0fh*(1d0/12/qs*mh**2-1d0/16/mw**2*mh**2)
     &   +a0fmo*mmo**2*(3d0/16/mw**2-1d0/8*vpamo*vmamo/mw**2+1d0/16*vpamo*
     &   *2/mw**2+1d0/4*stw**4*qmo**2/mw**2+1d0/2*sdet3icmoqs*vpamo+sdet3i
     &   cmoqs*stw**2*qmo+2*sdet3icmoqs**2*stw**2*qmo*mw**2-7d0/8*invfmow/
     &   mw**2-invfmow*vpamo/mw**2-2*invfmow*stw**2*qmo/mw**2+3d0/8*invfmo
     &   w**2/mw**2)
     &   +a0fmo*mmo**4*(-1d0/8*sdet3icmoqs/mw**2-1d0/8*sdet3icmoqs*vmamo/m
     &   w**2+1d0/8*sdet3icmoqs*vpamo/mw**2-2*sdet3icmoqs**2*stw**2*qmo)
     &   +a0fmo*(-3d0/8+3d0/8*invfmow)
     &   +b0fmowc*mmo**2*(-1d0/2*sdet3icmoqs/ctw**2*vpamn-1d0/2*sdet3icmoq
     &   s*vpamn+sdet3icmoqs**2/ctw**2*vpamn*mw**2)
     &   +b0fmowc*(-3d0/8+vpamn-1d0/2*sdet3icmoqs*vpamn*mw**2)
     &   +b0fmozmo*mmo**2*(3d0/8*sdet3icmoqs/ctw**2*vmamo+1d0/8*sdet3icmoq
     &   s/ctw**2*vpamo-1d0/2*sdet3icmoqs/ctw**2*vpamn*vpamo-1d0/2*sdet3ic
     &   moqs*vmamo+1d0/2*sdet3icmoqs*vpamo+1d0/2*sdet3icmoqs**2/ctw**4*vp
     &   amn*vpamo*mw**2-sdet3icmoqs**2*vpamo*mw**2)
     &   +b0fmozmo*mmo**4*(1d0/4*sdet3icmoqs*vmamo/mw**2-1d0/4*sdet3icmoqs
     &   *vpamo/mw**2+1d0/4*sdet3icmoqs**2*vmamo+3d0/4*sdet3icmoqs**2*vpam
     &   o)
     &   +b0fmozmo*mmo**6*(-1d0/4*sdet3icmoqs**2*vmamo/mw**2+1d0/4*sdet3ic
     &   moqs**2*vpamo/mw**2)
     &   +b0fmozmo*(1d0/16/ctw**2*vmamo**2+1d0/8/ctw**2*vpamo*vmamo-3d0/16
     &   /ctw**2*vpamo**2+1d0/2/ctw**2*vpamn*vpamo-vpamo-1d0/4*sdet3icmoqs
     &   /ctw**4*vpamn*vpamo*mw**2+1d0/2*sdet3icmoqs/ctw**2*vpamo*mw**2)
     &   +b0fmohmo*mmo**2*(1d0/2*sdet3icmoqs-1d0/8*sdet3icmoqs/mw**2*mh**2
     &   )
     &   +b0fmohmo*mmo**4*(1d0/4*sdet3icmoqs/mw**2+1d0/4*sdet3icmoqs**2)
     &   +b0fmohmo*mmo**6*(-1d0/4*sdet3icmoqs**2/mw**2)
     &   +b0fmohmo*(-1d0/16/mw**2*mh**2)
     &   +b0fqswz*mmo**2*(1d0/8*vmamo/mw**2-1d0/8*vpamo/mw**2-3d0/8*sdet3i
     &   cmoqs/ctw**2*vmamo-1d0/8*sdet3icmoqs/ctw**2*vpamo+1d0/2*sdet3icmo
     &   qs/ctw**2*vpamn+5d0/8*sdet3icmoqs*vmamo-1d0/8*sdet3icmoqs*vpamo+1
     &   d0/2*sdet3icmoqs*vpamn-sdet3icmoqs**2/ctw**2*vpamn*mw**2+sdet3icm
     &   oqs**2*vpamo*mw**2)
     &   +b0fqswz*mmo**4*(-3d0/8*sdet3icmoqs*vmamo/mw**2+3d0/8*sdet3icmoqs
     &   *vpamo/mw**2-1d0/4*sdet3icmoqs**2*vmamo-3d0/4*sdet3icmoqs**2*vpam
     &   o)
     &   +b0fqswz*mmo**6*(1d0/4*sdet3icmoqs**2*vmamo/mw**2-1d0/4*sdet3icmo
     &   qs**2*vpamo/mw**2)
     &   +b0fqswz*(13d0/3-1d0/12/ctw**4/qs*mw**2-4d0/3/ctw**2/qs*mw**2-5d0
     &   /6/ctw**2-1d0/2/ctw**2*vpadn/qs*mw**2+1d0/2/ctw**2*vpaup/qs*mw**2
     &   +17d0/3/qs*mw**2+1d0/2*vpamo-1d0/2*vpamn-1d0/2*vpadn/qs*mw**2+1d0
     &   /2*vpadn+1d0/2*vpaup/qs*mw**2-1d0/2*vpaup+4*ctw**2/qs*mw**2+8*ctw
     &   **2-1d0/2*sdet3icmoqs/ctw**2*vpamo*mw**2+1d0/2*sdet3icmoqs/ctw**2
     &   *vpamn*mw**2-1d0/2*sdet3icmoqs*vpamo*mw**2+1d0/2*sdet3icmoqs*vpam
     &   n*mw**2)
     &   +b0fqswh*mmo**2*(1d0/8/mw**2-3d0/8*sdet3icmoqs+1d0/8*sdet3icmoqs/
     &   mw**2*mh**2)
     &   +b0fqswh*mmo**4*(-3d0/8*sdet3icmoqs/mw**2-1d0/4*sdet3icmoqs**2)
     &   +b0fqswh*mmo**6*(1d0/4*sdet3icmoqs**2/mw**2)
     &   +b0fqswh*(-1+1d0/6/qs*mh**2-1d0/qs*mw**2)
     &   +b0fqswc*mmo**2*(sdet3icmoqs*qmo-sdet3icmoqs*ctw**2*qmo+2*sdet3ic
     &   moqs**2*qmo*mw**2-2*sdet3icmoqs**2*ctw**2*qmo*mw**2)
     &   +b0fqswc*mmo**4*(-2*sdet3icmoqs**2*qmo+2*sdet3icmoqs**2*ctw**2*qm
     &   o)
     &   +b0fqswc*(8+4/qs*mw**2+qmo-qdn/qs*mw**2+qdn+qup/qs*mw**2-qup-4*ct
     &   w**2/qs*mw**2-8*ctw**2-ctw**2*qmo+ctw**2*qdn/qs*mw**2-ctw**2*qdn-
     &   ctw**2*qup/qs*mw**2+ctw**2*qup-sdet3icmoqs*qmo*mw**2+sdet3icmoqs*
     &   ctw**2*qmo*mw**2)
     &   +b0fqsmoc*mmo**2*(1d0/2*sdet3icmoqs/ctw**2*vpamn*vpamo-1d0/2*sdet
     &   3icmoqs**2/ctw**4*vpamn*vpamo*mw**2)
     &   +b0fqsmoc*(-3d0/4/ctw**2*vpamn*vpamo+1d0/2*sdet3icmoqs/ctw**4*vpa
     &   mn*vpamo*mw**2)
     &   +b0fqscc*(1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-3d0/4/ctw**2*vpaup*vp
     &   adn-3*qup*qdn+3*ctw**2*qup*qdn)
     &   +dreal(b0pmozmo)*mmo**2*(1d0/8/ctw**2*vmamo**2-3d0/4/ctw**2*vpamo
     &   *vmamo+1d0/8/ctw**2*vpamo**2)
     &   +dreal(b0pmozmo)*(-1d0/8/ctw**4*vmamo**2*mw**2-1d0/8/ctw**4*vpamo
     &   **2*mw**2)
     &   +dreal(b0pmohmo)*mmo**2*(-1d0/8/mw**2*mh**2)
     &   +dreal(b0pmohmo)*mmo**4*(1d0/2/mw**2)
     &   +dreal(b0pmocw)*mmo**2*(1d0/8)
     &   +dreal(b0pmocw)*mmo**4*(1d0/8/mw**2)
     &   +dreal(b0pmocw)*(-1d0/4*mw**2)
     &   +110d0/9+1d0/stw**2*ctw**2*deltarhofer+1d0/stw**2*ctw**2*deltarho
     &   bos-1d0/ctw**4/qs*mw**4/mh**2-1d0/ctw**4*mw**2/mh**2+1d0/6/ctw**2
     &   /qs*mw**2+1d0/6/ctw**2-1d0/16/ctw**2*vmamo**2+1d0/8/ctw**2*vpamo*
     &   *2-1d0/2/ctw**2*vpamn*vpamo+3d0/16/ctw**2*vpamn**2+3d0/16/ctw**2*
     &   vpadn**2-1d0/2/ctw**2*vpaup*vpadn+3d0/16/ctw**2*vpaup**2+64d0/9/q
     &   s*mw**2-2/qs*mw**4/mh**2+caldwfer-za1fer-za1bos-2*mw**2/mh**2-2*q
     &   mo-3d0/2*qmo**2-2*qdn-3d0/2*qdn**2+2*qup+2*qup*qdn-3d0/2*qup**2+2
     &   *ctw**2*qmo+3d0/2*ctw**2*qmo**2+2*ctw**2*qdn+3d0/2*ctw**2*qdn**2-
     &   2*ctw**2*qup-2*ctw**2*qup*qdn+3d0/2*ctw**2*qup**2+3d0/8*invfmow

        ff_ew_ld =
     &   +mmo*(-1d0/4*sdet3icmoqs/ctw**2*vpamn*vpamo-1d0/2*sdet3icmoqs*vpa
     &   mo+1d0/2*sdet3icmoqs*vpamn-sdet3icmoqs*qmo+sdet3icmoqs*ctw**2*qmo
     &   +2*sdet3icmoqs**2*qmo*mw**2-2*sdet3icmoqs**2*ctw**2*qmo*mw**2)
     &   +mmo**3*(1d0/8*sdet3icmoqs/mw**2+1d0/8*sdet3icmoqs*vmamo/mw**2-1d
     &   0/8*sdet3icmoqs*vpamo/mw**2-8*sdet3icmoqs**2*qmo+8*sdet3icmoqs**2
     &   *ctw**2*qmo-6*sdet3icmoqs**3*qmo*mw**2+6*sdet3icmoqs**3*ctw**2*qm
     &   o*mw**2)
     &   +mmo**5*(6*sdet3icmoqs**3*qmo-6*sdet3icmoqs**3*ctw**2*qmo)
     &   +propiwqs*mmo*(-qdn*qmo/ts/us+ctw**2*qdn*qmo/ts/us-sdet3icmoqs*qd
     &   n*qmo/ts+sdet3icmoqs*qdn*qmo/us+sdet3icmoqs*ctw**2*qdn*qmo/ts-sde
     &   t3icmoqs*ctw**2*qdn*qmo/us+2*sdet3icmots*qdn*qmo/us-2*sdet3icmots
     &   *ctw**2*qdn*qmo/us)
     &   +propiwqs*d0ccmocqstswczmo*mmo*(1d0/4/ctw**6*vpadn*vpamo/qs/us*mw
     &   **4+1d0/4/ctw**6*vpadn*vpamo/us**2*mw**4-1d0/4/ctw**4*vpadn*vmamo
     &   /qs*mw**2-1d0/4/ctw**4*vpadn*vmamo/us*mw**2-1d0/4/ctw**4*vpadn*vp
     &   amo/qs/us*mw**4+1d0/4/ctw**4*vpadn*vpamo/qs*mw**2+1d0/2/ctw**4*vp
     &   adn*vpamo/us**2*mw**4+1d0/4/ctw**4*vpadn*vpamo/us*mw**2-1d0/2/ctw
     &   **4*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vmamo/qs*mw**2-
     &   1d0/4/ctw**2*vpadn*vmamo/us*mw**2+1d0/4/ctw**2*vpadn*vmamo*ts/us-
     &   1d0/4/ctw**2*vpadn*vpamo/qs*mw**2+1d0/4/ctw**2*vpadn*vpamo/us**2*
     &   mw**4-1d0/2/ctw**2*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*
     &   vpamo*ts**2/us**2)
     &   +propiwqs*d0ccmocqstswczmo*mmo**3*(1d0/4/ctw**6*vpadn*vpamo/qs/us
     &   **2*mw**4-1d0/4/ctw**4*vpadn*vmamo/qs/us*mw**2+1d0/4/ctw**4*vpadn
     &   *vpamo/qs/us*mw**2-1d0/2/ctw**4*vpadn*vpamo/us**2*mw**2+1d0/4/ctw
     &   **2*vpadn*vmamo/us+1d0/4/ctw**2*vpadn*vpamo/ts/us**2*mw**4-1d0/4/
     &   ctw**2*vpadn*vpamo/ts/us*mw**2-1d0/ctw**2*vpadn*vpamo/us**2*mw**2
     &   +1d0/4/ctw**2*vpadn*vpamo/us+3d0/4/ctw**2*vpadn*vpamo*ts/us**2)
     &   +propiwqs*d0ccmocqstswczmo*mmo**5*(-1d0/2/ctw**2*vpadn*vpamo/ts/u
     &   s**2*mw**2+1d0/4/ctw**2*vpadn*vpamo/ts/us+3d0/4/ctw**2*vpadn*vpam
     &   o/us**2)
     &   +propiwqs*d0ccmocqstswczmo*mmo**7*(1d0/4/ctw**2*vpadn*vpamo/ts/us
     &   **2)
     &   +propiwqs*d0ccmocqstszcwc*mmo*(1d0/4/ctw**6*vpaup*vpamn/us**2*mw*
     &   *4-1d0/4/ctw**4*vpaup*vpamn/qs/us*mw**4-1d0/4/ctw**4*vpaup*vpamn/
     &   qs*mw**2+1d0/2/ctw**4*vpaup*vpamn/us**2*mw**4-1d0/2/ctw**4*vpaup*
     &   vpamn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**4+1d0/4/c
     &   tw**2*vpaup*vpamn/qs*mw**2+1d0/4/ctw**2*vpaup*vpamn/us**2*mw**4+1
     &   d0/4/ctw**2*vpaup*vpamn/us*mw**2-1d0/2/ctw**2*vpaup*vpamn*ts/us**
     &   2*mw**2+1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2)
     &   +propiwqs*d0ccmocqstszcwc*mmo**3*(1d0/4/ctw**6*vpaup*vpamn/ts/us*
     &   *2*mw**4-1d0/2/ctw**4*vpaup*vpamn/us**2*mw**2+1d0/4/ctw**2*vpaup*
     &   vpamn/qs/us**2*mw**4+1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2+1d0/4/c
     &   tw**2*vpaup*vpamn*ts/us**2)
     &   +propiwqs*d0cccmoqsuszcwmo*mmo*(-1d0/4/ctw**4*vpaup*vmamo/qs*mw**
     &   2+1d0/4/ctw**4*vpaup*vmamo/ts*mw**2+1d0/4/ctw**2*vpaup*vmamo/qs*m
     &   w**2+1d0/4/ctw**2*vpaup*vmamo/ts*mw**2-1d0/4/ctw**2*vpaup*vmamo/t
     &   s*us)
     &   +propiwqs*d0cccmoqsuszcwmo*mmo**3*(1d0/4/ctw**2*vpaup*vmamo/qs/us
     &   *mw**2+1d0/4/ctw**2*vpaup*vmamo/ts/us*mw**2-1d0/2/ctw**2*vpaup*vm
     &   amo/ts)
     &   +propiwqs*d0cccmoqsuszcwmo*mmo**5*(-1d0/4/ctw**2*vpaup*vmamo/ts/u
     &   s)
     &   +propiwqs*c0mocqswcz*mmo*(1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2+1d
     &   0/4/ctw**2*vpaup*vpamn/us**2*mw**2-1d0/4/ctw**2*vpaup*vpamn*ts/us
     &   **2+1d0/4*sdet3icmoqs/ctw**4*vpaup*vpamn/ts*mw**2-1d0/4*sdet3icmo
     &   qs/ctw**4*vpaup*vpamn/us*mw**2)
     &   +propiwqs*c0mocqswcz*mmo**3*(1d0/4/ctw**2*vpaup*vpamn/qs/us**2*mw
     &   **2+1d0/4/ctw**2*vpaup*vpamn/qs/us)
     &   +propiwqs*c0mocqszmow*mmo*(1d0/4/ctw**4*vpadn*vpamo/us**2*mw**2-1
     &   d0/4/ctw**2*vpadn*vmamo/us+1d0/4/ctw**2*vpadn*vpamo/us**2*mw**2-1
     &   d0/4/ctw**2*vpadn*vpamo*ts/us**2+1d0/4/ctw**2*vpaup*vmamo/ts+1d0/
     &   4*sdet3icmoqs/ctw**2*vpadn*vpamo/ts*mw**2-1d0/4*sdet3icmoqs/ctw**
     &   2*vpadn*vpamo/us*mw**2)
     &   +propiwqs*c0mocqszmow*mmo**3*(1d0/4/ctw**4*vpadn*vpamo/qs/us**2*m
     &   w**2-1d0/4/ctw**2*vpadn*vmamo/qs/us+1d0/4/ctw**2*vpadn*vpamo/qs/u
     &   s-1d0/4/ctw**2*vpadn*vpamo/us**2+1d0/4/ctw**2*vpaup*vmamo/qs/us-1
     &   d0/4*sdet3icmoqs/ctw**2*vpadn*vpamo/ts+1d0/4*sdet3icmoqs/ctw**2*v
     &   padn*vpamo/us)
     &   +propiwqs*c0moctsmozc*mmo*(1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2-1
     &   d0/4/ctw**4*vpadn*vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vmamo/qs+1
     &   d0/4/ctw**2*vpadn*vmamo/us+1d0/4/ctw**2*vpadn*vpamo/qs-1d0/4/ctw*
     &   *2*vpadn*vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo/us+1d0/4/ctw*
     &   *2*vpadn*vpamo*ts/us**2+1d0/2*sdet3icmots/ctw**4*vpadn*vpamo/us*m
     &   w**2)
     &   +propiwqs*c0moctsmozc*mmo**3*(-1d0/4/ctw**2*vpadn*vpamo/ts/us**2*
     &   mw**2+1d0/2/ctw**2*vpadn*vpamo/us**2)
     &   +propiwqs*c0moctsmozc*mmo**5*(1d0/4/ctw**2*vpadn*vpamo/ts/us**2)
     &   +propiwqs*c0moctscwc*mmo*(-1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2+1
     &   d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2+1d0/4/ctw**2*vpaup*vpamn/qs-1
     &   d0/4/ctw**2*vpaup*vpamn/us**2*mw**2-1d0/4/ctw**2*vpaup*vpamn/us+1
     &   d0/4/ctw**2*vpaup*vpamn*ts/us**2+1d0/2*sdet3icmots/ctw**2*vpaup*v
     &   pamn/us*mw**2)
     &   +propiwqs*c0moctscwc*mmo**3*(-1d0/4/ctw**4*vpaup*vpamn/ts/us**2*m
     &   w**2+1d0/4/ctw**2*vpaup*vpamn/us**2)
     &   +propiwqs*c0mocusmozc*mmo*(-1d0/4/ctw**2*vpaup*vmamo/qs-1d0/4/ctw
     &   **2*vpaup*vmamo/ts)
     &   +propiwqs*c0mocusmozc*mmo**3*(-1d0/4/ctw**2*vpaup*vmamo/qs/us-1d0
     &   /4/ctw**2*vpaup*vmamo/ts/us)
     &   +propiwqs*c0ccqswcz*mmo*(1d0/4/ctw**4*vpadn*vpamo/us**2*mw**2+1d0
     &   /4/ctw**4*vpaup*vpamn/ts/us*mw**2+1d0/4/ctw**4*vpaup*vpamn/us**2*
     &   mw**2-1d0/4/ctw**2*vpadn*vmamo/us+1d0/4/ctw**2*vpadn*vpamo/ts/us*
     &   mw**2+1d0/4/ctw**2*vpadn*vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vpa
     &   mo*ts/us**2+1d0/4/ctw**2*vpaup*vmamo/ts+1d0/4/ctw**2*vpaup*vpamn/
     &   us**2*mw**2-1d0/4/ctw**2*vpaup*vpamn*ts/us**2)
     &   +propiwqs*c0ccqswcz*mmo**3*(1d0/4/ctw**4*vpaup*vpamn/ts/us**2*mw*
     &   *2+1d0/4/ctw**2*vpadn*vpamo/ts/us**2*mw**2-1d0/4/ctw**2*vpadn*vpa
     &   mo/ts/us-1d0/2/ctw**2*vpadn*vpamo/us**2+1d0/4/ctw**2*vpaup*vmamo/
     &   ts/us-1d0/4/ctw**2*vpaup*vpamn/us**2)
     &   +propiwqs*c0ccqswcz*mmo**5*(-1d0/4/ctw**2*vpadn*vpamo/ts/us**2)
     &   +propiwqs*c0cctscwmo*mmo*(-1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2-1
     &   d0/4/ctw**4*vpadn*vpamo/us**2*mw**2+1d0/4/ctw**2*vpadn*vmamo/qs+1
     &   d0/4/ctw**2*vpadn*vmamo/us-1d0/4/ctw**2*vpadn*vpamo/qs-1d0/4/ctw*
     &   *2*vpadn*vpamo/us**2*mw**2-1d0/4/ctw**2*vpadn*vpamo/us+1d0/4/ctw*
     &   *2*vpadn*vpamo*ts/us**2-qdn*qmo/us**2*mw**2+qdn*qmo*ts/us**2+ctw*
     &   *2*qdn*qmo/us**2*mw**2-ctw**2*qdn*qmo*ts/us**2)
     &   +propiwqs*c0cctscwmo*mmo**3*(-1d0/4/ctw**4*vpadn*vpamo/qs/us**2*m
     &   w**2+1d0/4/ctw**2*vpadn*vmamo/qs/us-1d0/4/ctw**2*vpadn*vpamo/qs/u
     &   s+1d0/4/ctw**2*vpadn*vpamo/us**2+qdn*qmo/us**2-ctw**2*qdn*qmo/us*
     &   *2)
     &   +propiwqs*c0cctsczc*mmo*(-1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2-1d
     &   0/4/ctw**2*vpaup*vpamn/qs/us*mw**2-1d0/4/ctw**2*vpaup*vpamn/qs-1d
     &   0/4/ctw**2*vpaup*vpamn/us**2*mw**2-1d0/4/ctw**2*vpaup*vpamn/us+1d
     &   0/4/ctw**2*vpaup*vpamn*ts/us**2)
     &   +propiwqs*c0cctsczc*mmo**3*(-1d0/4/ctw**2*vpaup*vpamn/qs/us**2*mw
     &   **2-1d0/4/ctw**2*vpaup*vpamn/qs/us)
     &   +propiwqs*c0ccuscwmo*mmo*(1d0/4/ctw**2*vpaup*vmamo/qs-1d0/4/ctw**
     &   2*vpaup*vmamo/ts+qup*qmo/qs-qup*qmo/ts-ctw**2*qup*qmo/qs+ctw**2*q
     &   up*qmo/ts)
     &   +propiwqs*a0fmo*mmo*(stw**2*qdn*qmo/ts/us+sdet3icmoqs*stw**2*qdn*
     &   qmo/ts-sdet3icmoqs*stw**2*qdn*qmo/us-2*sdet3icmots*stw**2*qdn*qmo
     &   /us)
     &   +propiwqs*b0fmowc*mmo*(-1d0/4/ctw**2*vpaup*vpamn/ts/us-1d0/4*sdet
     &   3icmoqs/ctw**2*vpaup*vpamn/ts+1d0/4*sdet3icmoqs/ctw**2*vpaup*vpam
     &   n/us+1d0/2*sdet3icmots/ctw**2*vpaup*vpamn/us)
     &   +propiwqs*b0fmozmo*mmo*(-1d0/4/ctw**2*vpadn*vpamo/ts/us-1d0/4*sde
     &   t3icmoqs/ctw**2*vpadn*vpamo/ts+1d0/4*sdet3icmoqs/ctw**2*vpadn*vpa
     &   mo/us+1d0/2*sdet3icmots/ctw**2*vpadn*vpamo/us)
     &   +propiwqs*b0fqswz*mmo*(1d0/4/ctw**2*vpadn*vpamo/ts/us+1d0/4/ctw**
     &   2*vpaup*vpamn/ts/us+1d0/4*sdet3icmoqs/ctw**2*vpadn*vpamo/ts-1d0/4
     &   *sdet3icmoqs/ctw**2*vpadn*vpamo/us+1d0/4*sdet3icmoqs/ctw**2*vpaup
     &   *vpamn/ts-1d0/4*sdet3icmoqs/ctw**2*vpaup*vpamn/us)
     &   +propiwqs*b0fqswc*mmo*(qdn*qmo/ts/us-ctw**2*qdn*qmo/ts/us+sdet3ic
     &   moqs*qdn*qmo/ts-sdet3icmoqs*qdn*qmo/us-sdet3icmoqs*ctw**2*qdn*qmo
     &   /ts+sdet3icmoqs*ctw**2*qdn*qmo/us)
     &   +propiwqs*b0ftsmoc*mmo*(-1d0/2*sdet3icmots/ctw**2*vpadn*vpamo/us-
     &   2*sdet3icmots*qdn*qmo/us+2*sdet3icmots*ctw**2*qdn*qmo/us)
     &   +propiwqs*b0ftscc*mmo*(-1d0/2*sdet3icmots/ctw**2*vpaup*vpamn/us)
     &   +javsubqstscmow*mmo*(-qdn*qmo/us**2*mw**4+qdn*qmo/us*mw**2+2*qdn*
     &   qmo*ts/us**2*mw**2-qdn*qmo*ts/us-qdn*qmo*ts**2/us**2+ctw**2*qdn*q
     &   mo/us**2*mw**4-ctw**2*qdn*qmo/us*mw**2-2*ctw**2*qdn*qmo*ts/us**2*
     &   mw**2+ctw**2*qdn*qmo*ts/us+ctw**2*qdn*qmo*ts**2/us**2)
     &   +javsubqstscmow*mmo**3*(-qdn*qmo/ts/us**2*mw**4+qdn*qmo/ts/us*mw*
     &   *2+4*qdn*qmo/us**2*mw**2-2*qdn*qmo/us-3*qdn*qmo*ts/us**2+ctw**2*q
     &   dn*qmo/ts/us**2*mw**4-ctw**2*qdn*qmo/ts/us*mw**2-4*ctw**2*qdn*qmo
     &   /us**2*mw**2+2*ctw**2*qdn*qmo/us+3*ctw**2*qdn*qmo*ts/us**2)
     &   +javsubqstscmow*mmo**5*(2*qdn*qmo/ts/us**2*mw**2-qdn*qmo/ts/us-3*
     &   qdn*qmo/us**2-2*ctw**2*qdn*qmo/ts/us**2*mw**2+ctw**2*qdn*qmo/ts/u
     &   s+3*ctw**2*qdn*qmo/us**2)
     &   +javsubqstscmow*mmo**7*(-qdn*qmo/ts/us**2+ctw**2*qdn*qmo/ts/us**2
     &   )
     &   +javsubqsuscmow*mmo*(-qup*qmo/qs*mw**2-qup*qmo/ts*mw**2+qup*qmo/t
     &   s*us+ctw**2*qup*qmo/qs*mw**2+ctw**2*qup*qmo/ts*mw**2-ctw**2*qup*q
     &   mo/ts*us)
     &   +javsubqsuscmow*mmo**3*(-qup*qmo/qs/us*mw**2-qup*qmo/ts/us*mw**2+
     &   2*qup*qmo/ts+ctw**2*qup*qmo/qs/us*mw**2+ctw**2*qup*qmo/ts/us*mw**
     &   2-2*ctw**2*qup*qmo/ts)
     &   +javsubqsuscmow*mmo**5*(qup*qmo/ts/us-ctw**2*qup*qmo/ts/us)
     &   +c0mocqswcz*mmo*(-1d0/2*sdet3icmoqs/ctw**2*vpamn*mw**2+sdet3icmoq
     &   s**2/ctw**4*vpamn*mw**4+2*sdet3icmoqs**2/ctw**2*vpamn*mw**4)
     &   +c0mocqswcz*mmo**3*(1d0/2*sdet3icmoqs/ctw**2*vpamn+sdet3icmoqs**2
     &   /ctw**4*vpamn*mw**2-2*sdet3icmoqs**2/ctw**2*vpamn*mw**2-3*sdet3ic
     &   moqs**3/ctw**4*vpamn*mw**4)
     &   +c0mocqszmow*mmo*(-2*sdet3icmoqs/ctw**2*vmamo*mw**2+1d0/2*sdet3ic
     &   moqs/ctw**2*vpamo*mw**2-sdet3icmoqs*vmamo*mw**2-2*sdet3icmoqs**2/
     &   ctw**2*vpamo*mw**4-sdet3icmoqs**2*vpamo*mw**4)
     &   +c0mocqszmow*mmo**3*(1d0/4*vmamo/mw**2-1d0/4*vpamo/mw**2+3d0/4*sd
     &   et3icmoqs/ctw**2*vmamo-1d0/4*sdet3icmoqs/ctw**2*vpamo+9d0/2*sdet3
     &   icmoqs*vmamo-1d0/2*sdet3icmoqs*vpamo+1d0/2*sdet3icmoqs**2/ctw**2*
     &   vmamo*mw**2+3d0/2*sdet3icmoqs**2/ctw**2*vpamo*mw**2+13d0/4*sdet3i
     &   cmoqs**2*vmamo*mw**2+19d0/4*sdet3icmoqs**2*vpamo*mw**2+3*sdet3icm
     &   oqs**3*vpamo*mw**4)
     &   +c0mocqszmow*mmo**5*(-5d0/4*sdet3icmoqs*vmamo/mw**2+5d0/4*sdet3ic
     &   moqs*vpamo/mw**2-1d0/2*sdet3icmoqs**2/ctw**2*vmamo+1d0/2*sdet3icm
     &   oqs**2/ctw**2*vpamo-5*sdet3icmoqs**2*vmamo-2*sdet3icmoqs**2*vpamo
     &   -3d0/4*sdet3icmoqs**3*vmamo*mw**2-21d0/4*sdet3icmoqs**3*vpamo*mw*
     &   *2)
     &   +c0mocqszmow*mmo**7*(7d0/4*sdet3icmoqs**2*vmamo/mw**2-7d0/4*sdet3
     &   icmoqs**2*vpamo/mw**2+3d0/2*sdet3icmoqs**3*vmamo+3d0/2*sdet3icmoq
     &   s**3*vpamo)
     &   +c0mocqszmow*mmo**9*(-3d0/4*sdet3icmoqs**3*vmamo/mw**2+3d0/4*sdet
     &   3icmoqs**3*vpamo/mw**2)
     &   +c0mocqshmow*mmo*(1d0/2*sdet3icmoqs*mh**2)
     &   +c0mocqshmow*mmo**3*(-1d0/4/mw**2-sdet3icmoqs-1d0/4*sdet3icmoqs/m
     &   w**2*mh**2+1d0/2*sdet3icmoqs**2*mh**2-3d0/4*sdet3icmoqs**2*mw**2)
     &
     &   +c0mocqshmow*mmo**5*(1d0/4*sdet3icmoqs/mw**2-1d0/2*sdet3icmoqs**2
     &   /mw**2*mh**2-3d0/4*sdet3icmoqs**3*mw**2)
     &   +c0mocqshmow*mmo**7*(3d0/4*sdet3icmoqs**2/mw**2+3d0/2*sdet3icmoqs
     &   **3)
     &   +c0mocqshmow*mmo**9*(-3d0/4*sdet3icmoqs**3/mw**2)
     &   +c0mocqsmozc*mmo*(1d0/2/ctw**2*vpamn*vmamo-1d0/2/ctw**2*vpamn*vpa
     &   mo-sdet3icmoqs/ctw**4*vpamn*vmamo*mw**2+2*sdet3icmoqs/ctw**4*vpam
     &   n*vpamo*mw**2-3d0/2*sdet3icmoqs**2/ctw**6*vpamn*vpamo*mw**4)
     &   +c0mocqsmozc*mmo**3*(sdet3icmoqs**2/ctw**4*vpamn*vmamo*mw**2-sdet
     &   3icmoqs**2/ctw**4*vpamn*vpamo*mw**2+3d0/2*sdet3icmoqs**3/ctw**6*v
     &   pamn*vpamo*mw**4)
     &   +c0mocqscmow*mmo*(-stw**2*qdn/ts*mw**2+2*sdet3icmoqs*stw**2*mw**2
     &   -sdet3icmoqs*stw**2*qdn/ts*mw**4+sdet3icmoqs*stw**2*qdn/us*mw**4+
     &   2*sdet3icmoqs**2*stw**2*mw**4+sdet3icmots*stw**2*qdn/us*mw**4-sde
     &   t3icmots*stw**2*qdn*mw**2)
     &   +c0mocqscmow*mmo**3*(-stw**2/qs/us*mw**2-stw**2/us-stw**2*qdn/qs/
     &   us*mw**2+stw**2*qdn/ts-stw**2*qdn/us-8*sdet3icmoqs*stw**2+2*sdet3
     &   icmoqs*stw**2*qdn/ts*mw**2-2*sdet3icmoqs*stw**2*qdn/us*mw**2-16*s
     &   det3icmoqs**2*stw**2*mw**2-6*sdet3icmoqs**3*stw**2*mw**4+sdet3icm
     &   ots*stw**2*qdn/ts/us*mw**4-sdet3icmots*stw**2*qdn/ts*mw**2-2*sdet
     &   3icmots*stw**2*qdn/us*mw**2+sdet3icmots*stw**2*qdn-sdet3icmous*st
     &   w**2/qs*mw**2-sdet3icmous*stw**2-sdet3icmous*stw**2*qdn/qs*mw**2-
     &   sdet3icmous*stw**2*qdn)
     &   +c0mocqscmow*mmo**5*(-sdet3icmoqs*stw**2*qdn/ts+sdet3icmoqs*stw**
     &   2*qdn/us+14*sdet3icmoqs**2*stw**2+12*sdet3icmoqs**3*stw**2*mw**2-
     &   2*sdet3icmots*stw**2*qdn/ts/us*mw**2+sdet3icmots*stw**2*qdn/ts+sd
     &   et3icmots*stw**2*qdn/us-sdet3icmous*stw**2/qs/us*mw**2-sdet3icmou
     &   s*stw**2/us-sdet3icmous*stw**2*qdn/qs/us*mw**2-sdet3icmous*stw**2
     &   *qdn/us)
     &   +c0mocqscmow*mmo**7*(-6*sdet3icmoqs**3*stw**2+sdet3icmots*stw**2*
     &   qdn/ts/us)
     &   +c0cctscwmo*mmo*(-qdn*qmo/us**2*mw**4+qdn*qmo/us*mw**2+2*qdn*qmo*
     &   ts/us**2*mw**2-qdn*qmo*ts/us-qdn*qmo*ts**2/us**2+ctw**2*qdn*qmo/u
     &   s**2*mw**4-ctw**2*qdn*qmo/us*mw**2-2*ctw**2*qdn*qmo*ts/us**2*mw**
     &   2+ctw**2*qdn*qmo*ts/us+ctw**2*qdn*qmo*ts**2/us**2)
     &   +c0cctscwmo*mmo**3*(-qdn*qmo/ts/us**2*mw**4+qdn*qmo/ts/us*mw**2+4
     &   *qdn*qmo/us**2*mw**2-2*qdn*qmo/us-3*qdn*qmo*ts/us**2+ctw**2*qdn*q
     &   mo/ts/us**2*mw**4-ctw**2*qdn*qmo/ts/us*mw**2-4*ctw**2*qdn*qmo/us*
     &   *2*mw**2+2*ctw**2*qdn*qmo/us+3*ctw**2*qdn*qmo*ts/us**2)
     &   +c0cctscwmo*mmo**5*(2*qdn*qmo/ts/us**2*mw**2-qdn*qmo/ts/us-3*qdn*
     &   qmo/us**2-2*ctw**2*qdn*qmo/ts/us**2*mw**2+ctw**2*qdn*qmo/ts/us+3*
     &   ctw**2*qdn*qmo/us**2)
     &   +c0cctscwmo*mmo**7*(-qdn*qmo/ts/us**2+ctw**2*qdn*qmo/ts/us**2)
     &   +c0ccuscwmo*mmo*(-qup*qmo/qs*mw**2-qup*qmo/ts*mw**2+qup*qmo/ts*us
     &   +ctw**2*qup*qmo/qs*mw**2+ctw**2*qup*qmo/ts*mw**2-ctw**2*qup*qmo/t
     &   s*us)
     &   +c0ccuscwmo*mmo**3*(-qup*qmo/qs/us*mw**2-qup*qmo/ts/us*mw**2+2*qu
     &   p*qmo/ts+ctw**2*qup*qmo/qs/us*mw**2+ctw**2*qup*qmo/ts/us*mw**2-2*
     &   ctw**2*qup*qmo/ts)
     &   +c0ccuscwmo*mmo**5*(qup*qmo/ts/us-ctw**2*qup*qmo/ts/us)
     &   +a0fw/mmo*(-1d0/2*sdet3icmoqs*vpamn*mw**2)
     &   +a0fw*mmo*(1d0/4*sdet3icmoqs-1d0/4*sdet3icmoqs*vmamo+1d0/4*sdet3i
     &   cmoqs*vpamo-3d0/2*sdet3icmoqs**2*vpamo*mw**2-3*sdet3icmoqs**2*qmo
     &   *mw**2+3*sdet3icmoqs**2*ctw**2*qmo*mw**2+1d0/4*sdet3icmoqs*invfmo
     &   w-5d0/4*sdet3icmoqs*invfmow*vmamo+1d0/4*sdet3icmoqs*invfmow*vpamo
     &   -2*sdet3icmoqs*invfmow*qmo+2*sdet3icmoqs*invfmow*ctw**2*qmo)
     &   +a0fw*mmo**3*(3d0/8*sdet3icmoqs**2+3d0/8*sdet3icmoqs**2*vmamo-3d0
     &   /8*sdet3icmoqs**2*vpamo)
     &   +a0fz/mmo*(-1d0/4*sdet3icmoqs/ctw**4*vpamn*vpamo*mw**2+1d0/2*sdet
     &   3icmoqs/ctw**2*vpamo*mw**2)
     &   +a0fz*mmo*(-1d0/8*sdet3icmoqs/ctw**2*vmamo+1d0/8*sdet3icmoqs/ctw*
     &   *2*vpamo-1d0/2*sdet3icmoqs/ctw**2*vpamn+1d0/2*sdet3icmoqs/ctw**2*
     &   vpamn*vmamo-1d0/2*sdet3icmoqs/ctw**2*vpamn*vpamo+3d0/4*sdet3icmoq
     &   s**2/ctw**4*vpamn*vpamo*mw**2+3d0/2*sdet3icmoqs**2/ctw**2*vpamn*m
     &   w**2)
     &   +a0fh*mmo*(-1d0/8*sdet3icmoqs/mw**2*mh**2)
     &   +a0fmo*mmo*(1d0/4*sdet3icmoqs/ctw**2*vpamn*vpamo-1d0/2*sdet3icmoq
     &   s*vpamo-sdet3icmoqs*stw**2*qmo-2*sdet3icmoqs**2*stw**2*qmo*mw**2)
     &
     &   +a0fmo*mmo**3*(-1d0/8*sdet3icmoqs/mw**2+3d0/8*sdet3icmoqs*vmamo/m
     &   w**2-3d0/8*sdet3icmoqs*vpamo/mw**2+3d0/2*sdet3icmoqs**2*vpamo+11*
     &   sdet3icmoqs**2*stw**2*qmo+6*sdet3icmoqs**3*stw**2*qmo*mw**2-1d0/4
     &   *sdet3icmoqs*invfmow/mw**2+5d0/4*sdet3icmoqs*invfmow*vmamo/mw**2-
     &   1d0/4*sdet3icmoqs*invfmow*vpamo/mw**2+2*sdet3icmoqs*invfmow*stw**
     &   2*qmo/mw**2)
     &   +a0fmo*mmo**5*(-3d0/8*sdet3icmoqs**2/mw**2-3d0/8*sdet3icmoqs**2*v
     &   mamo/mw**2+3d0/8*sdet3icmoqs**2*vpamo/mw**2-6*sdet3icmoqs**3*stw*
     &   *2*qmo)
     &   +b0fmowc/mmo*(-1d0/2*sdet3icmoqs*vpamn*mw**2)
     &   +b0fmowc*mmo*(1d0/2*sdet3icmoqs*vpamn-sdet3icmoqs**2/ctw**2*vpamn
     &   *mw**2-1d0/2*sdet3icmoqs**2*vpamn*mw**2)
     &   +b0fmowc*mmo**3*(-sdet3icmoqs**2/ctw**2*vpamn+1d0/2*sdet3icmoqs**
     &   2*vpamn+3*sdet3icmoqs**3/ctw**2*vpamn*mw**2)
     &   +b0fmozmo/mmo*(-1d0/4*sdet3icmoqs/ctw**4*vpamn*vpamo*mw**2+1d0/2*
     &   sdet3icmoqs/ctw**2*vpamo*mw**2)
     &   +b0fmozmo*mmo*(3d0/8*sdet3icmoqs/ctw**2*vmamo+1d0/8*sdet3icmoqs/c
     &   tw**2*vpamo-1d0/2*sdet3icmoqs/ctw**2*vpamn*vmamo+sdet3icmoqs/ctw*
     &   *2*vpamn*vpamo+sdet3icmoqs*vmamo-sdet3icmoqs*vpamo-3d0/4*sdet3icm
     &   oqs**2/ctw**4*vpamn*vpamo*mw**2+1d0/2*sdet3icmoqs**2/ctw**2*vpamo
     &   *mw**2+sdet3icmoqs**2*vpamo*mw**2)
     &   +b0fmozmo*mmo**3*(-1d0/4*sdet3icmoqs*vmamo/mw**2+1d0/4*sdet3icmoq
     &   s*vpamo/mw**2-1d0/8*sdet3icmoqs**2/ctw**2*vmamo+1d0/8*sdet3icmoqs
     &   **2/ctw**2*vpamo+sdet3icmoqs**2/ctw**2*vpamn*vmamo-sdet3icmoqs**2
     &   /ctw**2*vpamn*vpamo-13d0/4*sdet3icmoqs**2*vmamo-3d0/4*sdet3icmoqs
     &   **2*vpamo+3d0/2*sdet3icmoqs**3/ctw**4*vpamn*vpamo*mw**2-3*sdet3ic
     &   moqs**3*vpamo*mw**2)
     &   +b0fmozmo*mmo**5*(sdet3icmoqs**2*vmamo/mw**2-sdet3icmoqs**2*vpamo
     &   /mw**2+3d0/4*sdet3icmoqs**3*vmamo+9d0/4*sdet3icmoqs**3*vpamo)
     &   +b0fmozmo*mmo**7*(-3d0/4*sdet3icmoqs**3*vmamo/mw**2+3d0/4*sdet3ic
     &   moqs**3*vpamo/mw**2)
     &   +b0fmohmo*mmo*(-1d0/8*sdet3icmoqs/mw**2*mh**2)
     &   +b0fmohmo*mmo**3*(1d0/4*sdet3icmoqs/mw**2+3d0/4*sdet3icmoqs**2-1d
     &   0/8*sdet3icmoqs**2/mw**2*mh**2)
     &   +b0fmohmo*mmo**5*(3d0/4*sdet3icmoqs**3)
     &   +b0fmohmo*mmo**7*(-3d0/4*sdet3icmoqs**3/mw**2)
     &   +b0fqswz*mmo*(-1d0/2*sdet3icmoqs/ctw**2*vmamo-1d0/2*sdet3icmoqs/c
     &   tw**2*vpamn-5d0/2*sdet3icmoqs*vmamo+sdet3icmoqs*vpamo-1d0/2*sdet3
     &   icmoqs*vpamn-1d0/2*sdet3icmoqs**2/ctw**2*vpamo*mw**2+5d0/2*sdet3i
     &   cmoqs**2/ctw**2*vpamn*mw**2-5d0/2*sdet3icmoqs**2*vpamo*mw**2+1d0/
     &   2*sdet3icmoqs**2*vpamn*mw**2)
     &   +b0fqswz*mmo**3*(5d0/8*sdet3icmoqs*vmamo/mw**2-5d0/8*sdet3icmoqs*
     &   vpamo/mw**2+1d0/8*sdet3icmoqs**2/ctw**2*vmamo-1d0/8*sdet3icmoqs**
     &   2/ctw**2*vpamo+sdet3icmoqs**2/ctw**2*vpamn+29d0/8*sdet3icmoqs**2*
     &   vmamo+15d0/8*sdet3icmoqs**2*vpamo-1d0/2*sdet3icmoqs**2*vpamn-3*sd
     &   et3icmoqs**3/ctw**2*vpamn*mw**2+3*sdet3icmoqs**3*vpamo*mw**2)
     &   +b0fqswz*mmo**5*(-11d0/8*sdet3icmoqs**2*vmamo/mw**2+11d0/8*sdet3i
     &   cmoqs**2*vpamo/mw**2-3d0/4*sdet3icmoqs**3*vmamo-9d0/4*sdet3icmoqs
     &   **3*vpamo)
     &   +b0fqswz*mmo**7*(3d0/4*sdet3icmoqs**3*vmamo/mw**2-3d0/4*sdet3icmo
     &   qs**3*vpamo/mw**2)
     &   +b0fqswh*mmo*(1d0/2*sdet3icmoqs)
     &   +b0fqswh*mmo**3*(-3d0/8*sdet3icmoqs/mw**2-3d0/8*sdet3icmoqs**2+1d
     &   0/8*sdet3icmoqs**2/mw**2*mh**2)
     &   +b0fqswh*mmo**5*(-3d0/8*sdet3icmoqs**2/mw**2-3d0/4*sdet3icmoqs**3
     &   )
     &   +b0fqswh*mmo**7*(3d0/4*sdet3icmoqs**3/mw**2)
     &   +b0fqswc*mmo*(-3*sdet3icmoqs*qmo+3*sdet3icmoqs*ctw**2*qmo-5*sdet3
     &   icmoqs**2*qmo*mw**2+5*sdet3icmoqs**2*ctw**2*qmo*mw**2)
     &   +b0fqswc*mmo**3*(11*sdet3icmoqs**2*qmo-11*sdet3icmoqs**2*ctw**2*q
     &   mo+6*sdet3icmoqs**3*qmo*mw**2-6*sdet3icmoqs**3*ctw**2*qmo*mw**2)
     &   +b0fqswc*mmo**5*(-6*sdet3icmoqs**3*qmo+6*sdet3icmoqs**3*ctw**2*qm
     &   o)
     &   +b0fqsmoc*mmo*(sdet3icmoqs/ctw**2*vpamn*vmamo-5d0/4*sdet3icmoqs/c
     &   tw**2*vpamn*vpamo+3d0/2*sdet3icmoqs**2/ctw**4*vpamn*vpamo*mw**2)
     &   +b0fqsmoc*mmo**3*(-sdet3icmoqs**2/ctw**2*vpamn*vmamo+sdet3icmoqs*
     &   *2/ctw**2*vpamn*vpamo-3d0/2*sdet3icmoqs**3/ctw**4*vpamn*vpamo*mw*
     &   *2)

        ff_ew_rd =
     &   0

        ffarray(1,1) = ff_ew_ll
        ffarray(1,2) = ff_ew_ld
        ffarray(1,3) = ff_ew_rd

        return
      end
