************************************************************************
* sanc_nc_v1.30 package.
************************************************************************
* File (nc_si_1414_2020.f) is created on Wed Apr 18 13:09:52 MSK 2012.
************************************************************************
* This is the FORTRAN module (nc_si_1414_2020) to calculate EW
* cross-section (width) by using the helicity amplitudes
* for the anti-up + up -> mo^+ + mo^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2012.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_si_1414_2020_fs (s,t,u,sigma)
        implicit none!
        include 's2n_declare.h'

        real*8 sq,s1,sq1
        real*8 self0,born0,born1,delta0
        complex*16 mz2_

        qs = -s
        ts = -t
        us = -u
        sq = sqrt(s)

        s1 = s
        if (abs(sq-mz).le.1d-7) then
          if (sq.le.mz) sq1 = (mz-1d-7)
          if (sq.ge.mz) sq1 = (mz+1d-7)
          s1 = sq1**2
        endif

        mz2_  = mz2
        mz2   = dcmplx(rzm2,0d0)
        call nc_si_1414_2020 (s1,t,u,self0)
        call nc_br_1414_2020 (-s1,ts,us,born0,soft,hard)

        delta0 = self0/born0

        mz2   = mz2_
        call nc_br_1414_2020 (qs,ts,us,born1,soft,hard)

        sigma = delta0*born1

        return
      end
