#include "Info.h"
#include "Settings.h"

using namespace SANC;

Info::Info(Settings &_cfg)
    : Pid(_cfg.get_i("pid")), LamMinus(_cfg.get_d("lamem")), LamPlus(_cfg.get_d("lamep")),
      Scheme(_cfg.get_i("gfscheme")), Ecm(_cfg.get_d("ecm")), Ome(_cfg.get_d("ome")),
      DeltaLL(_cfg.get_d("deltall")), ScaleLL(_cfg.get_d("scalell")), Alphai(_cfg.get_d("alphai")),
      AlphaMZi(_cfg.get_d("alphamzi")), Alphas(_cfg.get_d("alphas")), GF(_cfg.get_d("gf")),
      PDFname(_cfg.get_s("pdfname")), PDFmember(_cfg.get_i("pdfmember")),
      Conhc(_cfg.get_d("conhc")), Alr(_cfg.get_i("alr")), Iborn(_cfg.get_i("iborn")),
      IgmZ(_cfg.get_i("igmz")), Iqed(_cfg.get_i("iqed")), Iqedlli(_cfg.get_i("iqedlli")),
      Iqedllf(_cfg.get_i("iqedllf")), Iew(_cfg.get_i("iew")), Ilin(_cfg.get_i("ilin")),
      Ifgg(_cfg.get_i("ifgg")), Irun(_cfg.get_i("irun")), Ibeams(_cfg.get_i("ibeams")),
      Iafb(_cfg.get_i("iafb")), Iach(_cfg.get_i("iach")), Icuts(_cfg.get_i("icuts")),
      Iscale(_cfg.get_i("iscale")), Iqcd(_cfg.get_i("iqcd")), Ifs(_cfg.get_i("ifs")),
      Iho(_cfg.get_i("iho")), Its(_cfg.get_i("its")), Imsb(_cfg.get_i("imsb")),
      Iph(_cfg.get_i("iph")), ForceOffH(_cfg.get_b("forceOffH")),
      ForceOffSV(_cfg.get_b("forceOffSV")), Men(_cfg.get_d("men")), Mel(_cfg.get_d("mel")),
      Mup(_cfg.get_d("mup")), Mdn(_cfg.get_d("mdn")), Mmn(_cfg.get_d("mmn")),
      Mmo(_cfg.get_d("mmo")), Mch(_cfg.get_d("mch")), Mst(_cfg.get_d("mst")),
      Mtn(_cfg.get_d("mtn")), Mta(_cfg.get_d("mta")), Mtp(_cfg.get_d("mtp")),
      Mbt(_cfg.get_d("mbt")), MW(_cfg.get_d("mw")), MZ(_cfg.get_d("mz")), MH(_cfg.get_d("mh")),
      Wz(_cfg.get_d("wz")), Ww(_cfg.get_d("ww")), Wh(_cfg.get_d("wh")), Wtp(_cfg.get_d("wtp")),
      Vud(_cfg.get_d("vud")), Vus(_cfg.get_d("vus")), Vcd(_cfg.get_d("vcd")),
      Vcs(_cfg.get_d("vcs")), Vcb(_cfg.get_d("vcb")), Vub(_cfg.get_d("vub")),
      CutMinCth(-_cfg.get_d("costhcut")), CutMaxCth(_cfg.get_d("costhcut")),
      CutMinTheta(_cfg.get_d("thetacut")), CutMaxTheta(180. - _cfg.get_d("thetacut")),
      // CutMinM34(0.),
      // CutMaxM34(Ecm),
      // CutMinPt(0.),
      // CutMaxPt(Ecm),
      CutMaxPhotonE(_cfg.get_d("e5max")), eta3cut(_cfg.get_b("eta3cut")),
      eta3min(_cfg.get_d("eta3min")), eta3max(_cfg.get_d("eta3max")),
      eta4cut(_cfg.get_b("eta4cut")), eta4min(_cfg.get_d("eta4min")),
      eta4max(_cfg.get_d("eta4max")), pt3cut(_cfg.get_b("pt3cut")), pt3min(_cfg.get_d("pt3min")),
      pt3max(_cfg.get_d("pt3max")), pt4cut(_cfg.get_b("pt4cut")), pt4min(_cfg.get_d("pt4min")),
      pt4max(_cfg.get_d("pt4max")), m34cut(_cfg.get_b("m34cut")), m34min(_cfg.get_d("m34min")),
      m34max(_cfg.get_d("m34max")), mt34cut(_cfg.get_b("mt34cut")), mt34min(_cfg.get_d("mt34min")),
      mt34max(_cfg.get_d("mt34max")), y34cut(_cfg.get_b("y34cut")), y34min(_cfg.get_d("y34min")),
      y34max(_cfg.get_d("y34max")), xmin(_cfg.get_d("xmin")), xmax(_cfg.get_d("xmax")),
      RanSeed(_cfg.get_l("RanSeed")), NevBorn(_cfg.get_l("NevBorn")),
      NevVirt(_cfg.get_l("NevVirt")), NevHard(_cfg.get_l("NevHard")),
      NevLL11(_cfg.get_l("NevLL11")), NevLL22(_cfg.get_l("NevLL22")),
      NevLL12(_cfg.get_l("NevLL12")), NevBrdq(_cfg.get_l("NevBrdq")),
      NevIbaa(_cfg.get_l("NevIbaa")), NevIbaq(_cfg.get_l("NevIbaq")),
      NevIbs1(_cfg.get_l("NevIbs1")), NevIbs2(_cfg.get_l("NevIbs2")), NevTot(_cfg.get_l("NevTot")),
      nCellsBorn(_cfg.get_i("nCellsBorn")), nSamplBorn(_cfg.get_i("nSamplBorn")),
      nBinBorn(_cfg.get_i("nBinBorn")), EvPerBinBorn(_cfg.get_i("EvPerBinBorn")),
      MaxWtRejBorn(_cfg.get_d("MaxWtRejBorn")), nCellsVirt(_cfg.get_i("nCellsVirt")),
      nSamplVirt(_cfg.get_i("nSamplVirt")), nBinVirt(_cfg.get_i("nBinVirt")),
      EvPerBinVirt(_cfg.get_i("EvPerBinVirt")), MaxWtRejVirt(_cfg.get_d("MaxWtRejVirt")),
      nCellsHard(_cfg.get_i("nCellsHard")), nSamplHard(_cfg.get_i("nSamplHard")),
      nBinHard(_cfg.get_i("nBinHard")), EvPerBinHard(_cfg.get_i("EvPerBinHard")),
      MaxWtRejHard(_cfg.get_d("MaxWtRejHard")), nCellsLL11(_cfg.get_i("nCellsLL11")),
      nSamplLL11(_cfg.get_i("nSamplLL11")), nBinLL11(_cfg.get_i("nBinLL11")),
      EvPerBinLL11(_cfg.get_i("EvPerBinLL11")), MaxWtRejLL11(_cfg.get_d("MaxWtRejLL11")),
      nCellsLL22(_cfg.get_i("nCellsLL22")), nSamplLL22(_cfg.get_i("nSamplLL22")),
      nBinLL22(_cfg.get_i("nBinLL22")), EvPerBinLL22(_cfg.get_i("EvPerBinLL22")),
      MaxWtRejLL22(_cfg.get_d("MaxWtRejLL22")), nCellsLL12(_cfg.get_i("nCellsLL12")),
      nSamplLL12(_cfg.get_i("nSamplLL12")), nBinLL12(_cfg.get_i("nBinLL12")),
      EvPerBinLL12(_cfg.get_i("EvPerBinLL12")), MaxWtRejLL12(_cfg.get_d("MaxWtRejLL12")),
      kDimBrdq(_cfg.get_i("kDimBrdq")), nCellsBrdq(_cfg.get_i("nCellsBrdq")),
      nSamplBrdq(_cfg.get_i("nSamplBrdq")), nBinBrdq(_cfg.get_i("nBinBrdq")),
      EvPerBinBrdq(_cfg.get_i("EvPerBinBrdq")), MaxWtRejBrdq(_cfg.get_d("MaxWtRejBrdq")),
      kDimIbaa(_cfg.get_i("kDimIbaa")), nCellsIbaa(_cfg.get_i("nCellsIbaa")),
      nSamplIbaa(_cfg.get_i("nSamplIbaa")), nBinIbaa(_cfg.get_i("nBinIbaa")),
      EvPerBinIbaa(_cfg.get_i("EvPerBinIbaa")), MaxWtRejIbaa(_cfg.get_d("MaxWtRejIbaa")),
      kDimIbaq(_cfg.get_i("kDimIbaq")), nCellsIbaq(_cfg.get_i("nCellsIbaq")),
      nSamplIbaq(_cfg.get_i("nSamplIbaq")), nBinIbaq(_cfg.get_i("nBinIbaq")),
      EvPerBinIbaq(_cfg.get_i("EvPerBinIbaq")), MaxWtRejIbaq(_cfg.get_d("MaxWtRejIbaq")),
      kDimIbs1(_cfg.get_i("kDimIbs1")), nCellsIbs1(_cfg.get_i("nCellsIbs1")),
      nSamplIbs1(_cfg.get_i("nSamplIbs1")), nBinIbs1(_cfg.get_i("nBinIbs1")),
      EvPerBinIbs1(_cfg.get_i("EvPerBinIbs1")), MaxWtRejIbs1(_cfg.get_d("MaxWtRejIbs1")),
      kDimIbs2(_cfg.get_i("kDimIbs2")), nCellsIbs2(_cfg.get_i("nCellsIbs2")),
      nSamplIbs2(_cfg.get_i("nSamplIbs2")), nBinIbs2(_cfg.get_i("nBinIbs2")),
      EvPerBinIbs2(_cfg.get_i("EvPerBinIbs2")), MaxWtRejIbs2(_cfg.get_d("MaxWtRejIbs2")),
      OptRej(_cfg.get_i("OptRej")), OptDrive(_cfg.get_i("OptDrive")), Chat(_cfg.get_i("Chat")),
      IEXPLBORN(_cfg.get_b("exploreBorn")), IEXPLVIRT(_cfg.get_b("exploreVirt")),
      IEXPLHARD(_cfg.get_b("exploreHard")), IEXPLLLI11(_cfg.get_b("exploreLLI11")),
      IEXPLLLI22(_cfg.get_b("exploreLLI22")), IEXPLLLI12(_cfg.get_b("exploreLLI12")),
      IEXPLLLF11(_cfg.get_b("exploreLLF11")), IEXPLLLF22(_cfg.get_b("exploreLLF22")),
      IEXPLLLF12(_cfg.get_b("exploreLLF12")), IEXPLBRDQ(_cfg.get_b("exploreBrdq")),
      IEXPLIBAA(_cfg.get_b("exploreIbaa")), IEXPLIBAQ(_cfg.get_b("exploreIbaq")),
      IEXPLIBS1(_cfg.get_b("exploreIbs1")), IEXPLIBS2(_cfg.get_b("exploreIbs2")),
      PrintLHE(_cfg.get_b("printLHE")), PrintROOT(_cfg.get_b("printROOT")),
      PrintHard(_cfg.get_b("printHard")), PrintDEBUG(_cfg.get_b("printDEBUG")),
      kDimBorn(_cfg.get_i("kDimBorn")), kDimVirt(_cfg.get_i("kDimVirt")),
      kDimHard(_cfg.get_i("kDimHard")), verMajor(1), verMinor(3), verPatch(8), cfg(_cfg) {
  outputDir = cfg.get_s("outputDir");
  Ecm = cfg.get_d("ecm");
  EA = cfg.get_d("ea");
  EB = cfg.get_d("eb");
  if ((Ecm > 0.) && ((EA > 0.) || (EB > 0.))) {
    std::cerr << "Error in configuration! Conflicting parameters are set:\n";
    std::cerr << "ecm, ea, eb\n";
    std::cerr << "Please, set only {ecm} or {ea and/or eb}" << std::endl;
    exit(1);
  }
  // CutMinM34 = 0.;
  // CutMaxM34 = Ecm;
  // CutMinPt = 0.;
  // CutMaxPt = Ecm;
  Sigma = 0.;
  SigmaErr = 0.;
}

std::string Info::version() {
  return std::to_string(verMajor) + "." + std::to_string(verMinor) + "." + std::to_string(verPatch);
}

void Info::init() { Ecm = cfg.get_d("ecm"); }
