************************************************************************
* sanc_nc_v1.30 package.
************************************************************************
* File (nc_ff_1313_2020.F) is created on Wed Apr 18 13:08:18 MSK 2012.
************************************************************************
* This is the FORTRAN module (nc_ff_1313_2020) to calculate 1-loop EW
* form factors for the anti-up + up -> ta^+ + ta^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2012.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ff_1313_2020 (qs,ts,us)
        implicit none!
#include "looptools.h"
#include "s2n_declare.h"

        complex*16 ff_qed_ll,ff_qed_lq,ff_qed_ql,ff_qed_qq,ff_qed_ld
        complex*16 ff_qed_qd,ff_ew_ll,ff_ew_ld,ff_ew_lq,ff_ew_ql,ff_ew_qq
        complex*16 ff_ew_qd,ff_qed_gg
        real*8 isr,ifi,fsr

        real*8 det3itataqs
        real*8 a0fta,a0fup,a0fw,a0fz,a0fh
        real*8 lnlatam,lnlaupm
        complex*16 b0ptazta,b0ptahta,b0ptacw
        complex*16 b0fqstata,b0ftazta,b0ftatac,b0ftstac,b0fustac,b0fqszc,
     &   b0fqscc,b0ftawc,b0ftahta,b0fqsww,b0fqszh,b0fqszz
        complex*16 c0ctatsczta,c0ctausczta,c0tataqsztac,c0tataqsctac,c0up
     &   upqszupc,c0upupqscupc,c0irtataqs,c0iruptats,c0iruptaus,c0irupupqs
     &   ,c0irtaupts,c0irtaupus,c0tataqswcw,c0tataqsztah,c0tataqstazta,c0t
     &   ataqstahta,c0tataqscwc,c0tataqsztaz,c0ccqszcz,c0ccqswcw,c0ccqscwc
     &   ,c0ccqsczc
        complex*16 b0d1tataz
        complex*16 b0dwtacw
        complex*16 d0cctataqstszczta,d0cctataqsuszczta,d0cctataqsuswcwc
        complex*16 jaaqstsupta,jaaqsusupta,javqstsuptaz,javqsusuptaz
        real*8 sdet3ictats,sdet3ictaus,sdet4itatsus,sdet3itataqs
        real*8 sdet3ctats,sdet3ctaus
        real*8 pxx2zqsc
        complex*16 propzqs,propizqs,prop1zqs

        common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
        common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     &   zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
        common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

        if (iqed.eq.1) then
          isr = 1d0
          ifi = 1d0
          fsr = 1d0
        elseif(iqed.eq.2) then
          isr = 1d0
          ifi = 0d0
          fsr = 0d0
        elseif(iqed.eq.3) then
          isr = 0d0
          ifi = 1d0
          fsr = 0d0
        elseif(iqed.eq.4) then
          isr = 0d0
          ifi = 0d0
          fsr = 1d0
        elseif(iqed.eq.5) then
          isr = 0d0
          ifi = 1d0
          fsr = 1d0
        elseif(iqed.eq.6) then
          isr = 1d0
          ifi = 1d0
          fsr = 0d0
        else
          isr = 0d0
          ifi = 0d0
          fsr = 0d0
        endif

        cmz2 = mz2

        if (irun.eq.0) then
          prop1zqs = (cmz2+qs)
        else
          prop1zqs = (dcmplx(mz**2,qs*wz/mz)+qs)
        endif
        propizqs = (rzm2+qs)
        propzqs = 1d0/propizqs
        det3itataqs = 1d0/(-1d0/4d0*((-rtam2)**2+(-rtam2)**2+(qs)**2
     &   -2d0*(-rtam2)*(-rtam2)-2d0*(-rtam2)*(qs)
     &   -2d0*(-rtam2)*(qs)))
        a0fta = log(rtam2/thmu2) - 1d0
        a0fup = log(rupm2/thmu2) - 1d0
        a0fw = log(rwm2/thmu2) - 1d0
        a0fz = log(rzm2/thmu2) - 1d0
        a0fh = log(rhm2/thmu2) - 1d0
        lnlatam = log(rtam2/tlmu2)
        lnlaupm = log(rupm2/tlmu2)
        b0ptazta = b0p(-rtam2,zm2,tam2)
        b0ptahta = b0p(-rtam2,hm2,tam2)
        b0ptacw = b0p(-rtam2,cm2,wm2)
        b0fqstata = b0f(qs,thmu2,tam2,tam2)
        b0ftazta = b0f(-rtam2,thmu2,zm2,tam2)
        b0ftatac = b0f(-rtam2,thmu2,tam2,cm2)
        b0ftstac = b0f(ts,thmu2,tam2,cm2)
        b0fustac = b0f(us,thmu2,tam2,cm2)
        b0fqszc = b0f(qs,thmu2,zm2,cm2)
        b0fqscc = b0f(qs,thmu2,cm2,cm2)
        b0ftawc = b0f(-rtam2,thmu2,wm2,cm2)
        b0ftahta = b0f(-rtam2,thmu2,hm2,tam2)
        b0fqsww = b0f(qs,thmu2,wm2,wm2)
        b0fqszh = b0f(qs,thmu2,zm2,hm2)
        b0fqszz = b0f(qs,thmu2,zm2,zm2)
        c0ctatsczta = -c0(0d0,rtam2,-ts,0d0,rzm2,rtam2)
        c0ctausczta = -c0(0d0,rtam2,-us,0d0,rzm2,rtam2)
        c0tataqsztac = -c0(rtam2,rtam2,-qs,rzm2,rtam2,0d0)
        c0tataqsctac = -c0(rtam2,rtam2,-qs,0d0,rtam2,0d0)
        c0upupqszupc = -c0(rupm2,rupm2,-qs,rzm2,rupm2,0d0)
        c0upupqscupc = -c0(rupm2,rupm2,-qs,0d0,rupm2,0d0)
        c0irtataqs = c0ir(tlmu2,tam2,tam2,qs)
        c0iruptats = c0ir(tlmu2,upm2,tam2,ts)
        c0iruptaus = c0ir(tlmu2,upm2,tam2,us)
        c0irupupqs = c0ir(tlmu2,upm2,upm2,qs)
        c0irtaupts = c0ir(tlmu2,tam2,upm2,ts)
        c0irtaupus = c0ir(tlmu2,tam2,upm2,us)
        c0tataqswcw = -c0(rtam2,rtam2,-qs,rwm2,0d0,rwm2)
        c0tataqsztah = -c0(rtam2,rtam2,-qs,rzm2,rtam2,rhm2)
        c0tataqstazta = -c0(rtam2,rtam2,-qs,rtam2,rzm2,rtam2)
        c0tataqstahta = -c0(rtam2,rtam2,-qs,rtam2,rhm2,rtam2)
        c0tataqscwc = -c0(rtam2,rtam2,-qs,0d0,rwm2,0d0)
        c0tataqsztaz = -c0(rtam2,rtam2,-qs,rzm2,rtam2,rzm2)
        c0ccqszcz = -c0(0d0,0d0,-qs,rzm2,0d0,rzm2)
        c0ccqswcw = -c0(0d0,0d0,-qs,rwm2,0d0,rwm2)
        c0ccqscwc = -c0(0d0,0d0,-qs,0d0,rwm2,0d0)
        c0ccqsczc = -c0(0d0,0d0,-qs,0d0,rzm2,0d0)
        b0d1tataz = b0d1(-rtam2,thmu2,tam2,zm2)
        b0dwtacw = b0dw(-rtam2,thmu2,cm2,wm2)
        d0cctataqstszczta =
     &   d0(0d0,0d0,rtam2,rtam2,-qs,-ts,rzm2,0d0,rzm2,rtam2)
        d0cctataqsuszczta =
     &   d0(0d0,0d0,rtam2,rtam2,-qs,-us,rzm2,0d0,rzm2,rtam2)
        d0cctataqsuswcwc =
     &   d0(0d0,0d0,rtam2,rtam2,-qs,-us,rwm2,0d0,rwm2,0d0)
        jaaqstsupta = jaa(qs,ts,upm2,tam2)
        jaaqsusupta = jaa(qs,us,upm2,tam2)
        javqstsuptaz = jav(qs,ts,upm2,tam2,cmz2)
        javqsusuptaz = jav(qs,us,upm2,tam2,cmz2)
        sdet3ictats = 1d0/(ts+(mta)**2)
        sdet3ictaus = 1d0/(us+(mta)**2)
        sdet4itatsus = 1d0/(ts*us-mta**4)
        sdet3itataqs = 1d0/(qs+(mta+mta)**2)
        sdet3ctats = (ts+mta**2)
        sdet3ctaus = (us+mta**2)
        pxx2zqsc = (2*mz**2)+(qs)

        ff_qed_gg =
     &   -za1fer+stw**2*piggfer

        ff_qed_ll =
     &   +fsr*(-stw**2*qta**2)
     &   +isr*(-stw**2*qup**2)
     &   +det3itataqs*fsr*(2*stw**2*qta**2*qs*mta**2)
     &   +det3itataqs*a0fta*fsr*(-2*stw**2*qta**2*qs*mta**2)
     &   +det3itataqs*b0fqstata*fsr*(-2*stw**2*qta**2*qs*mta**2)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(-4*stw
     &   **2*qup*vmaup*qta*vmata*ts*mz**2*mta**2-4*stw**2*qup*vpaup*qta*vp
     &   ata*ts*mz**2*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(-4*stw**2
     &   *qup*vmaup*qta*vmata*mta**4-4*stw**2*qup*vmaup*qta*vmata*ts*mta**
     &   2-4*stw**2*qup*vpaup*qta*vpata*mta**4-4*stw**2*qup*vpaup*qta*vpat
     &   a*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(-4*stw**2
     &   *qup*vmaup*qta*vmata*mta**4-4*stw**2*qup*vmaup*qta*vmata*ts*mta**
     &   2-4*stw**2*qup*vpaup*qta*vpata*mta**4-4*stw**2*qup*vpaup*qta*vpat
     &   a*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(8*stw**2*
     &   qup*vmaup*qta*vmata*mta**4+8*stw**2*qup*vmaup*qta*vmata*ts*mta**2
     &   +8*stw**2*qup*vpaup*qta*vpata*mta**4+8*stw**2*qup*vpaup*qta*vpata
     &   *ts*mta**2)
     &   +sdet3ictats*c0ctatsczta*dreal(propizqs)*ifi*(-4*stw**2*qup*vmaup
     &   *qta*vmata/qs*mz**2*mta**2-4*stw**2*qup*vpaup*qta*vpata/qs*mz**2*
     &   mta**2)
     &   +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(-4*stw
     &   **2*qup*vmaup*qta*vpata*us*mz**2*mta**2-4*stw**2*qup*vpaup*qta*vm
     &   ata*us*mz**2*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(-4*stw**2
     &   *qup*vmaup*qta*vpata*mta**4-4*stw**2*qup*vmaup*qta*vpata*us*mta**
     &   2-4*stw**2*qup*vpaup*qta*vmata*mta**4-4*stw**2*qup*vpaup*qta*vmat
     &   a*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(-4*stw**2
     &   *qup*vmaup*qta*vpata*mta**4-4*stw**2*qup*vmaup*qta*vpata*us*mta**
     &   2-4*stw**2*qup*vpaup*qta*vmata*mta**4-4*stw**2*qup*vpaup*qta*vmat
     &   a*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(8*stw**2*
     &   qup*vmaup*qta*vpata*mta**4+8*stw**2*qup*vmaup*qta*vpata*us*mta**2
     &   +8*stw**2*qup*vpaup*qta*vmata*mta**4+8*stw**2*qup*vpaup*qta*vmata
     &   *us*mta**2)
     &   +sdet3ictaus*c0ctausczta*dreal(propizqs)*ifi*(-4*stw**2*qup*vmaup
     &   *qta*vpata/qs*mz**2*mta**2-4*stw**2*qup*vpaup*qta*vmata/qs*mz**2*
     &   mta**2)
     &   +sdet4itatsus**2*jaaqstsupta*dreal(propizqs)*ifi*cfscheme*(-8*sde
     &   t3ctats**3*stw**4*ctw**2*qup**2*qta**2*us+8*sdet3ctats**3*stw**4*
     &   ctw**2*qup**2*qta**2*ts)
     &   +sdet4itatsus**2*jaaqsusupta*dreal(propizqs)*ifi*cfscheme*(8*sdet
     &   3ctaus**3*stw**4*ctw**2*qup**2*qta**2*us-8*sdet3ctaus**3*stw**4*c
     &   tw**2*qup**2*qta**2*ts)
     &   +sdet4itatsus**2*javqstsuptaz*dreal(propizqs)*ifi*(2*sdet3ctats*s
     &   tw**2*qup*vmaup*qta*vmata*mz**2*mta**4-2*sdet3ctats*stw**2*qup*vm
     &   aup*qta*vmata*ts**2*mz**2+2*sdet3ctats*stw**2*qup*vmaup*qta*vmata
     &   *qs*mta**4-2*sdet3ctats*stw**2*qup*vmaup*qta*vmata*qs*ts**2+2*sde
     &   t3ctats*stw**2*qup*vpaup*qta*vpata*mz**2*mta**4-2*sdet3ctats*stw*
     &   *2*qup*vpaup*qta*vpata*ts**2*mz**2+2*sdet3ctats*stw**2*qup*vpaup*
     &   qta*vpata*qs*mta**4-2*sdet3ctats*stw**2*qup*vpaup*qta*vpata*qs*ts
     &   **2)
     &   +sdet4itatsus**2*javqsusuptaz*dreal(propizqs)*ifi*(2*sdet3ctaus*s
     &   tw**2*qup*vmaup*qta*vpata*mz**2*mta**4-2*sdet3ctaus*stw**2*qup*vm
     &   aup*qta*vpata*us**2*mz**2+2*sdet3ctaus*stw**2*qup*vmaup*qta*vpata
     &   *qs*mta**4-2*sdet3ctaus*stw**2*qup*vmaup*qta*vpata*qs*us**2+2*sde
     &   t3ctaus*stw**2*qup*vpaup*qta*vmata*mz**2*mta**4-2*sdet3ctaus*stw*
     &   *2*qup*vpaup*qta*vmata*us**2*mz**2+2*sdet3ctaus*stw**2*qup*vpaup*
     &   qta*vmata*qs*mta**4-2*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*qs*us
     &   **2)
     &   +sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*ifi*(-2*sdet3ctats*
     &   stw**2*qup*vmaup*qta*vmata*mz**2*mta**4+2*sdet3ctats*stw**2*qup*v
     &   maup*qta*vmata*us*mz**2*mta**2-2*sdet3ctats*stw**2*qup*vmaup*qta*
     &   vmata*ts*mz**2*mta**2+2*sdet3ctats*stw**2*qup*vmaup*qta*vmata*ts*
     &   *2*mz**2-2*sdet3ctats*stw**2*qup*vmaup*qta*vmata*qs*mta**4+2*sdet
     &   3ctats*stw**2*qup*vmaup*qta*vmata*qs*us*mta**2-2*sdet3ctats*stw**
     &   2*qup*vmaup*qta*vmata*qs*ts*mta**2+2*sdet3ctats*stw**2*qup*vmaup*
     &   qta*vmata*qs*ts**2-2*sdet3ctats*stw**2*qup*vpaup*qta*vpata*mz**2*
     &   mta**4+2*sdet3ctats*stw**2*qup*vpaup*qta*vpata*us*mz**2*mta**2-2*
     &   sdet3ctats*stw**2*qup*vpaup*qta*vpata*ts*mz**2*mta**2+2*sdet3ctat
     &   s*stw**2*qup*vpaup*qta*vpata*ts**2*mz**2-2*sdet3ctats*stw**2*qup*
     &   vpaup*qta*vpata*qs*mta**4+2*sdet3ctats*stw**2*qup*vpaup*qta*vpata
     &   *qs*us*mta**2-2*sdet3ctats*stw**2*qup*vpaup*qta*vpata*qs*ts*mta**
     &   2+2*sdet3ctats*stw**2*qup*vpaup*qta*vpata*qs*ts**2-2*sdet3ctaus*s
     &   tw**2*qup*vmaup*qta*vpata*mz**2*mta**4-2*sdet3ctaus*stw**2*qup*vm
     &   aup*qta*vpata*us*mz**2*mta**2+2*sdet3ctaus*stw**2*qup*vmaup*qta*v
     &   pata*us**2*mz**2+2*sdet3ctaus*stw**2*qup*vmaup*qta*vpata*ts*mz**2
     &   *mta**2-2*sdet3ctaus*stw**2*qup*vmaup*qta*vpata*qs*mta**4-2*sdet3
     &   ctaus*stw**2*qup*vmaup*qta*vpata*qs*us*mta**2+2*sdet3ctaus*stw**2
     &   *qup*vmaup*qta*vpata*qs*us**2+2*sdet3ctaus*stw**2*qup*vmaup*qta*v
     &   pata*qs*ts*mta**2-2*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*mz**2*m
     &   ta**4-2*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*us*mz**2*mta**2+2*s
     &   det3ctaus*stw**2*qup*vpaup*qta*vmata*us**2*mz**2+2*sdet3ctaus*stw
     &   **2*qup*vpaup*qta*vmata*ts*mz**2*mta**2-2*sdet3ctaus*stw**2*qup*v
     &   paup*qta*vmata*qs*mta**4-2*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*
     &   qs*us*mta**2+2*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*qs*us**2+2*s
     &   det3ctaus*stw**2*qup*vpaup*qta*vmata*qs*ts*mta**2)
     &   +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*ifi*cfscheme*(-32*s
     &   tw**4*ctw**2*qup**2*qta**2*qs*us**2*mta**2+64*stw**4*ctw**2*qup**
     &   2*qta**2*qs*ts*us*mta**2-32*stw**4*ctw**2*qup**2*qta**2*qs*ts**2*
     &   mta**2-8*stw**4*ctw**2*qup**2*qta**2*qs**2*us**2+16*stw**4*ctw**2
     &   *qup**2*qta**2*qs**2*ts*us-8*stw**4*ctw**2*qup**2*qta**2*qs**2*ts
     &   **2-64*sdet3ctats*stw**4*ctw**2*qup**2*qta**2*qs*mta**4-16*sdet3c
     &   tats*stw**4*ctw**2*qup**2*qta**2*qs**2*mta**2-64*sdet3ctaus*stw**
     &   4*ctw**2*qup**2*qta**2*qs*mta**4-16*sdet3ctaus*stw**4*ctw**2*qup*
     &   *2*qta**2*qs**2*mta**2)
     &   +sdet4itatsus**2*c0upupqszupc*dreal(propizqs)*ifi*(-2*sdet3ctats*
     &   stw**2*qup*vmaup*qta*vmata*us*mz**2*mta**2+2*sdet3ctats*stw**2*qu
     &   p*vmaup*qta*vmata*ts*mz**2*mta**2-2*sdet3ctats*stw**2*qup*vmaup*q
     &   ta*vmata*qs*us*mta**2+2*sdet3ctats*stw**2*qup*vmaup*qta*vmata*qs*
     &   ts*mta**2-2*sdet3ctats*stw**2*qup*vpaup*qta*vpata*us*mz**2*mta**2
     &   +2*sdet3ctats*stw**2*qup*vpaup*qta*vpata*ts*mz**2*mta**2-2*sdet3c
     &   tats*stw**2*qup*vpaup*qta*vpata*qs*us*mta**2+2*sdet3ctats*stw**2*
     &   qup*vpaup*qta*vpata*qs*ts*mta**2-2*sdet3ctats**2*stw**2*qup*vmaup
     &   *qta*vmata*mz**2*mta**2+2*sdet3ctats**2*stw**2*qup*vmaup*qta*vmat
     &   a*ts*mz**2-2*sdet3ctats**2*stw**2*qup*vmaup*qta*vmata*qs*mta**2+2
     &   *sdet3ctats**2*stw**2*qup*vmaup*qta*vmata*qs*ts-2*sdet3ctats**2*s
     &   tw**2*qup*vpaup*qta*vpata*mz**2*mta**2+2*sdet3ctats**2*stw**2*qup
     &   *vpaup*qta*vpata*ts*mz**2-2*sdet3ctats**2*stw**2*qup*vpaup*qta*vp
     &   ata*qs*mta**2+2*sdet3ctats**2*stw**2*qup*vpaup*qta*vpata*qs*ts+2*
     &   sdet3ctaus*stw**2*qup*vmaup*qta*vpata*us*mz**2*mta**2-2*sdet3ctau
     &   s*stw**2*qup*vmaup*qta*vpata*ts*mz**2*mta**2+2*sdet3ctaus*stw**2*
     &   qup*vmaup*qta*vpata*qs*us*mta**2-2*sdet3ctaus*stw**2*qup*vmaup*qt
     &   a*vpata*qs*ts*mta**2+2*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*us*m
     &   z**2*mta**2-2*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*ts*mz**2*mta*
     &   *2+2*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*qs*us*mta**2-2*sdet3ct
     &   aus*stw**2*qup*vpaup*qta*vmata*qs*ts*mta**2-2*sdet3ctaus**2*stw**
     &   2*qup*vmaup*qta*vpata*mz**2*mta**2+2*sdet3ctaus**2*stw**2*qup*vma
     &   up*qta*vpata*us*mz**2-2*sdet3ctaus**2*stw**2*qup*vmaup*qta*vpata*
     &   qs*mta**2+2*sdet3ctaus**2*stw**2*qup*vmaup*qta*vpata*qs*us-2*sdet
     &   3ctaus**2*stw**2*qup*vpaup*qta*vmata*mz**2*mta**2+2*sdet3ctaus**2
     &   *stw**2*qup*vpaup*qta*vmata*us*mz**2-2*sdet3ctaus**2*stw**2*qup*v
     &   paup*qta*vmata*qs*mta**2+2*sdet3ctaus**2*stw**2*qup*vpaup*qta*vma
     &   ta*qs*us)
     &   +sdet4itatsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(-8*st
     &   w**4*ctw**2*qup**2*qta**2*qs**2*us**2+16*stw**4*ctw**2*qup**2*qta
     &   **2*qs**2*ts*us-8*stw**4*ctw**2*qup**2*qta**2*qs**2*ts**2)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*ifi*(4*sdet3ctats*st
     &   w**2*qup*vmaup*qta*vmata*mz**2*mta**4-4*sdet3ctats*stw**2*qup*vma
     &   up*qta*vmata*ts**2*mz**2+4*sdet3ctats*stw**2*qup*vmaup*qta*vmata*
     &   qs*mta**4-4*sdet3ctats*stw**2*qup*vmaup*qta*vmata*qs*ts**2+4*sdet
     &   3ctats*stw**2*qup*vpaup*qta*vpata*mz**2*mta**4-4*sdet3ctats*stw**
     &   2*qup*vpaup*qta*vpata*ts**2*mz**2+4*sdet3ctats*stw**2*qup*vpaup*q
     &   ta*vpata*qs*mta**4-4*sdet3ctats*stw**2*qup*vpaup*qta*vpata*qs*ts*
     &   *2)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*ifi*(4*sdet3ctaus*st
     &   w**2*qup*vmaup*qta*vpata*mz**2*mta**4-4*sdet3ctaus*stw**2*qup*vma
     &   up*qta*vpata*us**2*mz**2+4*sdet3ctaus*stw**2*qup*vmaup*qta*vpata*
     &   qs*mta**4-4*sdet3ctaus*stw**2*qup*vmaup*qta*vpata*qs*us**2+4*sdet
     &   3ctaus*stw**2*qup*vpaup*qta*vmata*mz**2*mta**4-4*sdet3ctaus*stw**
     &   2*qup*vpaup*qta*vmata*us**2*mz**2+4*sdet3ctaus*stw**2*qup*vpaup*q
     &   ta*vmata*qs*mta**4-4*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*qs*us*
     &   *2)
     &   +sdet4itatsus*javqstsuptaz*dreal(propizqs)*ifi*(-2*stw**2*qup*vma
     &   up*qta*vmata*mta**4-2*stw**2*qup*vmaup*qta*vmata*ts*mta**2-2*stw*
     &   *2*qup*vmaup*qta*vpata*mta**4-2*stw**2*qup*vmaup*qta*vpata*ts*mta
     &   **2-2*stw**2*qup*vpaup*qta*vmata*mta**4-2*stw**2*qup*vpaup*qta*vm
     &   ata*ts*mta**2-2*stw**2*qup*vpaup*qta*vpata*mta**4-2*stw**2*qup*vp
     &   aup*qta*vpata*ts*mta**2-4*sdet3ctats*stw**2*qup*vmaup*qta*vmata*t
     &   s-4*sdet3ctats*stw**2*qup*vpaup*qta*vpata*ts)
     &   +sdet4itatsus*javqsusuptaz*dreal(propizqs)*ifi*(-2*stw**2*qup*vma
     &   up*qta*vmata*mta**4-2*stw**2*qup*vmaup*qta*vmata*us*mta**2-2*stw*
     &   *2*qup*vmaup*qta*vpata*mta**4-2*stw**2*qup*vmaup*qta*vpata*us*mta
     &   **2-2*stw**2*qup*vpaup*qta*vmata*mta**4-2*stw**2*qup*vpaup*qta*vm
     &   ata*us*mta**2-2*stw**2*qup*vpaup*qta*vpata*mta**4-2*stw**2*qup*vp
     &   aup*qta*vpata*us*mta**2-4*sdet3ctaus*stw**2*qup*vmaup*qta*vpata*u
     &   s-4*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*us)
     &   +sdet4itatsus*c0tataqsztac*dreal(propizqs)*ifi*(2*stw**2*qup*vmau
     &   p*qta*vmata/qs*us*mz**2*mta**2-2*stw**2*qup*vmaup*qta*vmata/qs*ts
     &   *mz**2*mta**2-8*stw**2*qup*vmaup*qta*vmata*mta**4+2*stw**2*qup*vm
     &   aup*qta*vmata*us*mta**2-10*stw**2*qup*vmaup*qta*vmata*ts*mta**2+2
     &   *stw**2*qup*vmaup*qta*vmata*ts*mz**2-2*stw**2*qup*vmaup*qta*vmata
     &   *qs*ts-2*stw**2*qup*vmaup*qta*vpata/qs*us*mz**2*mta**2+2*stw**2*q
     &   up*vmaup*qta*vpata/qs*ts*mz**2*mta**2-8*stw**2*qup*vmaup*qta*vpat
     &   a*mta**4-10*stw**2*qup*vmaup*qta*vpata*us*mta**2+2*stw**2*qup*vma
     &   up*qta*vpata*us*mz**2+2*stw**2*qup*vmaup*qta*vpata*ts*mta**2-2*st
     &   w**2*qup*vmaup*qta*vpata*qs*us-2*stw**2*qup*vpaup*qta*vmata/qs*us
     &   *mz**2*mta**2+2*stw**2*qup*vpaup*qta*vmata/qs*ts*mz**2*mta**2-8*s
     &   tw**2*qup*vpaup*qta*vmata*mta**4-10*stw**2*qup*vpaup*qta*vmata*us
     &   *mta**2+2*stw**2*qup*vpaup*qta*vmata*us*mz**2+2*stw**2*qup*vpaup*
     &   qta*vmata*ts*mta**2-2*stw**2*qup*vpaup*qta*vmata*qs*us+2*stw**2*q
     &   up*vpaup*qta*vpata/qs*us*mz**2*mta**2-2*stw**2*qup*vpaup*qta*vpat
     &   a/qs*ts*mz**2*mta**2-8*stw**2*qup*vpaup*qta*vpata*mta**4+2*stw**2
     &   *qup*vpaup*qta*vpata*us*mta**2-10*stw**2*qup*vpaup*qta*vpata*ts*m
     &   ta**2+2*stw**2*qup*vpaup*qta*vpata*ts*mz**2-2*stw**2*qup*vpaup*qt
     &   a*vpata*qs*ts+4*sdet3ctats*stw**2*qup*vmaup*qta*vmata/qs*mz**2*mt
     &   a**2+4*sdet3ctats*stw**2*qup*vmaup*qta*vmata*mta**2+4*sdet3ctats*
     &   stw**2*qup*vpaup*qta*vpata/qs*mz**2*mta**2+4*sdet3ctats*stw**2*qu
     &   p*vpaup*qta*vpata*mta**2+4*sdet3ctaus*stw**2*qup*vmaup*qta*vpata/
     &   qs*mz**2*mta**2+4*sdet3ctaus*stw**2*qup*vmaup*qta*vpata*mta**2+4*
     &   sdet3ctaus*stw**2*qup*vpaup*qta*vmata/qs*mz**2*mta**2+4*sdet3ctau
     &   s*stw**2*qup*vpaup*qta*vmata*mta**2)
     &   +sdet4itatsus*c0tataqsctac*dreal(propizqs)*ifi*cfscheme*(-32*stw*
     &   *4*ctw**2*qup**2*qta**2*qs*mta**2)
     &   +sdet4itatsus*c0upupqszupc*dreal(propizqs)*ifi*(2*stw**2*qup*vmau
     &   p*qta*vmata*mz**2*mta**2+2*stw**2*qup*vmaup*qta*vmata*ts*mz**2-2*
     &   stw**2*qup*vmaup*qta*vmata*qs*mta**2-2*stw**2*qup*vmaup*qta*vmata
     &   *qs*ts+2*stw**2*qup*vmaup*qta*vpata*mz**2*mta**2+2*stw**2*qup*vma
     &   up*qta*vpata*us*mz**2-2*stw**2*qup*vmaup*qta*vpata*qs*mta**2-2*st
     &   w**2*qup*vmaup*qta*vpata*qs*us+2*stw**2*qup*vpaup*qta*vmata*mz**2
     &   *mta**2+2*stw**2*qup*vpaup*qta*vmata*us*mz**2-2*stw**2*qup*vpaup*
     &   qta*vmata*qs*mta**2-2*stw**2*qup*vpaup*qta*vmata*qs*us+2*stw**2*q
     &   up*vpaup*qta*vpata*mz**2*mta**2+2*stw**2*qup*vpaup*qta*vpata*ts*m
     &   z**2-2*stw**2*qup*vpaup*qta*vpata*qs*mta**2-2*stw**2*qup*vpaup*qt
     &   a*vpata*qs*ts)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(-4*stw**2*qup*vmau
     &   p*qta*vmata*mta**4-4*stw**2*qup*vmaup*qta*vmata*ts*mta**2-4*stw**
     &   2*qup*vmaup*qta*vpata*mta**4-4*stw**2*qup*vmaup*qta*vpata*ts*mta*
     &   *2-4*stw**2*qup*vpaup*qta*vmata*mta**4-4*stw**2*qup*vpaup*qta*vma
     &   ta*ts*mta**2-4*stw**2*qup*vpaup*qta*vpata*mta**4-4*stw**2*qup*vpa
     &   up*qta*vpata*ts*mta**2-4*sdet3ctats*stw**2*qup*vmaup*qta*vmata/qs
     &   *mz**2*mta**2-8*sdet3ctats*stw**2*qup*vmaup*qta*vmata*ts-4*sdet3c
     &   tats*stw**2*qup*vpaup*qta*vpata/qs*mz**2*mta**2-8*sdet3ctats*stw*
     &   *2*qup*vpaup*qta*vpata*ts)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(-4*stw**2*qup*vmau
     &   p*qta*vmata*mta**4-4*stw**2*qup*vmaup*qta*vmata*us*mta**2-4*stw**
     &   2*qup*vmaup*qta*vpata*mta**4-4*stw**2*qup*vmaup*qta*vpata*us*mta*
     &   *2-4*stw**2*qup*vpaup*qta*vmata*mta**4-4*stw**2*qup*vpaup*qta*vma
     &   ta*us*mta**2-4*stw**2*qup*vpaup*qta*vpata*mta**4-4*stw**2*qup*vpa
     &   up*qta*vpata*us*mta**2-4*sdet3ctaus*stw**2*qup*vmaup*qta*vpata/qs
     &   *mz**2*mta**2-8*sdet3ctaus*stw**2*qup*vmaup*qta*vpata*us-4*sdet3c
     &   taus*stw**2*qup*vpaup*qta*vmata/qs*mz**2*mta**2-8*sdet3ctaus*stw*
     &   *2*qup*vpaup*qta*vmata*us)
     &   +sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*cfscheme*(-64*stw**4*c
     &   tw**2*qup**2*qta**2*mta**2)
     &   +sdet4itatsus*b0fqszc*dreal(propizqs)*ifi*(4*stw**2*qup*vmaup*qta
     &   *vmata*mta**2+4*stw**2*qup*vmaup*qta*vmata*ts+4*stw**2*qup*vmaup*
     &   qta*vpata*mta**2+4*stw**2*qup*vmaup*qta*vpata*us+4*stw**2*qup*vpa
     &   up*qta*vmata*mta**2+4*stw**2*qup*vpaup*qta*vmata*us+4*stw**2*qup*
     &   vpaup*qta*vpata*mta**2+4*stw**2*qup*vpaup*qta*vpata*ts)
     &   +sdet4itatsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(16*sdet3ctats
     &   *stw**4*ctw**2*qup**2*qta**2+16*sdet3ctaus*stw**4*ctw**2*qup**2*q
     &   ta**2)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(-4*stw**2*qup*vmaup*q
     &   ta*vmata*mta**2-4*stw**2*qup*vmaup*qta*vmata*ts-4*stw**2*qup*vpau
     &   p*qta*vpata*mta**2-4*stw**2*qup*vpaup*qta*vpata*ts)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*cfscheme*(32*stw**4*ct
     &   w**2*qup**2*qta**2*mta**2-16*sdet3ctats*stw**4*ctw**2*qup**2*qta*
     &   *2)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(-4*stw**2*qup*vmaup*q
     &   ta*vpata*mta**2-4*stw**2*qup*vmaup*qta*vpata*us-4*stw**2*qup*vpau
     &   p*qta*vmata*mta**2-4*stw**2*qup*vpaup*qta*vmata*us)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*ifi*cfscheme*(32*stw**4*ct
     &   w**2*qup**2*qta**2*mta**2-16*sdet3ctaus*stw**4*ctw**2*qup**2*qta*
     &   *2)
     &   +javqstsuptaz*ifi*(-4*sdet3ctats*stw**2*qup*vmaup*qta*vmata+4*sde
     &   t3ctats*stw**2*qup*vmaup*qta*vpata+4*sdet3ctats*stw**2*qup*vpaup*
     &   qta*vmata-4*sdet3ctats*stw**2*qup*vpaup*qta*vpata)
     &   +javqsusuptaz*ifi*(4*sdet3ctaus*stw**2*qup*vmaup*qta*vmata-4*sdet
     &   3ctaus*stw**2*qup*vmaup*qta*vpata-4*sdet3ctaus*stw**2*qup*vpaup*q
     &   ta*vmata+4*sdet3ctaus*stw**2*qup*vpaup*qta*vpata)
     &   +c0irtataqs*fsr*(-4*stw**2*qta**2*mta**2-2*stw**2*qta**2*qs)
     &   +c0iruptats*ifi*(4*sdet3ctats*stw**2*qup*vmaup*qta*vmata-4*sdet3c
     &   tats*stw**2*qup*vmaup*qta*vpata-4*sdet3ctats*stw**2*qup*vpaup*qta
     &   *vmata+4*sdet3ctats*stw**2*qup*vpaup*qta*vpata)
     &   +c0iruptaus*ifi*(-4*sdet3ctaus*stw**2*qup*vmaup*qta*vmata+4*sdet3
     &   ctaus*stw**2*qup*vmaup*qta*vpata+4*sdet3ctaus*stw**2*qup*vpaup*qt
     &   a*vmata-4*sdet3ctaus*stw**2*qup*vpaup*qta*vpata)
     &   +c0irupupqs*isr*(-2*stw**2*qup**2*qs)
     &   +c0ctatsczta*ifi*(-4*sdet3ctats*stw**2*qup*vmaup*qta*vmata+4*sdet
     &   3ctats*stw**2*qup*vmaup*qta*vpata+4*sdet3ctats*stw**2*qup*vpaup*q
     &   ta*vmata-4*sdet3ctats*stw**2*qup*vpaup*qta*vpata)
     &   +c0ctausczta*ifi*(4*sdet3ctaus*stw**2*qup*vmaup*qta*vmata-4*sdet3
     &   ctaus*stw**2*qup*vmaup*qta*vpata-4*sdet3ctaus*stw**2*qup*vpaup*qt
     &   a*vmata+4*sdet3ctaus*stw**2*qup*vpaup*qta*vpata)
     &   +a0fup*isr*(-3*stw**2*qup**2)
     &   +a0fta*fsr*(-3*stw**2*qta**2)
     &   +b0fqstata*fsr*(-3*stw**2*qta**2)
     &   +b0fqscc*isr*(-3*stw**2*qup**2)
     &   +lnlatam*fsr*(2*stw**2*qta**2)
     &   +lnlaupm*isr*(2*stw**2*qup**2)

        ff_qed_ql =
     &   +fsr*(-stw**2*qta**2)
     &   +isr*(-stw**2*qup**2)
     &   +det3itataqs*fsr*(2*stw**2*qta**2*qs*mta**2)
     &   +det3itataqs*a0fta*fsr*(-2*stw**2*qta**2*qs*mta**2)
     &   +det3itataqs*b0fqstata*fsr*(-2*stw**2*qta**2*qs*mta**2)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(4*stw*
     &   *2*qup*qta*vmata*ts*mz**2*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*qta*vmata*mta**4+4*stw**2*qup*qta*vmata*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*qta*vmata*mta**4+4*stw**2*qup*qta*vmata*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(-8*stw**2
     &   *qup*qta*vmata*mta**4-8*stw**2*qup*qta*vmata*ts*mta**2)
     &   +sdet3ictats*c0ctatsczta*dreal(propizqs)*ifi*(4*stw**2*qup*qta*vm
     &   ata/qs*mz**2*mta**2)
     &   +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(4*stw*
     &   *2*qup*qta*vpata*us*mz**2*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*qta*vpata*mta**4+4*stw**2*qup*qta*vpata*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*qta*vpata*mta**4+4*stw**2*qup*qta*vpata*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(-8*stw**2
     &   *qup*qta*vpata*mta**4-8*stw**2*qup*qta*vpata*us*mta**2)
     &   +sdet3ictaus*c0ctausczta*dreal(propizqs)*ifi*(4*stw**2*qup*qta*vp
     &   ata/qs*mz**2*mta**2)
     &   +sdet4itatsus**2*jaaqstsupta*dreal(propizqs)*ifi*cfscheme*(-2*sde
     &   t3ctats**3*stw**2*ctw**2*qup*qta**2*us+2*sdet3ctats**3*stw**2*ctw
     &   **2*qup*qta**2*ts)
     &   +sdet4itatsus**2*jaaqsusupta*dreal(propizqs)*ifi*cfscheme*(2*sdet
     &   3ctaus**3*stw**2*ctw**2*qup*qta**2*us-2*sdet3ctaus**3*stw**2*ctw*
     &   *2*qup*qta**2*ts)
     &   +sdet4itatsus**2*javqstsuptaz*dreal(propizqs)*ifi*(-2*sdet3ctats*
     &   stw**2*qup*qta*vmata*mz**2*mta**4+2*sdet3ctats*stw**2*qup*qta*vma
     &   ta*ts**2*mz**2-2*sdet3ctats*stw**2*qup*qta*vmata*qs*mta**4+2*sdet
     &   3ctats*stw**2*qup*qta*vmata*qs*ts**2)
     &   +sdet4itatsus**2*javqsusuptaz*dreal(propizqs)*ifi*(-2*sdet3ctaus*
     &   stw**2*qup*qta*vpata*mz**2*mta**4+2*sdet3ctaus*stw**2*qup*qta*vpa
     &   ta*us**2*mz**2-2*sdet3ctaus*stw**2*qup*qta*vpata*qs*mta**4+2*sdet
     &   3ctaus*stw**2*qup*qta*vpata*qs*us**2)
     &   +sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*ifi*(2*sdet3ctats*s
     &   tw**2*qup*qta*vmata*mz**2*mta**4-2*sdet3ctats*stw**2*qup*qta*vmat
     &   a*us*mz**2*mta**2+2*sdet3ctats*stw**2*qup*qta*vmata*ts*mz**2*mta*
     &   *2-2*sdet3ctats*stw**2*qup*qta*vmata*ts**2*mz**2+2*sdet3ctats*stw
     &   **2*qup*qta*vmata*qs*mta**4-2*sdet3ctats*stw**2*qup*qta*vmata*qs*
     &   us*mta**2+2*sdet3ctats*stw**2*qup*qta*vmata*qs*ts*mta**2-2*sdet3c
     &   tats*stw**2*qup*qta*vmata*qs*ts**2+2*sdet3ctaus*stw**2*qup*qta*vp
     &   ata*mz**2*mta**4+2*sdet3ctaus*stw**2*qup*qta*vpata*us*mz**2*mta**
     &   2-2*sdet3ctaus*stw**2*qup*qta*vpata*us**2*mz**2-2*sdet3ctaus*stw*
     &   *2*qup*qta*vpata*ts*mz**2*mta**2+2*sdet3ctaus*stw**2*qup*qta*vpat
     &   a*qs*mta**4+2*sdet3ctaus*stw**2*qup*qta*vpata*qs*us*mta**2-2*sdet
     &   3ctaus*stw**2*qup*qta*vpata*qs*us**2-2*sdet3ctaus*stw**2*qup*qta*
     &   vpata*qs*ts*mta**2)
     &   +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*ifi*cfscheme*(-8*st
     &   w**2*ctw**2*qup*qta**2*qs*us**2*mta**2+16*stw**2*ctw**2*qup*qta**
     &   2*qs*ts*us*mta**2-8*stw**2*ctw**2*qup*qta**2*qs*ts**2*mta**2-2*st
     &   w**2*ctw**2*qup*qta**2*qs**2*us**2+4*stw**2*ctw**2*qup*qta**2*qs*
     &   *2*ts*us-2*stw**2*ctw**2*qup*qta**2*qs**2*ts**2-16*sdet3ctats*stw
     &   **2*ctw**2*qup*qta**2*qs*mta**4-4*sdet3ctats*stw**2*ctw**2*qup*qt
     &   a**2*qs**2*mta**2-16*sdet3ctaus*stw**2*ctw**2*qup*qta**2*qs*mta**
     &   4-4*sdet3ctaus*stw**2*ctw**2*qup*qta**2*qs**2*mta**2)
     &   +sdet4itatsus**2*c0upupqszupc*dreal(propizqs)*ifi*(2*sdet3ctats*s
     &   tw**2*qup*qta*vmata*us*mz**2*mta**2-2*sdet3ctats*stw**2*qup*qta*v
     &   mata*ts*mz**2*mta**2+2*sdet3ctats*stw**2*qup*qta*vmata*qs*us*mta*
     &   *2-2*sdet3ctats*stw**2*qup*qta*vmata*qs*ts*mta**2+2*sdet3ctats**2
     &   *stw**2*qup*qta*vmata*mz**2*mta**2-2*sdet3ctats**2*stw**2*qup*qta
     &   *vmata*ts*mz**2+2*sdet3ctats**2*stw**2*qup*qta*vmata*qs*mta**2-2*
     &   sdet3ctats**2*stw**2*qup*qta*vmata*qs*ts-2*sdet3ctaus*stw**2*qup*
     &   qta*vpata*us*mz**2*mta**2+2*sdet3ctaus*stw**2*qup*qta*vpata*ts*mz
     &   **2*mta**2-2*sdet3ctaus*stw**2*qup*qta*vpata*qs*us*mta**2+2*sdet3
     &   ctaus*stw**2*qup*qta*vpata*qs*ts*mta**2+2*sdet3ctaus**2*stw**2*qu
     &   p*qta*vpata*mz**2*mta**2-2*sdet3ctaus**2*stw**2*qup*qta*vpata*us*
     &   mz**2+2*sdet3ctaus**2*stw**2*qup*qta*vpata*qs*mta**2-2*sdet3ctaus
     &   **2*stw**2*qup*qta*vpata*qs*us)
     &   +sdet4itatsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(-2*st
     &   w**2*ctw**2*qup*qta**2*qs**2*us**2+4*stw**2*ctw**2*qup*qta**2*qs*
     &   *2*ts*us-2*stw**2*ctw**2*qup*qta**2*qs**2*ts**2)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*ifi*(-4*sdet3ctats*s
     &   tw**2*qup*qta*vmata*mz**2*mta**4+4*sdet3ctats*stw**2*qup*qta*vmat
     &   a*ts**2*mz**2-4*sdet3ctats*stw**2*qup*qta*vmata*qs*mta**4+4*sdet3
     &   ctats*stw**2*qup*qta*vmata*qs*ts**2)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*ifi*(-4*sdet3ctaus*s
     &   tw**2*qup*qta*vpata*mz**2*mta**4+4*sdet3ctaus*stw**2*qup*qta*vpat
     &   a*us**2*mz**2-4*sdet3ctaus*stw**2*qup*qta*vpata*qs*mta**4+4*sdet3
     &   ctaus*stw**2*qup*qta*vpata*qs*us**2)
     &   +sdet4itatsus*javqstsuptaz*dreal(propizqs)*ifi*(2*stw**2*qup*qta*
     &   vmata*mta**4+2*stw**2*qup*qta*vmata*ts*mta**2+2*stw**2*qup*qta*vp
     &   ata*mta**4+2*stw**2*qup*qta*vpata*ts*mta**2+4*sdet3ctats*stw**2*q
     &   up*qta*vmata*ts)
     &   +sdet4itatsus*javqsusuptaz*dreal(propizqs)*ifi*(2*stw**2*qup*qta*
     &   vmata*mta**4+2*stw**2*qup*qta*vmata*us*mta**2+2*stw**2*qup*qta*vp
     &   ata*mta**4+2*stw**2*qup*qta*vpata*us*mta**2+4*sdet3ctaus*stw**2*q
     &   up*qta*vpata*us)
     &   +sdet4itatsus*c0tataqsztac*dreal(propizqs)*ifi*(-2*stw**2*qup*qta
     &   *vmata/qs*us*mz**2*mta**2+2*stw**2*qup*qta*vmata/qs*ts*mz**2*mta*
     &   *2+8*stw**2*qup*qta*vmata*mta**4-2*stw**2*qup*qta*vmata*us*mta**2
     &   +10*stw**2*qup*qta*vmata*ts*mta**2-2*stw**2*qup*qta*vmata*ts*mz**
     &   2+2*stw**2*qup*qta*vmata*qs*ts+2*stw**2*qup*qta*vpata/qs*us*mz**2
     &   *mta**2-2*stw**2*qup*qta*vpata/qs*ts*mz**2*mta**2+8*stw**2*qup*qt
     &   a*vpata*mta**4+10*stw**2*qup*qta*vpata*us*mta**2-2*stw**2*qup*qta
     &   *vpata*us*mz**2-2*stw**2*qup*qta*vpata*ts*mta**2+2*stw**2*qup*qta
     &   *vpata*qs*us-4*sdet3ctats*stw**2*qup*qta*vmata/qs*mz**2*mta**2-4*
     &   sdet3ctats*stw**2*qup*qta*vmata*mta**2-4*sdet3ctaus*stw**2*qup*qt
     &   a*vpata/qs*mz**2*mta**2-4*sdet3ctaus*stw**2*qup*qta*vpata*mta**2)
     &
     &   +sdet4itatsus*c0tataqsctac*dreal(propizqs)*ifi*cfscheme*(-8*stw**
     &   2*ctw**2*qup*qta**2*qs*mta**2)
     &   +sdet4itatsus*c0upupqszupc*dreal(propizqs)*ifi*(-2*stw**2*qup*qta
     &   *vmata*mz**2*mta**2-2*stw**2*qup*qta*vmata*ts*mz**2+2*stw**2*qup*
     &   qta*vmata*qs*mta**2+2*stw**2*qup*qta*vmata*qs*ts-2*stw**2*qup*qta
     &   *vpata*mz**2*mta**2-2*stw**2*qup*qta*vpata*us*mz**2+2*stw**2*qup*
     &   qta*vpata*qs*mta**2+2*stw**2*qup*qta*vpata*qs*us)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(4*stw**2*qup*qta*v
     &   mata*mta**4+4*stw**2*qup*qta*vmata*ts*mta**2+4*stw**2*qup*qta*vpa
     &   ta*mta**4+4*stw**2*qup*qta*vpata*ts*mta**2+4*sdet3ctats*stw**2*qu
     &   p*qta*vmata/qs*mz**2*mta**2+8*sdet3ctats*stw**2*qup*qta*vmata*ts)
     &
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(4*stw**2*qup*qta*v
     &   mata*mta**4+4*stw**2*qup*qta*vmata*us*mta**2+4*stw**2*qup*qta*vpa
     &   ta*mta**4+4*stw**2*qup*qta*vpata*us*mta**2+4*sdet3ctaus*stw**2*qu
     &   p*qta*vpata/qs*mz**2*mta**2+8*sdet3ctaus*stw**2*qup*qta*vpata*us)
     &
     &   +sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*cfscheme*(-16*stw**2*c
     &   tw**2*qup*qta**2*mta**2)
     &   +sdet4itatsus*b0fqszc*dreal(propizqs)*ifi*(-4*stw**2*qup*qta*vmat
     &   a*mta**2-4*stw**2*qup*qta*vmata*ts-4*stw**2*qup*qta*vpata*mta**2-
     &   4*stw**2*qup*qta*vpata*us)
     &   +sdet4itatsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(4*sdet3ctats*
     &   stw**2*ctw**2*qup*qta**2+4*sdet3ctaus*stw**2*ctw**2*qup*qta**2)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(4*stw**2*qup*qta*vmat
     &   a*mta**2+4*stw**2*qup*qta*vmata*ts)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*cfscheme*(8*stw**2*ctw
     &   **2*qup*qta**2*mta**2-4*sdet3ctats*stw**2*ctw**2*qup*qta**2)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(4*stw**2*qup*qta*vpat
     &   a*mta**2+4*stw**2*qup*qta*vpata*us)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*ifi*cfscheme*(8*stw**2*ctw
     &   **2*qup*qta**2*mta**2-4*sdet3ctaus*stw**2*ctw**2*qup*qta**2)
     &   +javqstsuptaz*ifi*(4*sdet3ctats*stw**2*qup*qta*vmata-4*sdet3ctats
     &   *stw**2*qup*qta*vpata)
     &   +javqsusuptaz*ifi*(-4*sdet3ctaus*stw**2*qup*qta*vmata+4*sdet3ctau
     &   s*stw**2*qup*qta*vpata)
     &   +c0irtataqs*fsr*(-4*stw**2*qta**2*mta**2-2*stw**2*qta**2*qs)
     &   +c0iruptats*ifi*(-4*sdet3ctats*stw**2*qup*qta*vmata+4*sdet3ctats*
     &   stw**2*qup*qta*vpata)
     &   +c0iruptaus*ifi*(4*sdet3ctaus*stw**2*qup*qta*vmata-4*sdet3ctaus*s
     &   tw**2*qup*qta*vpata)
     &   +c0irupupqs*isr*(-2*stw**2*qup**2*qs)
     &   +c0ctatsczta*ifi*(4*sdet3ctats*stw**2*qup*qta*vmata-4*sdet3ctats*
     &   stw**2*qup*qta*vpata)
     &   +c0ctausczta*ifi*(-4*sdet3ctaus*stw**2*qup*qta*vmata+4*sdet3ctaus
     &   *stw**2*qup*qta*vpata)
     &   +a0fup*isr*(-3*stw**2*qup**2)
     &   +a0fta*fsr*(-3*stw**2*qta**2)
     &   +b0fqstata*fsr*(-3*stw**2*qta**2)
     &   +b0fqscc*isr*(-3*stw**2*qup**2)
     &   +lnlatam*fsr*(2*stw**2*qta**2)
     &   +lnlaupm*isr*(2*stw**2*qup**2)

        ff_qed_lq =
     &   +fsr*(-stw**2*qta**2)
     &   +isr*(-stw**2*qup**2)
     &   +det3itataqs*fsr*(-1d0/2*qta*qs*mta**2)
     &   +det3itataqs*a0fta*fsr*(1d0/2*qta*qs*mta**2)
     &   +det3itataqs*b0fqstata*fsr*(1d0/2*qta*qs*mta**2)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(-4*stw
     &   **2*qup*vmaup*qta*ts*mz**2*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(2*qup*vpa
     &   up*vpata*mta**4-4*stw**2*qup*vmaup*qta*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(2*qup*vpa
     &   up*vpata*mta**4-4*stw**2*qup*vmaup*qta*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(-4*qup*vp
     &   aup*vpata*mta**4+8*stw**2*qup*vmaup*qta*ts*mta**2)
     &   +sdet3ictats*c0ctatsczta*dreal(propizqs)*ifi*(2*qup*vpaup*vpata/q
     &   s*mz**2*mta**2)
     &   +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(-4*stw
     &   **2*qup*vpaup*qta*us*mz**2*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(2*qup*vma
     &   up*vpata*mta**4-4*stw**2*qup*vpaup*qta*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(2*qup*vma
     &   up*vpata*mta**4-4*stw**2*qup*vpaup*qta*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(-4*qup*vm
     &   aup*vpata*mta**4+8*stw**2*qup*vpaup*qta*us*mta**2)
     &   +sdet3ictaus*c0ctausczta*dreal(propizqs)*ifi*(2*qup*vmaup*vpata/q
     &   s*mz**2*mta**2)
     &   +sdet4itatsus**2*jaaqstsupta*dreal(propizqs)*ifi*cfscheme*(2*sdet
     &   3ctats**3*stw**2*ctw**2*qup**2*qta*us-2*sdet3ctats**3*stw**2*ctw*
     &   *2*qup**2*qta*ts)
     &   +sdet4itatsus**2*jaaqsusupta*dreal(propizqs)*ifi*cfscheme*(-2*sde
     &   t3ctaus**3*stw**2*ctw**2*qup**2*qta*us+2*sdet3ctaus**3*stw**2*ctw
     &   **2*qup**2*qta*ts)
     &   +sdet4itatsus**2*javqstsuptaz*dreal(propizqs)*ifi*(-sdet3ctats*qu
     &   p*vpaup*vpata*mz**2*mta**4+sdet3ctats*qup*vpaup*vpata*ts*mz**2*mt
     &   a**2-sdet3ctats*qup*vpaup*vpata*qs*mta**4+sdet3ctats*qup*vpaup*vp
     &   ata*qs*ts*mta**2+2*sdet3ctats*stw**2*qup*vmaup*qta*ts*mz**2*mta**
     &   2-2*sdet3ctats*stw**2*qup*vmaup*qta*ts**2*mz**2+2*sdet3ctats*stw*
     &   *2*qup*vmaup*qta*qs*ts*mta**2-2*sdet3ctats*stw**2*qup*vmaup*qta*q
     &   s*ts**2)
     &   +sdet4itatsus**2*javqsusuptaz*dreal(propizqs)*ifi*(-sdet3ctaus*qu
     &   p*vmaup*vpata*mz**2*mta**4+sdet3ctaus*qup*vmaup*vpata*us*mz**2*mt
     &   a**2-sdet3ctaus*qup*vmaup*vpata*qs*mta**4+sdet3ctaus*qup*vmaup*vp
     &   ata*qs*us*mta**2+2*sdet3ctaus*stw**2*qup*vpaup*qta*us*mz**2*mta**
     &   2-2*sdet3ctaus*stw**2*qup*vpaup*qta*us**2*mz**2+2*sdet3ctaus*stw*
     &   *2*qup*vpaup*qta*qs*us*mta**2-2*sdet3ctaus*stw**2*qup*vpaup*qta*q
     &   s*us**2)
     &   +sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*ifi*(2*sdet3ctats*q
     &   up*vpaup*vpata*mz**2*mta**4-sdet3ctats*qup*vpaup*vpata*us*mz**2*m
     &   ta**2-sdet3ctats*qup*vpaup*vpata*ts*mz**2*mta**2+2*sdet3ctats*qup
     &   *vpaup*vpata*qs*mta**4-sdet3ctats*qup*vpaup*vpata*qs*us*mta**2-sd
     &   et3ctats*qup*vpaup*vpata*qs*ts*mta**2+2*sdet3ctats*stw**2*qup*vma
     &   up*qta*mz**2*mta**4-4*sdet3ctats*stw**2*qup*vmaup*qta*ts*mz**2*mt
     &   a**2+2*sdet3ctats*stw**2*qup*vmaup*qta*ts**2*mz**2+2*sdet3ctats*s
     &   tw**2*qup*vmaup*qta*qs*mta**4-4*sdet3ctats*stw**2*qup*vmaup*qta*q
     &   s*ts*mta**2+2*sdet3ctats*stw**2*qup*vmaup*qta*qs*ts**2+2*sdet3cta
     &   us*qup*vmaup*vpata*mz**2*mta**4-sdet3ctaus*qup*vmaup*vpata*us*mz*
     &   *2*mta**2-sdet3ctaus*qup*vmaup*vpata*ts*mz**2*mta**2+2*sdet3ctaus
     &   *qup*vmaup*vpata*qs*mta**4-sdet3ctaus*qup*vmaup*vpata*qs*us*mta**
     &   2-sdet3ctaus*qup*vmaup*vpata*qs*ts*mta**2+2*sdet3ctaus*stw**2*qup
     &   *vpaup*qta*mz**2*mta**4-4*sdet3ctaus*stw**2*qup*vpaup*qta*us*mz**
     &   2*mta**2+2*sdet3ctaus*stw**2*qup*vpaup*qta*us**2*mz**2+2*sdet3cta
     &   us*stw**2*qup*vpaup*qta*qs*mta**4-4*sdet3ctaus*stw**2*qup*vpaup*q
     &   ta*qs*us*mta**2+2*sdet3ctaus*stw**2*qup*vpaup*qta*qs*us**2)
     &   +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*ifi*cfscheme*(8*stw
     &   **2*ctw**2*qup**2*qta*qs*us**2*mta**2-16*stw**2*ctw**2*qup**2*qta
     &   *qs*ts*us*mta**2+8*stw**2*ctw**2*qup**2*qta*qs*ts**2*mta**2+2*stw
     &   **2*ctw**2*qup**2*qta*qs**2*us**2-4*stw**2*ctw**2*qup**2*qta*qs**
     &   2*ts*us+2*stw**2*ctw**2*qup**2*qta*qs**2*ts**2+16*sdet3ctats*stw*
     &   *2*ctw**2*qup**2*qta*qs*mta**4+4*sdet3ctats*stw**2*ctw**2*qup**2*
     &   qta*qs**2*mta**2+16*sdet3ctaus*stw**2*ctw**2*qup**2*qta*qs*mta**4
     &   +4*sdet3ctaus*stw**2*ctw**2*qup**2*qta*qs**2*mta**2)
     &   +sdet4itatsus**2*c0upupqszupc*dreal(propizqs)*ifi*(sdet3ctats*qup
     &   *vpaup*vpata*us*mz**2*mta**2-sdet3ctats*qup*vpaup*vpata*ts*mz**2*
     &   mta**2+sdet3ctats*qup*vpaup*vpata*qs*us*mta**2-sdet3ctats*qup*vpa
     &   up*vpata*qs*ts*mta**2-2*sdet3ctats**2*stw**2*qup*vmaup*qta*mz**2*
     &   mta**2+2*sdet3ctats**2*stw**2*qup*vmaup*qta*ts*mz**2-2*sdet3ctats
     &   **2*stw**2*qup*vmaup*qta*qs*mta**2+2*sdet3ctats**2*stw**2*qup*vma
     &   up*qta*qs*ts-sdet3ctaus*qup*vmaup*vpata*us*mz**2*mta**2+sdet3ctau
     &   s*qup*vmaup*vpata*ts*mz**2*mta**2-sdet3ctaus*qup*vmaup*vpata*qs*u
     &   s*mta**2+sdet3ctaus*qup*vmaup*vpata*qs*ts*mta**2-2*sdet3ctaus**2*
     &   stw**2*qup*vpaup*qta*mz**2*mta**2+2*sdet3ctaus**2*stw**2*qup*vpau
     &   p*qta*us*mz**2-2*sdet3ctaus**2*stw**2*qup*vpaup*qta*qs*mta**2+2*s
     &   det3ctaus**2*stw**2*qup*vpaup*qta*qs*us)
     &   +sdet4itatsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(2*stw
     &   **2*ctw**2*qup**2*qta*qs**2*us**2-4*stw**2*ctw**2*qup**2*qta*qs**
     &   2*ts*us+2*stw**2*ctw**2*qup**2*qta*qs**2*ts**2)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*ifi*(-2*sdet3ctats*q
     &   up*vpaup*vpata*mz**2*mta**4+2*sdet3ctats*qup*vpaup*vpata*ts*mz**2
     &   *mta**2-2*sdet3ctats*qup*vpaup*vpata*qs*mta**4+2*sdet3ctats*qup*v
     &   paup*vpata*qs*ts*mta**2+4*sdet3ctats*stw**2*qup*vmaup*qta*ts*mz**
     &   2*mta**2-4*sdet3ctats*stw**2*qup*vmaup*qta*ts**2*mz**2+4*sdet3cta
     &   ts*stw**2*qup*vmaup*qta*qs*ts*mta**2-4*sdet3ctats*stw**2*qup*vmau
     &   p*qta*qs*ts**2)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*ifi*(-2*sdet3ctaus*q
     &   up*vmaup*vpata*mz**2*mta**4+2*sdet3ctaus*qup*vmaup*vpata*us*mz**2
     &   *mta**2-2*sdet3ctaus*qup*vmaup*vpata*qs*mta**4+2*sdet3ctaus*qup*v
     &   maup*vpata*qs*us*mta**2+4*sdet3ctaus*stw**2*qup*vpaup*qta*us*mz**
     &   2*mta**2-4*sdet3ctaus*stw**2*qup*vpaup*qta*us**2*mz**2+4*sdet3cta
     &   us*stw**2*qup*vpaup*qta*qs*us*mta**2-4*sdet3ctaus*stw**2*qup*vpau
     &   p*qta*qs*us**2)
     &   +sdet4itatsus*javqstsuptaz*dreal(propizqs)*ifi*(qup*vmaup*vpata*t
     &   s*mta**2+qup*vpaup*vpata*ts*mta**2-2*stw**2*qup*vmaup*qta*mta**4-
     &   2*stw**2*qup*vpaup*qta*mta**4+sdet3ctats*qup*vpaup*vpata/qs*mz**2
     &   *mta**2+2*sdet3ctats*qup*vpaup*vpata*mta**2+2*sdet3ctats*stw**2*q
     &   up*vmaup*qta/qs*mz**2*mta**2+4*sdet3ctats*stw**2*qup*vmaup*qta*mt
     &   a**2-4*sdet3ctats*stw**2*qup*vmaup*qta*ts)
     &   +sdet4itatsus*javqsusuptaz*dreal(propizqs)*ifi*(qup*vmaup*vpata*u
     &   s*mta**2+qup*vpaup*vpata*us*mta**2-2*stw**2*qup*vmaup*qta*mta**4-
     &   2*stw**2*qup*vpaup*qta*mta**4+sdet3ctaus*qup*vmaup*vpata/qs*mz**2
     &   *mta**2+2*sdet3ctaus*qup*vmaup*vpata*mta**2+2*sdet3ctaus*stw**2*q
     &   up*vpaup*qta/qs*mz**2*mta**2+4*sdet3ctaus*stw**2*qup*vpaup*qta*mt
     &   a**2-4*sdet3ctaus*stw**2*qup*vpaup*qta*us)
     &   +sdet4itatsus*c0tataqsztac*dreal(propizqs)*ifi*(qup*vmaup*vpata/q
     &   s*us*mz**2*mta**2-qup*vmaup*vpata/qs*ts*mz**2*mta**2+4*qup*vmaup*
     &   vpata*mta**4+qup*vmaup*vpata*us*mta**2-qup*vmaup*vpata*ts*mta**2-
     &   qup*vpaup*vpata/qs*us*mz**2*mta**2+qup*vpaup*vpata/qs*ts*mz**2*mt
     &   a**2+4*qup*vpaup*vpata*mta**4-qup*vpaup*vpata*us*mta**2+qup*vpaup
     &   *vpata*ts*mta**2-8*stw**2*qup*vmaup*qta*ts*mta**2+2*stw**2*qup*vm
     &   aup*qta*ts*mz**2-2*stw**2*qup*vmaup*qta*qs*ts-8*stw**2*qup*vpaup*
     &   qta*us*mta**2+2*stw**2*qup*vpaup*qta*us*mz**2-2*stw**2*qup*vpaup*
     &   qta*qs*us-2*sdet3ctats*qup*vpaup*vpata/qs*mz**2*mta**2-4*sdet3cta
     &   ts*qup*vpaup*vpata*mta**2-4*sdet3ctats*stw**2*qup*vmaup*qta*mta**
     &   2-2*sdet3ctaus*qup*vmaup*vpata/qs*mz**2*mta**2-4*sdet3ctaus*qup*v
     &   maup*vpata*mta**2-4*sdet3ctaus*stw**2*qup*vpaup*qta*mta**2)
     &   +sdet4itatsus*c0tataqsctac*dreal(propizqs)*ifi*cfscheme*(8*stw**2
     &   *ctw**2*qup**2*qta*qs*mta**2)
     &   +sdet4itatsus*c0upupqszupc*dreal(propizqs)*ifi*(-qup*vmaup*vpata*
     &   mz**2*mta**2+qup*vmaup*vpata*qs*mta**2-qup*vpaup*vpata*mz**2*mta*
     &   *2+qup*vpaup*vpata*qs*mta**2+2*stw**2*qup*vmaup*qta*ts*mz**2-2*st
     &   w**2*qup*vmaup*qta*qs*ts+2*stw**2*qup*vpaup*qta*us*mz**2-2*stw**2
     &   *qup*vpaup*qta*qs*us)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(2*qup*vmaup*vpata*
     &   ts*mta**2+2*qup*vpaup*vpata*ts*mta**2-4*stw**2*qup*vmaup*qta*mta*
     &   *4-4*stw**2*qup*vpaup*qta*mta**4+2*sdet3ctats*qup*vpaup*vpata/qs*
     &   mz**2*mta**2+4*sdet3ctats*qup*vpaup*vpata*mta**2+8*sdet3ctats*stw
     &   **2*qup*vmaup*qta*mta**2-8*sdet3ctats*stw**2*qup*vmaup*qta*ts)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(2*qup*vmaup*vpata*
     &   us*mta**2+2*qup*vpaup*vpata*us*mta**2-4*stw**2*qup*vmaup*qta*mta*
     &   *4-4*stw**2*qup*vpaup*qta*mta**4+2*sdet3ctaus*qup*vmaup*vpata/qs*
     &   mz**2*mta**2+4*sdet3ctaus*qup*vmaup*vpata*mta**2+8*sdet3ctaus*stw
     &   **2*qup*vpaup*qta*mta**2-8*sdet3ctaus*stw**2*qup*vpaup*qta*us)
     &   +sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*cfscheme*(16*stw**2*ct
     &   w**2*qup**2*qta*mta**2)
     &   +sdet4itatsus*b0fqszc*dreal(propizqs)*ifi*(-2*qup*vmaup*vpata*mta
     &   **2-2*qup*vpaup*vpata*mta**2+4*stw**2*qup*vmaup*qta*ts+4*stw**2*q
     &   up*vpaup*qta*us)
     &   +sdet4itatsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(-4*sdet3ctats
     &   *stw**2*ctw**2*qup**2*qta-4*sdet3ctaus*stw**2*ctw**2*qup**2*qta)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(2*qup*vpaup*vpata*mta
     &   **2-4*stw**2*qup*vmaup*qta*ts)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*cfscheme*(-8*stw**2*ct
     &   w**2*qup**2*qta*mta**2+4*sdet3ctats*stw**2*ctw**2*qup**2*qta)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(2*qup*vmaup*vpata*mta
     &   **2-4*stw**2*qup*vpaup*qta*us)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*ifi*cfscheme*(-8*stw**2*ct
     &   w**2*qup**2*qta*mta**2+4*sdet3ctaus*stw**2*ctw**2*qup**2*qta)
     &   +javqstsuptaz*ifi*(-4*sdet3ctats*stw**2*qup*vmaup*qta+4*sdet3ctat
     &   s*stw**2*qup*vpaup*qta)
     &   +javqstsuptaz*dreal(propizqs)*ifi*(qup*vmaup*vpata/qs*mta**2+qup*
     &   vpaup*vpata/qs*mta**2+2*stw**2*qup*vmaup*qta/qs*mta**2+2*stw**2*q
     &   up*vpaup*qta/qs*mta**2)
     &   +javqsusuptaz*ifi*(4*sdet3ctaus*stw**2*qup*vmaup*qta-4*sdet3ctaus
     &   *stw**2*qup*vpaup*qta)
     &   +javqsusuptaz*dreal(propizqs)*ifi*(qup*vmaup*vpata/qs*mta**2+qup*
     &   vpaup*vpata/qs*mta**2+2*stw**2*qup*vmaup*qta/qs*mta**2+2*stw**2*q
     &   up*vpaup*qta/qs*mta**2)
     &   +c0irtataqs*fsr*(-4*stw**2*qta**2*mta**2-2*stw**2*qta**2*qs)
     &   +c0iruptats*ifi*(4*sdet3ctats*stw**2*qup*vmaup*qta-4*sdet3ctats*s
     &   tw**2*qup*vpaup*qta)
     &   +c0iruptaus*ifi*(-4*sdet3ctaus*stw**2*qup*vmaup*qta+4*sdet3ctaus*
     &   stw**2*qup*vpaup*qta)
     &   +c0irupupqs*isr*(-2*stw**2*qup**2*qs)
     &   +c0ctatsczta*ifi*(-4*sdet3ctats*stw**2*qup*vmaup*qta+4*sdet3ctats
     &   *stw**2*qup*vpaup*qta)
     &   +c0ctausczta*ifi*(4*sdet3ctaus*stw**2*qup*vmaup*qta-4*sdet3ctaus*
     &   stw**2*qup*vpaup*qta)
     &   +a0fup*isr*(-3*stw**2*qup**2)
     &   +a0fta*fsr*(-3*stw**2*qta**2)
     &   +b0fqstata*fsr*(-3*stw**2*qta**2)
     &   +b0fqscc*isr*(-3*stw**2*qup**2)
     &   +lnlatam*fsr*(2*stw**2*qta**2)
     &   +lnlaupm*isr*(2*stw**2*qup**2)

        ff_qed_qq =
     &   +fsr*(-stw**2*qta**2)
     &   +isr*(-stw**2*qup**2)
     &   +prop1zqs*c0irtataqs*fsr*cfscheme*(-4*qta**2/qs*mta**2-2*qta**2+4
     &   *stw**2*qta**2/qs*mta**2+2*stw**2*qta**2)
     &   +prop1zqs*c0irtaupts*ifi*cfscheme*(-4*sdet3ctats*ctw**2*qup*qta/q
     &   s)
     &   +prop1zqs*c0irtaupus*ifi*cfscheme*(4*sdet3ctaus*ctw**2*qup*qta/qs
     &   )
     &   +prop1zqs*c0irupupqs*isr*cfscheme*(-2*qup**2+2*stw**2*qup**2)
     &   +prop1zqs*lnlatam*fsr*cfscheme*(2*qta**2/qs-2*stw**2*qta**2/qs)
     &   +prop1zqs*lnlaupm*isr*cfscheme*(2*qup**2/qs-2*stw**2*qup**2/qs)
     &   +det3itataqs*fsr*(-1d0/2*qta*qs*mta**2)
     &   +det3itataqs*a0fta*fsr*(1d0/2*qta*qs*mta**2)
     &   +det3itataqs*b0fqstata*fsr*(1d0/2*qta*qs*mta**2)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(4*stw*
     &   *2*qup*qta*ts*mz**2*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*qta*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*qta*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*cfscheme*(
     &   4*ctw**2*qup*qta*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(-8*stw**2
     &   *qup*qta*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*cfscheme*(
     &   -4*ctw**2*qup*qta*ts*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(-2*qup*vp
     &   ata*mta**4)
     &   +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(-2*qup*vp
     &   ata*mta**4)
     &   +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*cfscheme*(
     &   -4*ctw**2*qup*qta*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(4*qup*vpa
     &   ta*mta**4)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*ifi*cfscheme*(
     &   4*ctw**2*qup*qta*us*mta**2)
     &   +sdet3ictaus*c0ctausczta*dreal(propizqs)*ifi*(-2*qup*vpata/qs*mz*
     &   *2*mta**2)
     &   +sdet4itatsus**2*jaaqstsupta*dreal(propizqs)*ifi*cfscheme*(sdet3c
     &   tats**3*ctw**2*qup*qta*mta**2-sdet3ctats**3*ctw**2*qup*qta*ts)
     &   +sdet4itatsus**2*jaaqsusupta*dreal(propizqs)*ifi*cfscheme*(-sdet3
     &   ctaus**3*ctw**2*qup*qta*mta**2+sdet3ctaus**3*ctw**2*qup*qta*ts)
     &   +sdet4itatsus**2*javqstsuptaz*dreal(propizqs)*ifi*(-2*sdet3ctats*
     &   stw**2*qup*qta*ts*mz**2*mta**2+2*sdet3ctats*stw**2*qup*qta*ts**2*
     &   mz**2-2*sdet3ctats*stw**2*qup*qta*qs*ts*mta**2+2*sdet3ctats*stw**
     &   2*qup*qta*qs*ts**2)
     &   +sdet4itatsus**2*javqsusuptaz*dreal(propizqs)*ifi*(sdet3ctaus*qup
     &   *vpata*mz**2*mta**4-sdet3ctaus*qup*vpata*us*mz**2*mta**2+sdet3cta
     &   us*qup*vpata*qs*mta**4-sdet3ctaus*qup*vpata*qs*us*mta**2)
     &   +sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*ifi*(-2*sdet3ctats*
     &   stw**2*qup*qta*mz**2*mta**4+4*sdet3ctats*stw**2*qup*qta*ts*mz**2*
     &   mta**2-2*sdet3ctats*stw**2*qup*qta*ts**2*mz**2-2*sdet3ctats*stw**
     &   2*qup*qta*qs*mta**4+4*sdet3ctats*stw**2*qup*qta*qs*ts*mta**2-2*sd
     &   et3ctats*stw**2*qup*qta*qs*ts**2-2*sdet3ctaus*qup*vpata*mz**2*mta
     &   **4+sdet3ctaus*qup*vpata*us*mz**2*mta**2+sdet3ctaus*qup*vpata*ts*
     &   mz**2*mta**2-2*sdet3ctaus*qup*vpata*qs*mta**4+sdet3ctaus*qup*vpat
     &   a*qs*us*mta**2+sdet3ctaus*qup*vpata*qs*ts*mta**2)
     &   +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*ifi*cfscheme*(4*ctw
     &   **2*qup*qta*qs*us*mta**4-4*ctw**2*qup*qta*qs*ts*mta**4-4*ctw**2*q
     &   up*qta*qs*ts*us*mta**2+4*ctw**2*qup*qta*qs*ts**2*mta**2+ctw**2*qu
     &   p*qta*qs**2*us*mta**2-ctw**2*qup*qta*qs**2*ts*mta**2-ctw**2*qup*q
     &   ta*qs**2*ts*us+ctw**2*qup*qta*qs**2*ts**2+8*sdet3ctats*ctw**2*qup
     &   *qta*qs*mta**4+2*sdet3ctats*ctw**2*qup*qta*qs**2*mta**2)
     &   +sdet4itatsus**2*c0upupqszupc*dreal(propizqs)*ifi*(2*sdet3ctats**
     &   2*stw**2*qup*qta*mz**2*mta**2-2*sdet3ctats**2*stw**2*qup*qta*ts*m
     &   z**2+2*sdet3ctats**2*stw**2*qup*qta*qs*mta**2-2*sdet3ctats**2*stw
     &   **2*qup*qta*qs*ts+sdet3ctaus*qup*vpata*us*mz**2*mta**2-sdet3ctaus
     &   *qup*vpata*ts*mz**2*mta**2+sdet3ctaus*qup*vpata*qs*us*mta**2-sdet
     &   3ctaus*qup*vpata*qs*ts*mta**2)
     &   +sdet4itatsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(ctw**
     &   2*qup*qta*qs**2*us*mta**2-ctw**2*qup*qta*qs**2*ts*mta**2-ctw**2*q
     &   up*qta*qs**2*ts*us+ctw**2*qup*qta*qs**2*ts**2)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*ifi*(-4*sdet3ctats*s
     &   tw**2*qup*qta*ts*mz**2*mta**2+4*sdet3ctats*stw**2*qup*qta*ts**2*m
     &   z**2-4*sdet3ctats*stw**2*qup*qta*qs*ts*mta**2+4*sdet3ctats*stw**2
     &   *qup*qta*qs*ts**2)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*ifi*(2*sdet3ctaus*qu
     &   p*vpata*mz**2*mta**4-2*sdet3ctaus*qup*vpata*us*mz**2*mta**2+2*sde
     &   t3ctaus*qup*vpata*qs*mta**4-2*sdet3ctaus*qup*vpata*qs*us*mta**2)
     &   +sdet4itatsus*jaaqstsupta*dreal(propizqs)*ifi*cfscheme*(sdet3ctat
     &   s*ctw**2*qup*qta*ts)
     &   +sdet4itatsus*jaaqsusupta*dreal(propizqs)*ifi*cfscheme*(-sdet3cta
     &   us*ctw**2*qup*qta*us)
     &   +sdet4itatsus*javqstsuptaz*dreal(propizqs)*ifi*(-qup*vpata*ts*mta
     &   **2+2*stw**2*qup*qta*mta**4-2*sdet3ctats*stw**2*qup*qta/qs*mz**2*
     &   mta**2-4*sdet3ctats*stw**2*qup*qta*mta**2+4*sdet3ctats*stw**2*qup
     &   *qta*ts)
     &   +sdet4itatsus*javqsusuptaz*dreal(propizqs)*ifi*(-qup*vpata*us*mta
     &   **2+2*stw**2*qup*qta*mta**4-sdet3ctaus*qup*vpata/qs*mz**2*mta**2-
     &   2*sdet3ctaus*qup*vpata*mta**2)
     &   +sdet4itatsus*c0tataqsztac*dreal(propizqs)*ifi*(-qup*vpata/qs*us*
     &   mz**2*mta**2+qup*vpata/qs*ts*mz**2*mta**2-4*qup*vpata*mta**4-qup*
     &   vpata*us*mta**2+qup*vpata*ts*mta**2+8*stw**2*qup*qta*ts*mta**2-2*
     &   stw**2*qup*qta*ts*mz**2+2*stw**2*qup*qta*qs*ts+4*sdet3ctats*stw**
     &   2*qup*qta*mta**2+2*sdet3ctaus*qup*vpata/qs*mz**2*mta**2+4*sdet3ct
     &   aus*qup*vpata*mta**2)
     &   +sdet4itatsus*c0tataqsctac*dreal(propizqs)*ifi*cfscheme*(-4*ctw**
     &   2*qup*qta*us*mta**2+4*ctw**2*qup*qta*ts*mta**2+2*ctw**2*qup*qta*q
     &   s*mta**2-ctw**2*qup*qta*qs*us+ctw**2*qup*qta*qs*ts)
     &   +sdet4itatsus*c0upupqszupc*dreal(propizqs)*ifi*(qup*vpata*mz**2*m
     &   ta**2-qup*vpata*qs*mta**2-2*stw**2*qup*qta*ts*mz**2+2*stw**2*qup*
     &   qta*qs*ts)
     &   +sdet4itatsus*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(-ctw**2*
     &   qup*qta*qs*us+ctw**2*qup*qta*qs*ts)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(-2*qup*vpata*ts*mt
     &   a**2+4*stw**2*qup*qta*mta**4-8*sdet3ctats*stw**2*qup*qta*mta**2+8
     &   *sdet3ctats*stw**2*qup*qta*ts)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(-2*qup*vpata*us*mt
     &   a**2+4*stw**2*qup*qta*mta**4-2*sdet3ctaus*qup*vpata/qs*mz**2*mta*
     &   *2-4*sdet3ctaus*qup*vpata*mta**2)
     &   +sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*cfscheme*(4*ctw**2*qup
     &   *qta*mta**2)
     &   +sdet4itatsus*b0fqszc*dreal(propizqs)*ifi*(2*qup*vpata*mta**2-4*s
     &   tw**2*qup*qta*ts)
     &   +sdet4itatsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(-2*sdet3ctats
     &   *ctw**2*qup*qta)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(4*stw**2*qup*qta*ts)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*cfscheme*(-2*ctw**2*qu
     &   p*qta*mta**2+2*sdet3ctats*ctw**2*qup*qta)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(-2*qup*vpata*mta**2)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*ifi*cfscheme*(-2*ctw**2*qu
     &   p*qta*mta**2)
     &   +jaaqstsupta*dreal(propizqs)*ifi*cfscheme*(2*sdet3ctats*ctw**2*qu
     &   p*qta/qs)
     &   +jaaqsusupta*dreal(propizqs)*ifi*cfscheme*(-2*sdet3ctaus*ctw**2*q
     &   up*qta/qs)
     &   +javqstsuptaz*ifi*(4*sdet3ctats*stw**2*qup*qta)
     &   +javqstsuptaz*dreal(propizqs)*ifi*(-qup*vpata/qs*mta**2-2*stw**2*
     &   qup*qta/qs*mta**2)
     &   +javqsusuptaz*ifi*(-4*sdet3ctaus*stw**2*qup*qta)
     &   +javqsusuptaz*dreal(propizqs)*ifi*(-qup*vpata/qs*mta**2-2*stw**2*
     &   qup*qta/qs*mta**2)
     &   +c0irtataqs*fsr*(-4*stw**2*qta**2*mta**2-2*stw**2*qta**2*qs)
     &   +c0iruptats*ifi*(-4*sdet3ctats*stw**2*qup*qta)
     &   +c0iruptaus*ifi*(4*sdet3ctaus*stw**2*qup*qta)
     &   +c0irupupqs*isr*(-2*stw**2*qup**2*qs)
     &   +c0ctatsczta*ifi*(4*sdet3ctats*stw**2*qup*qta)
     &   +c0ctausczta*ifi*(-4*sdet3ctaus*stw**2*qup*qta)
     &   +a0fup*isr*(-3*stw**2*qup**2)
     &   +a0fup*dreal(propizqs)*isr*cfscheme*(-3*qup**2/qs+3*stw**2*qup**2
     &   /qs)
     &   +a0fta*fsr*(-3*stw**2*qta**2)
     &   +a0fta*dreal(propizqs)*fsr*cfscheme*(-3*qta**2/qs+3*stw**2*qta**2
     &   /qs)
     &   +b0fqstata*fsr*(-3*stw**2*qta**2)
     &   +b0fqstata*dreal(propizqs)*fsr*cfscheme*(-3*qta**2/qs+3*stw**2*qt
     &   a**2/qs)
     &   +b0fqscc*isr*(-3*stw**2*qup**2)
     &   +b0fqscc*dreal(propizqs)*isr*cfscheme*(-3*qup**2/qs+3*stw**2*qup*
     &   *2/qs)
     &   +lnlatam*fsr*(2*stw**2*qta**2)
     &   +lnlaupm*isr*(2*stw**2*qup**2)
     &   +dreal(propizqs)*fsr*cfscheme*(-qta**2/qs+stw**2*qta**2/qs)
     &   +dreal(propizqs)*isr*cfscheme*(-qup**2/qs+stw**2*qup**2/qs)

        ff_qed_ld =
     &   +det3itataqs*fsr*(1d0/2*stw**2*qta**2*qs+stw**2*qta**2*vpata*qs)
     &   +det3itataqs*sdet4itatsus*c0tataqsztac*dreal(propizqs)*ifi*(4*stw
     &   **2*qup*vmaup*qta*vmata*qs*mta**4-stw**2*qup*vmaup*qta*vmata*qs*m
     &   z**2*mta**2-4*stw**2*qup*vmaup*qta*vmata*qs*ts*mta**2+stw**2*qup*
     &   vmaup*qta*vmata*qs*ts*mz**2-4*stw**2*qup*vmaup*qta*vpata*qs*mta**
     &   4+stw**2*qup*vmaup*qta*vpata*qs*mz**2*mta**2+4*stw**2*qup*vmaup*q
     &   ta*vpata*qs*us*mta**2-stw**2*qup*vmaup*qta*vpata*qs*us*mz**2+4*st
     &   w**2*qup*vpaup*qta*vmata*qs*mta**4-stw**2*qup*vpaup*qta*vmata*qs*
     &   mz**2*mta**2-4*stw**2*qup*vpaup*qta*vmata*qs*us*mta**2+stw**2*qup
     &   *vpaup*qta*vmata*qs*us*mz**2-4*stw**2*qup*vpaup*qta*vpata*qs*mta*
     &   *4+stw**2*qup*vpaup*qta*vpata*qs*mz**2*mta**2+4*stw**2*qup*vpaup*
     &   qta*vpata*qs*ts*mta**2-stw**2*qup*vpaup*qta*vpata*qs*ts*mz**2)
     &   +det3itataqs*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(stw**2*qu
     &   p*vmaup*qta*vmata*qs*mta**2-stw**2*qup*vmaup*qta*vmata*qs*ts-stw*
     &   *2*qup*vmaup*qta*vpata*qs*mta**2+stw**2*qup*vmaup*qta*vpata*qs*us
     &   +stw**2*qup*vpaup*qta*vmata*qs*mta**2-stw**2*qup*vpaup*qta*vmata*
     &   qs*us-stw**2*qup*vpaup*qta*vpata*qs*mta**2+stw**2*qup*vpaup*qta*v
     &   pata*qs*ts)
     &   +det3itataqs*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(stw**2*qu
     &   p*vmaup*qta*vmata*qs*mta**2-stw**2*qup*vmaup*qta*vmata*qs*ts-stw*
     &   *2*qup*vmaup*qta*vpata*qs*mta**2+stw**2*qup*vmaup*qta*vpata*qs*us
     &   +stw**2*qup*vpaup*qta*vmata*qs*mta**2-stw**2*qup*vpaup*qta*vmata*
     &   qs*us-stw**2*qup*vpaup*qta*vpata*qs*mta**2+stw**2*qup*vpaup*qta*v
     &   pata*qs*ts)
     &   +det3itataqs*sdet4itatsus*b0fqszc*dreal(propizqs)*ifi*(-2*stw**2*
     &   qup*vmaup*qta*vmata*qs*mta**2+2*stw**2*qup*vmaup*qta*vmata*qs*ts+
     &   2*stw**2*qup*vmaup*qta*vpata*qs*mta**2-2*stw**2*qup*vmaup*qta*vpa
     &   ta*qs*us-2*stw**2*qup*vpaup*qta*vmata*qs*mta**2+2*stw**2*qup*vpau
     &   p*qta*vmata*qs*us+2*stw**2*qup*vpaup*qta*vpata*qs*mta**2-2*stw**2
     &   *qup*vpaup*qta*vpata*qs*ts)
     &   +det3itataqs*a0fta*fsr*(-1d0/2*stw**2*qta**2*qs-stw**2*qta**2*vpa
     &   ta*qs)
     &   +det3itataqs*b0fqstata*fsr*(-1d0/2*stw**2*qta**2*qs-stw**2*qta**2
     &   *vpata*qs)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(4*stw*
     &   *2*qup*vmaup*qta*vmata*ts*mz**2-4*stw**2*qup*vpaup*qta*vpata*ts*m
     &   z**2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*vmaup*qta*vmata*ts-4*stw**2*qup*vpaup*qta*vpata*ts)
     &   +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*vmaup*qta*vmata*ts-4*stw**2*qup*vpaup*qta*vpata*ts)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(-8*stw**2
     &   *qup*vmaup*qta*vmata*ts+8*stw**2*qup*vpaup*qta*vpata*ts)
     &   +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(-4*stw
     &   **2*qup*vmaup*qta*vpata*us*mz**2+4*stw**2*qup*vpaup*qta*vmata*us*
     &   mz**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(-4*stw**2
     &   *qup*vmaup*qta*vpata*us+4*stw**2*qup*vpaup*qta*vmata*us)
     &   +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(-4*stw**2
     &   *qup*vmaup*qta*vpata*us+4*stw**2*qup*vpaup*qta*vmata*us)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(8*stw**2*
     &   qup*vmaup*qta*vpata*us-8*stw**2*qup*vpaup*qta*vmata*us)
     &   +sdet4itatsus**2*javqstsuptaz*dreal(propizqs)*ifi*(-4*sdet3ctats*
     &   stw**2*qup*vmaup*qta*vmata*ts*mz**2-4*sdet3ctats*stw**2*qup*vmaup
     &   *qta*vmata*qs*ts+4*sdet3ctats*stw**2*qup*vpaup*qta*vpata*ts*mz**2
     &   +4*sdet3ctats*stw**2*qup*vpaup*qta*vpata*qs*ts)
     &   +sdet4itatsus**2*javqsusuptaz*dreal(propizqs)*ifi*(4*sdet3ctaus*s
     &   tw**2*qup*vmaup*qta*vpata*us*mz**2+4*sdet3ctaus*stw**2*qup*vmaup*
     &   qta*vpata*qs*us-4*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*us*mz**2-
     &   4*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*qs*us)
     &   +sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*ifi*(-4*sdet3ctats*
     &   stw**2*qup*vmaup*qta*vmata*mz**2*mta**2+4*sdet3ctats*stw**2*qup*v
     &   maup*qta*vmata*ts*mz**2-4*sdet3ctats*stw**2*qup*vmaup*qta*vmata*q
     &   s*mta**2+4*sdet3ctats*stw**2*qup*vmaup*qta*vmata*qs*ts+4*sdet3cta
     &   ts*stw**2*qup*vpaup*qta*vpata*mz**2*mta**2-4*sdet3ctats*stw**2*qu
     &   p*vpaup*qta*vpata*ts*mz**2+4*sdet3ctats*stw**2*qup*vpaup*qta*vpat
     &   a*qs*mta**2-4*sdet3ctats*stw**2*qup*vpaup*qta*vpata*qs*ts+4*sdet3
     &   ctaus*stw**2*qup*vmaup*qta*vpata*mz**2*mta**2-4*sdet3ctaus*stw**2
     &   *qup*vmaup*qta*vpata*us*mz**2+4*sdet3ctaus*stw**2*qup*vmaup*qta*v
     &   pata*qs*mta**2-4*sdet3ctaus*stw**2*qup*vmaup*qta*vpata*qs*us-4*sd
     &   et3ctaus*stw**2*qup*vpaup*qta*vmata*mz**2*mta**2+4*sdet3ctaus*stw
     &   **2*qup*vpaup*qta*vmata*us*mz**2-4*sdet3ctaus*stw**2*qup*vpaup*qt
     &   a*vmata*qs*mta**2+4*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*qs*us)
     &   +sdet4itatsus**2*c0upupqszupc*dreal(propizqs)*ifi*(4*sdet3ctats**
     &   2*stw**2*qup*vmaup*qta*vmata*mz**2+4*sdet3ctats**2*stw**2*qup*vma
     &   up*qta*vmata*qs-4*sdet3ctats**2*stw**2*qup*vpaup*qta*vpata*mz**2-
     &   4*sdet3ctats**2*stw**2*qup*vpaup*qta*vpata*qs-4*sdet3ctaus**2*stw
     &   **2*qup*vmaup*qta*vpata*mz**2-4*sdet3ctaus**2*stw**2*qup*vmaup*qt
     &   a*vpata*qs+4*sdet3ctaus**2*stw**2*qup*vpaup*qta*vmata*mz**2+4*sde
     &   t3ctaus**2*stw**2*qup*vpaup*qta*vmata*qs)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*ifi*(-8*sdet3ctats*s
     &   tw**2*qup*vmaup*qta*vmata*ts*mz**2-8*sdet3ctats*stw**2*qup*vmaup*
     &   qta*vmata*qs*ts+8*sdet3ctats*stw**2*qup*vpaup*qta*vpata*ts*mz**2+
     &   8*sdet3ctats*stw**2*qup*vpaup*qta*vpata*qs*ts)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*ifi*(8*sdet3ctaus*st
     &   w**2*qup*vmaup*qta*vpata*us*mz**2+8*sdet3ctaus*stw**2*qup*vmaup*q
     &   ta*vpata*qs*us-8*sdet3ctaus*stw**2*qup*vpaup*qta*vmata*us*mz**2-8
     &   *sdet3ctaus*stw**2*qup*vpaup*qta*vmata*qs*us)
     &   +sdet4itatsus*javqstsuptaz*dreal(propizqs)*ifi*(-2*sdet3ctats*stw
     &   **2*qup*vmaup*qta*vmata/qs*mz**2-4*sdet3ctats*stw**2*qup*vmaup*qt
     &   a*vmata+2*sdet3ctats*stw**2*qup*vpaup*qta*vpata/qs*mz**2+4*sdet3c
     &   tats*stw**2*qup*vpaup*qta*vpata+2*sdet3ctats**2*stw**2*qup*vmaup*
     &   qta*vmata/qs-2*sdet3ctats**2*stw**2*qup*vmaup*qta*vpata/qs+2*sdet
     &   3ctats**2*stw**2*qup*vpaup*qta*vmata/qs-2*sdet3ctats**2*stw**2*qu
     &   p*vpaup*qta*vpata/qs)
     &   +sdet4itatsus*javqsusuptaz*dreal(propizqs)*ifi*(2*sdet3ctaus*stw*
     &   *2*qup*vmaup*qta*vpata/qs*mz**2+4*sdet3ctaus*stw**2*qup*vmaup*qta
     &   *vpata-2*sdet3ctaus*stw**2*qup*vpaup*qta*vmata/qs*mz**2-4*sdet3ct
     &   aus*stw**2*qup*vpaup*qta*vmata+2*sdet3ctaus**2*stw**2*qup*vmaup*q
     &   ta*vmata/qs-2*sdet3ctaus**2*stw**2*qup*vmaup*qta*vpata/qs+2*sdet3
     &   ctaus**2*stw**2*qup*vpaup*qta*vmata/qs-2*sdet3ctaus**2*stw**2*qup
     &   *vpaup*qta*vpata/qs)
     &   +sdet4itatsus*c0tataqsztac*dreal(propizqs)*ifi*(-2*stw**2*qup*vma
     &   up*qta*vmata*mz**2-2*stw**2*qup*vmaup*qta*vmata*qs+2*stw**2*qup*v
     &   maup*qta*vpata*mz**2+2*stw**2*qup*vmaup*qta*vpata*qs-2*stw**2*qup
     &   *vpaup*qta*vmata*mz**2-2*stw**2*qup*vpaup*qta*vmata*qs+2*stw**2*q
     &   up*vpaup*qta*vpata*mz**2+2*stw**2*qup*vpaup*qta*vpata*qs)
     &   +sdet4itatsus*c0upupqszupc*dreal(propizqs)*ifi*(2*stw**2*qup*vmau
     &   p*qta*vmata*mz**2-2*stw**2*qup*vmaup*qta*vmata*qs-2*stw**2*qup*vm
     &   aup*qta*vpata*mz**2+2*stw**2*qup*vmaup*qta*vpata*qs+2*stw**2*qup*
     &   vpaup*qta*vmata*mz**2-2*stw**2*qup*vpaup*qta*vmata*qs-2*stw**2*qu
     &   p*vpaup*qta*vpata*mz**2+2*stw**2*qup*vpaup*qta*vpata*qs)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(-4*stw**2*qup*vmau
     &   p*qta*vmata*ts+4*stw**2*qup*vmaup*qta*vpata*ts-4*stw**2*qup*vpaup
     &   *qta*vmata*ts+4*stw**2*qup*vpaup*qta*vpata*ts-8*sdet3ctats*stw**2
     &   *qup*vmaup*qta*vmata+8*sdet3ctats*stw**2*qup*vpaup*qta*vpata)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(-4*stw**2*qup*vmau
     &   p*qta*vmata*us+4*stw**2*qup*vmaup*qta*vpata*us-4*stw**2*qup*vpaup
     &   *qta*vmata*us+4*stw**2*qup*vpaup*qta*vpata*us+8*sdet3ctaus*stw**2
     &   *qup*vmaup*qta*vpata-8*sdet3ctaus*stw**2*qup*vpaup*qta*vmata)

        ff_qed_qd =
     &   +det3itataqs*fsr*(1d0/2*stw**2*qta**2*qs+stw**2*qta**2*vpata*qs)
     &   +det3itataqs*sdet4itatsus*c0tataqsztac*dreal(propizqs)*ifi*(-4*st
     &   w**2*qup*qta*vmata*qs*mta**4+stw**2*qup*qta*vmata*qs*mz**2*mta**2
     &   +4*stw**2*qup*qta*vmata*qs*ts*mta**2-stw**2*qup*qta*vmata*qs*ts*m
     &   z**2+4*stw**2*qup*qta*vpata*qs*mta**4-stw**2*qup*qta*vpata*qs*mz*
     &   *2*mta**2-4*stw**2*qup*qta*vpata*qs*us*mta**2+stw**2*qup*qta*vpat
     &   a*qs*us*mz**2)
     &   +det3itataqs*sdet4itatsus*c0tataqsctac*dreal(propizqs)*ifi*cfsche
     &   me*(4*stw**2*ctw**2*qup*qta**2*qs*us*mta**2-4*stw**2*ctw**2*qup*q
     &   ta**2*qs*ts*mta**2)
     &   +det3itataqs*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(-stw**2*q
     &   up*qta*vmata*qs*mta**2+stw**2*qup*qta*vmata*qs*ts+stw**2*qup*qta*
     &   vpata*qs*mta**2-stw**2*qup*qta*vpata*qs*us)
     &   +det3itataqs*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(-stw**2*q
     &   up*qta*vmata*qs*mta**2+stw**2*qup*qta*vmata*qs*ts+stw**2*qup*qta*
     &   vpata*qs*mta**2-stw**2*qup*qta*vpata*qs*us)
     &   +det3itataqs*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*cfscheme*(
     &   2*stw**2*ctw**2*qup*qta**2*qs*us-2*stw**2*ctw**2*qup*qta**2*qs*ts
     &   )
     &   +det3itataqs*sdet4itatsus*b0fqszc*dreal(propizqs)*ifi*(2*stw**2*q
     &   up*qta*vmata*qs*mta**2-2*stw**2*qup*qta*vmata*qs*ts-2*stw**2*qup*
     &   qta*vpata*qs*mta**2+2*stw**2*qup*qta*vpata*qs*us)
     &   +det3itataqs*sdet4itatsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(-
     &   2*stw**2*ctw**2*qup*qta**2*qs*us+2*stw**2*ctw**2*qup*qta**2*qs*ts
     &   )
     &   +det3itataqs*a0fta*fsr*(-1d0/2*stw**2*qta**2*qs-stw**2*qta**2*vpa
     &   ta*qs)
     &   +det3itataqs*a0fta*dreal(propizqs)*fsr*cfscheme*(2*stw**2*ctw**2*
     &   qta**3)
     &   +det3itataqs*b0fqstata*fsr*(-1d0/2*stw**2*qta**2*qs-stw**2*qta**2
     &   *vpata*qs)
     &   +det3itataqs*b0fqstata*dreal(propizqs)*fsr*cfscheme*(2*stw**2*ctw
     &   **2*qta**3)
     &   +det3itataqs*dreal(propizqs)*fsr*cfscheme*(-2*stw**2*ctw**2*qta**
     &   3)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(-4*stw
     &   **2*qup*qta*vmata*ts*mz**2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(-4*stw**2
     &   *qup*qta*vmata*ts)
     &   +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(-4*stw**2
     &   *qup*qta*vmata*ts)
     &   +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*cfscheme*(
     &   8*stw**2*ctw**2*qup*qta**2*ts)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*(8*stw**2*
     &   qup*qta*vmata*ts)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*ifi*cfscheme*(
     &   -8*stw**2*ctw**2*qup*qta**2*ts)
     &   +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(4*stw*
     &   *2*qup*qta*vpata*us*mz**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*qta*vpata*us)
     &   +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*(4*stw**2*
     &   qup*qta*vpata*us)
     &   +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*ifi*cfscheme*(
     &   -8*stw**2*ctw**2*qup*qta**2*us)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*ifi*(-8*stw**2
     &   *qup*qta*vpata*us)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*ifi*cfscheme*(
     &   8*stw**2*ctw**2*qup*qta**2*us)
     &   +sdet4itatsus**2*jaaqstsupta*dreal(propizqs)*ifi*cfscheme*(4*sdet
     &   3ctats**3*stw**2*ctw**2*qup*qta**2)
     &   +sdet4itatsus**2*jaaqsusupta*dreal(propizqs)*ifi*cfscheme*(-4*sde
     &   t3ctaus**3*stw**2*ctw**2*qup*qta**2)
     &   +sdet4itatsus**2*javqstsuptaz*dreal(propizqs)*ifi*(4*sdet3ctats*s
     &   tw**2*qup*qta*vmata*ts*mz**2+4*sdet3ctats*stw**2*qup*qta*vmata*qs
     &   *ts)
     &   +sdet4itatsus**2*javqsusuptaz*dreal(propizqs)*ifi*(-4*sdet3ctaus*
     &   stw**2*qup*qta*vpata*us*mz**2-4*sdet3ctaus*stw**2*qup*qta*vpata*q
     &   s*us)
     &   +sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*ifi*(4*sdet3ctats*s
     &   tw**2*qup*qta*vmata*mz**2*mta**2-4*sdet3ctats*stw**2*qup*qta*vmat
     &   a*ts*mz**2+4*sdet3ctats*stw**2*qup*qta*vmata*qs*mta**2-4*sdet3cta
     &   ts*stw**2*qup*qta*vmata*qs*ts-4*sdet3ctaus*stw**2*qup*qta*vpata*m
     &   z**2*mta**2+4*sdet3ctaus*stw**2*qup*qta*vpata*us*mz**2-4*sdet3cta
     &   us*stw**2*qup*qta*vpata*qs*mta**2+4*sdet3ctaus*stw**2*qup*qta*vpa
     &   ta*qs*us)
     &   +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*ifi*cfscheme*(8*stw
     &   **2*ctw**2*qup*qta**2*qs*us*mta**2-8*stw**2*ctw**2*qup*qta**2*qs*
     &   ts*mta**2+4*stw**2*ctw**2*qup*qta**2*qs**2*us-4*stw**2*ctw**2*qup
     &   *qta**2*qs**2*ts)
     &   +sdet4itatsus**2*c0upupqszupc*dreal(propizqs)*ifi*(-4*sdet3ctats*
     &   *2*stw**2*qup*qta*vmata*mz**2-4*sdet3ctats**2*stw**2*qup*qta*vmat
     &   a*qs+4*sdet3ctaus**2*stw**2*qup*qta*vpata*mz**2+4*sdet3ctaus**2*s
     &   tw**2*qup*qta*vpata*qs)
     &   +sdet4itatsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(4*stw
     &   **2*ctw**2*qup*qta**2*qs**2*us-4*stw**2*ctw**2*qup*qta**2*qs**2*t
     &   s)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*ifi*(8*sdet3ctats*st
     &   w**2*qup*qta*vmata*ts*mz**2+8*sdet3ctats*stw**2*qup*qta*vmata*qs*
     &   ts)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*ifi*(-8*sdet3ctaus*s
     &   tw**2*qup*qta*vpata*us*mz**2-8*sdet3ctaus*stw**2*qup*qta*vpata*qs
     &   *us)
     &   +sdet4itatsus*javqstsuptaz*dreal(propizqs)*ifi*(2*sdet3ctats*stw*
     &   *2*qup*qta*vmata/qs*mz**2+4*sdet3ctats*stw**2*qup*qta*vmata-2*sde
     &   t3ctats**2*stw**2*qup*qta*vmata/qs+2*sdet3ctats**2*stw**2*qup*qta
     &   *vpata/qs)
     &   +sdet4itatsus*javqsusuptaz*dreal(propizqs)*ifi*(-2*sdet3ctaus*stw
     &   **2*qup*qta*vpata/qs*mz**2-4*sdet3ctaus*stw**2*qup*qta*vpata-2*sd
     &   et3ctaus**2*stw**2*qup*qta*vmata/qs+2*sdet3ctaus**2*stw**2*qup*qt
     &   a*vpata/qs)
     &   +sdet4itatsus*c0tataqsztac*dreal(propizqs)*ifi*(2*stw**2*qup*qta*
     &   vmata*mz**2+2*stw**2*qup*qta*vmata*qs-2*stw**2*qup*qta*vpata*mz**
     &   2-2*stw**2*qup*qta*vpata*qs)
     &   +sdet4itatsus*c0upupqszupc*dreal(propizqs)*ifi*(-2*stw**2*qup*qta
     &   *vmata*mz**2+2*stw**2*qup*qta*vmata*qs+2*stw**2*qup*qta*vpata*mz*
     &   *2-2*stw**2*qup*qta*vpata*qs)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*ifi*(4*stw**2*qup*qta*v
     &   mata*ts-4*stw**2*qup*qta*vpata*ts+8*sdet3ctats*stw**2*qup*qta*vma
     &   ta)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*ifi*(4*stw**2*qup*qta*v
     &   mata*us-4*stw**2*qup*qta*vpata*us-8*sdet3ctaus*stw**2*qup*qta*vpa
     &   ta)

        ff_ew_ll =
     &   +sdet3itataqs*c0tataqswcw*dreal(propizqs)*(-7d0/2*mw**2*rtaw*rwz+
     &   3*mw**2*rtaw**2*rwz+1d0/2*mw**2*rtaw**3*rwz)
     &   +sdet3itataqs*c0tataqswcw*(2*mw**4*rwz+11*mw**4*rtaw*rwz-26*mw**4
     &   *rtaw**2*rwz+11*mw**4*rtaw**3*rwz+2*mw**4*rtaw**4*rwz)
     &   +sdet3itataqs*c0tataqsztah*(-3d0/4*mw**4*rtaw/rwz**2-1d0/2*mw**4*
     &   rtaw/rwz*rhw+1d0/4*mw**4*rtaw*rhw**2+2*mw**4*rtaw**2/rwz-2*mw**4*
     &   rtaw**2*rhw+4*mw**4*rtaw**3)
     &   +sdet3itataqs*c0tataqstazta*(-7d0/2*mw**4/rwz**3+9*mw**4/rwz**2-6
     &   *mw**4/rwz-55d0/4*mw**4*rtaw/rwz**2+36*mw**4*rtaw/rwz-24*mw**4*rt
     &   aw)
     &   +sdet3itataqs*c0tataqstahta*(1d0/4*mw**4*rtaw*rhw**2-2*mw**4*rtaw
     &   **2*rhw)
     &   +sdet3itataqs*c0tataqscwc*(mw**4+11d0/2*mw**4*rtaw+6*mw**4*rtaw**
     &   2+3d0/2*mw**4*rtaw**3)
     &   +sdet3itataqs*b0ftawc*dreal(propizqs)*(2*rtaw*rwz)
     &   +sdet3itataqs*b0ftawc*(mw**2-2*mw**2*rwz+6*mw**2*rtaw-13*mw**2*rt
     &   aw*rwz+2*mw**2*rtaw**2+7*mw**2*rtaw**2*rwz)
     &   +sdet3itataqs*b0ftazta*(-7d0/2*mw**2/rwz**2+9*mw**2/rwz-6*mw**2-1
     &   3*mw**2*rtaw/rwz+36*mw**2*rtaw-1d0/4*mw**2*rtaw*rhw-24*mw**2*rtaw
     &   *rwz+mw**2*rtaw**2)
     &   +sdet3itataqs*b0ftahta*(3d0/4*mw**2*rtaw/rwz-mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqsww*dreal(propizqs)*(-7d0/2*rtaw*rwz-1d0/2*rtaw
     &   **2*rwz)
     &   +sdet3itataqs*b0fqsww*(2*mw**2*rwz+13*mw**2*rtaw*rwz-13*mw**2*rta
     &   w**2*rwz-2*mw**2*rtaw**3*rwz)
     &   +sdet3itataqs*b0fqszh*(-3d0/2*mw**2*rtaw/rwz+1d0/2*mw**2*rtaw*rhw
     &   -2*mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqstata*(7d0/2*mw**2/rwz**2-9*mw**2/rwz+6*mw**2+5
     &   5d0/4*mw**2*rtaw/rwz-36*mw**2*rtaw-1d0/4*mw**2*rtaw*rhw+24*mw**2*
     &   rtaw*rwz+2*mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqscc*(-mw**2-9d0/2*mw**2*rtaw-3d0/2*mw**2*rtaw**
     &   2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup**2*vmata**2*mta**4-1d0/ctw**2*vmaup**2*vmata**2*ts*mta**2-1d
     &   0/ctw**2*vpaup**2*vpata**2*mta**4-1d0/ctw**2*vpaup**2*vpata**2*ts
     &   *mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup**2*vmata**2*mta**4+1d0/ctw**2*vmaup**2*vmata**2*ts*mta**2+1d0
     &   /ctw**2*vpaup**2*vpata**2*mta**4+1d0/ctw**2*vpaup**2*vpata**2*ts*
     &   mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup**2*vpata**2*mta**4-1d0/ctw**2*vmaup**2*vpata**2*us*mta**2-1d
     &   0/ctw**2*vpaup**2*vmata**2*mta**4-1d0/ctw**2*vpaup**2*vmata**2*us
     &   *mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup**2*vpata**2*mta**4+1d0/ctw**2*vmaup**2*vpata**2*us*mta**2+1d0
     &   /ctw**2*vpaup**2*vmata**2*mta**4+1d0/ctw**2*vpaup**2*vmata**2*us*
     &   mta**2)
     &   +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(-
     &   1d0/4/ctw**2*vmaup**2*vmata**2*us*mta**4+1d0/4/ctw**2*vmaup**2*vm
     &   ata**2*ts*mta**4-1d0/4/ctw**2*vpaup**2*vpata**2*us*mta**4+1d0/4/c
     &   tw**2*vpaup**2*vpata**2*ts*mta**4-1d0/4*sdet3ctats/ctw**2*vmaup**
     &   2*vmata**2*mta**4+1d0/4*sdet3ctats/ctw**2*vmaup**2*vmata**2*ts*mt
     &   a**2-1d0/4*sdet3ctats/ctw**2*vpaup**2*vpata**2*mta**4+1d0/4*sdet3
     &   ctats/ctw**2*vpaup**2*vpata**2*ts*mta**2-sdet3ctats**2/ctw**2*vma
     &   up**2*vmata**2*mta**2-1d0/4*sdet3ctats**2/ctw**2*vmaup**2*vmata**
     &   2*qs-sdet3ctats**2/ctw**2*vpaup**2*vpata**2*mta**2-1d0/4*sdet3cta
     &   ts**2/ctw**2*vpaup**2*vpata**2*qs)
     &   +sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(1
     &   d0/4/ctw**2*vmaup**2*vpata**2*us*mta**4-1d0/4/ctw**2*vmaup**2*vpa
     &   ta**2*ts*mta**4+1d0/4/ctw**2*vpaup**2*vmata**2*us*mta**4-1d0/4/ct
     &   w**2*vpaup**2*vmata**2*ts*mta**4-1d0/4*sdet3ctaus/ctw**2*vmaup**2
     &   *vpata**2*mta**4+1d0/4*sdet3ctaus/ctw**2*vmaup**2*vpata**2*us*mta
     &   **2-1d0/4*sdet3ctaus/ctw**2*vpaup**2*vmata**2*mta**4+1d0/4*sdet3c
     &   taus/ctw**2*vpaup**2*vmata**2*us*mta**2-sdet3ctaus**2/ctw**2*vmau
     &   p**2*vpata**2*mta**2-1d0/4*sdet3ctaus**2/ctw**2*vmaup**2*vpata**2
     &   *qs-sdet3ctaus**2/ctw**2*vpaup**2*vmata**2*mta**2-1d0/4*sdet3ctau
     &   s**2/ctw**2*vpaup**2*vmata**2*qs)
     &   +sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(-sdet3cta
     &   ts/ctw**2*vmaup**2*vmata**2*mta**4-sdet3ctats/ctw**2*vmaup**2*vma
     &   ta**2*ts*mta**2-1d0/4*sdet3ctats/ctw**2*vmaup**2*vmata**2*qs*mta*
     &   *2-1d0/4*sdet3ctats/ctw**2*vmaup**2*vmata**2*qs*ts-sdet3ctats/ctw
     &   **2*vpaup**2*vpata**2*mta**4-sdet3ctats/ctw**2*vpaup**2*vpata**2*
     &   ts*mta**2-1d0/4*sdet3ctats/ctw**2*vpaup**2*vpata**2*qs*mta**2-1d0
     &   /4*sdet3ctats/ctw**2*vpaup**2*vpata**2*qs*ts-sdet3ctaus/ctw**2*vm
     &   aup**2*vpata**2*mta**4-sdet3ctaus/ctw**2*vmaup**2*vpata**2*us*mta
     &   **2-1d0/4*sdet3ctaus/ctw**2*vmaup**2*vpata**2*qs*mta**2-1d0/4*sde
     &   t3ctaus/ctw**2*vmaup**2*vpata**2*qs*us-sdet3ctaus/ctw**2*vpaup**2
     &   *vmata**2*mta**4-sdet3ctaus/ctw**2*vpaup**2*vmata**2*us*mta**2-1d
     &   0/4*sdet3ctaus/ctw**2*vpaup**2*vmata**2*qs*mta**2-1d0/4*sdet3ctau
     &   s/ctw**2*vpaup**2*vmata**2*qs*us)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(1d0/2*sdet
     &   3ctats/ctw**2*vmaup**2*vmata**2*mta**4-1d0/2*sdet3ctats/ctw**2*vm
     &   aup**2*vmata**2*ts**2+1d0/2*sdet3ctats/ctw**2*vpaup**2*vpata**2*m
     &   ta**4-1d0/2*sdet3ctats/ctw**2*vpaup**2*vpata**2*ts**2)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*pxx2zqsc*(1d0/2*sdet
     &   3ctaus/ctw**2*vmaup**2*vpata**2*mta**4-1d0/2*sdet3ctaus/ctw**2*vm
     &   aup**2*vpata**2*us**2+1d0/2*sdet3ctaus/ctw**2*vpaup**2*vmata**2*m
     &   ta**4-1d0/2*sdet3ctaus/ctw**2*vpaup**2*vmata**2*us**2)
     &   +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2
     &   *vmaup**2*vmata**2*qs*mta**4-1d0/4/ctw**2*vmaup**2*vmata**2*qs*ts
     &   *mta**2+1d0/4/ctw**2*vmaup**2*vpata**2*qs*mta**4-1d0/4/ctw**2*vma
     &   up**2*vpata**2*qs*us*mta**2+1d0/4/ctw**2*vpaup**2*vmata**2*qs*mta
     &   **4-1d0/4/ctw**2*vpaup**2*vmata**2*qs*us*mta**2+1d0/4/ctw**2*vpau
     &   p**2*vpata**2*qs*mta**4-1d0/4/ctw**2*vpaup**2*vpata**2*qs*ts*mta*
     &   *2-1d0/4*sdet3ctats**2/ctw**2*vmaup**2*vmata**2*mta**2+1d0/4*sdet
     &   3ctats**2/ctw**2*vmaup**2*vmata**2*ts-1d0/4*sdet3ctats**2/ctw**2*
     &   vpaup**2*vpata**2*mta**2+1d0/4*sdet3ctats**2/ctw**2*vpaup**2*vpat
     &   a**2*ts-1d0/4*sdet3ctaus**2/ctw**2*vmaup**2*vpata**2*mta**2+1d0/4
     &   *sdet3ctaus**2/ctw**2*vmaup**2*vpata**2*us-1d0/4*sdet3ctaus**2/ct
     &   w**2*vpaup**2*vmata**2*mta**2+1d0/4*sdet3ctaus**2/ctw**2*vpaup**2
     &   *vmata**2*us)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(-1d0
     &   /2/ctw**2*vmaup**2*vmata**2*mta**2-1d0/2/ctw**2*vpaup**2*vpata**2
     &   *mta**2-1d0/8*sdet3ctats/ctw**2*vmaup**2*vmata**2-1d0/8*sdet3ctat
     &   s/ctw**2*vpaup**2*vpata**2)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc*(-3d0/4/
     &   ctw**2*vmaup**2*vmata**2*mta**4+3d0/4/ctw**2*vmaup**2*vmata**2*ts
     &   **2+1d0/4/ctw**2*vmaup**2*vmata**2*qs*mta**2+1d0/2/ctw**2*vmaup**
     &   2*vpata*vmata*mta**4+1d0/2/ctw**2*vmaup**2*vpata*vmata*ts*mta**2+
     &   1d0/2/ctw**2*vpaup**2*vpata*vmata*mta**4+1d0/2/ctw**2*vpaup**2*vp
     &   ata*vmata*ts*mta**2-3d0/4/ctw**2*vpaup**2*vpata**2*mta**4+3d0/4/c
     &   tw**2*vpaup**2*vpata**2*ts**2+1d0/4/ctw**2*vpaup**2*vpata**2*qs*m
     &   ta**2+sdet3ctats/ctw**2*vmaup**2*vmata**2*mta**2+sdet3ctats/ctw**
     &   2*vpaup**2*vpata**2*mta**2)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(1d0/8/ctw**2*vma
     &   up**2*vmata**2*qs*us*mta**2-1d0/8/ctw**2*vmaup**2*vmata**2*qs*ts*
     &   mta**2+1d0/8/ctw**2*vpaup**2*vpata**2*qs*us*mta**2-1d0/8/ctw**2*v
     &   paup**2*vpata**2*qs*ts*mta**2+1d0/8*sdet3ctats/ctw**2*vmaup**2*vm
     &   ata**2*qs*mta**2-1d0/8*sdet3ctats/ctw**2*vmaup**2*vmata**2*qs*ts+
     &   1d0/8*sdet3ctats/ctw**2*vpaup**2*vpata**2*qs*mta**2-1d0/8*sdet3ct
     &   ats/ctw**2*vpaup**2*vpata**2*qs*ts)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(-1d0
     &   /2/ctw**2*vmaup**2*vpata**2*mta**2-1d0/2/ctw**2*vpaup**2*vmata**2
     &   *mta**2-1d0/8*sdet3ctaus/ctw**2*vmaup**2*vpata**2-1d0/8*sdet3ctau
     &   s/ctw**2*vpaup**2*vmata**2)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     &   tw**2*vmaup**2*vpata*vmata*mta**4+1d0/2/ctw**2*vmaup**2*vpata*vma
     &   ta*us*mta**2-3d0/4/ctw**2*vmaup**2*vpata**2*mta**4+3d0/4/ctw**2*v
     &   maup**2*vpata**2*us**2+1d0/4/ctw**2*vmaup**2*vpata**2*qs*mta**2-3
     &   d0/4/ctw**2*vpaup**2*vmata**2*mta**4+3d0/4/ctw**2*vpaup**2*vmata*
     &   *2*us**2+1d0/4/ctw**2*vpaup**2*vmata**2*qs*mta**2+1d0/2/ctw**2*vp
     &   aup**2*vpata*vmata*mta**4+1d0/2/ctw**2*vpaup**2*vpata*vmata*us*mt
     &   a**2+sdet3ctaus/ctw**2*vmaup**2*vpata**2*mta**2+sdet3ctaus/ctw**2
     &   *vpaup**2*vmata**2*mta**2)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-1d0/8/ctw**2*vm
     &   aup**2*vpata**2*qs*us*mta**2+1d0/8/ctw**2*vmaup**2*vpata**2*qs*ts
     &   *mta**2-1d0/8/ctw**2*vpaup**2*vmata**2*qs*us*mta**2+1d0/8/ctw**2*
     &   vpaup**2*vmata**2*qs*ts*mta**2+1d0/8*sdet3ctaus/ctw**2*vmaup**2*v
     &   pata**2*qs*mta**2-1d0/8*sdet3ctaus/ctw**2*vmaup**2*vpata**2*qs*us
     &   +1d0/8*sdet3ctaus/ctw**2*vpaup**2*vmata**2*qs*mta**2-1d0/8*sdet3c
     &   taus/ctw**2*vpaup**2*vmata**2*qs*us)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(-1d0/2/ctw**
     &   2*vmaup**2*vmata**2*mta**2-1d0/2/ctw**2*vmaup**2*vpata**2*mta**2-
     &   1d0/2/ctw**2*vpaup**2*vmata**2*mta**2-1d0/2/ctw**2*vpaup**2*vpata
     &   **2*mta**2)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**
     &   2*vmata**2*mta**4+1d0/2/ctw**2*vmaup**2*vmata**2*ts**2-1d0/2/ctw*
     &   *2*vmaup**2*vpata**2*mta**4+1d0/2/ctw**2*vmaup**2*vpata**2*us**2-
     &   1d0/2/ctw**2*vpaup**2*vmata**2*mta**4+1d0/2/ctw**2*vpaup**2*vmata
     &   **2*us**2-1d0/2/ctw**2*vpaup**2*vpata**2*mta**4+1d0/2/ctw**2*vpau
     &   p**2*vpata**2*ts**2)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-1d0/ctw**2*vmaup**2*v
     &   mata**2*ts*mta**2-1d0/ctw**2*vmaup**2*vmata**2*ts**2-1d0/ctw**2*v
     &   maup**2*vpata*vmata*mta**4-1d0/ctw**2*vmaup**2*vpata*vmata*ts*mta
     &   **2-1d0/ctw**2*vpaup**2*vpata*vmata*mta**4-1d0/ctw**2*vpaup**2*vp
     &   ata*vmata*ts*mta**2-1d0/ctw**2*vpaup**2*vpata**2*ts*mta**2-1d0/ct
     &   w**2*vpaup**2*vpata**2*ts**2)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*(-1d0/ctw**2*vmaup**2*v
     &   pata*vmata*mta**4-1d0/ctw**2*vmaup**2*vpata*vmata*us*mta**2-1d0/c
     &   tw**2*vmaup**2*vpata**2*us*mta**2-1d0/ctw**2*vmaup**2*vpata**2*us
     &   **2-1d0/ctw**2*vpaup**2*vmata**2*us*mta**2-1d0/ctw**2*vpaup**2*vm
     &   ata**2*us**2-1d0/ctw**2*vpaup**2*vpata*vmata*mta**4-1d0/ctw**2*vp
     &   aup**2*vpata*vmata*us*mta**2)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**2*v
     &   maup**2*vmata**2*mta**2+1d0/4/ctw**2*vmaup**2*vmata**2*ts-1d0/4/c
     &   tw**2*vmaup**2*vpata**2*mta**2+1d0/4/ctw**2*vmaup**2*vpata**2*us-
     &   1d0/4/ctw**2*vpaup**2*vmata**2*mta**2+1d0/4/ctw**2*vpaup**2*vmata
     &   **2*us-1d0/4/ctw**2*vpaup**2*vpata**2*mta**2+1d0/4/ctw**2*vpaup**
     &   2*vpata**2*ts)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/2*sdet3ctats/ctw**2*
     &   vmaup**2*vmata**2*mta**2+1d0/2*sdet3ctats/ctw**2*vmaup**2*vmata**
     &   2*ts+sdet3ctats/ctw**2*vmaup**2*vpata*vmata*mta**2+sdet3ctats/ctw
     &   **2*vpaup**2*vpata*vmata*mta**2+1d0/2*sdet3ctats/ctw**2*vpaup**2*
     &   vpata**2*mta**2+1d0/2*sdet3ctats/ctw**2*vpaup**2*vpata**2*ts+sdet
     &   3ctaus/ctw**2*vmaup**2*vpata*vmata*mta**2+1d0/2*sdet3ctaus/ctw**2
     &   *vmaup**2*vpata**2*mta**2+1d0/2*sdet3ctaus/ctw**2*vmaup**2*vpata*
     &   *2*us+1d0/2*sdet3ctaus/ctw**2*vpaup**2*vmata**2*mta**2+1d0/2*sdet
     &   3ctaus/ctw**2*vpaup**2*vmata**2*us+sdet3ctaus/ctw**2*vpaup**2*vpa
     &   ta*vmata*mta**2)
     &   +sdet4itatsus*b0fqszz*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vmat
     &   a**2*mta**2+1d0/2/ctw**2*vmaup**2*vmata**2*ts+1d0/2/ctw**2*vmaup*
     &   *2*vpata**2*mta**2+1d0/2/ctw**2*vmaup**2*vpata**2*us+1d0/2/ctw**2
     &   *vpaup**2*vmata**2*mta**2+1d0/2/ctw**2*vpaup**2*vmata**2*us+1d0/2
     &   /ctw**2*vpaup**2*vpata**2*mta**2+1d0/2/ctw**2*vpaup**2*vpata**2*t
     &   s)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**2*vm
     &   ata**2*mta**2-1d0/2/ctw**2*vmaup**2*vmata**2*ts-1d0/2/ctw**2*vpau
     &   p**2*vpata**2*mta**2-1d0/2/ctw**2*vpaup**2*vpata**2*ts)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**2*vp
     &   ata**2*mta**2-1d0/2/ctw**2*vmaup**2*vpata**2*us-1d0/2/ctw**2*vpau
     &   p**2*vmata**2*mta**2-1d0/2/ctw**2*vpaup**2*vmata**2*us)
     &   +d0cctataqstszczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vmata**
     &   2*mta**2+1d0/2/ctw**2*vmaup**2*vmata**2*mz**2+1d0/2/ctw**2*vmaup*
     &   *2*vmata**2*ts+1d0/8/ctw**2*vmaup**2*vmata**2*qs+1d0/2/ctw**2*vpa
     &   up**2*vpata**2*mta**2+1d0/2/ctw**2*vpaup**2*vpata**2*mz**2+1d0/2/
     &   ctw**2*vpaup**2*vpata**2*ts+1d0/8/ctw**2*vpaup**2*vpata**2*qs-1d0
     &   /2*sdet3ctats/ctw**2*vmaup**2*vpata**2-1d0/2*sdet3ctats/ctw**2*vp
     &   aup**2*vmata**2)
     &   +d0cctataqsuswcwc*dreal(propizqs)*(-2*us*rwz)
     &   +d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vmaup**
     &   2*vpata**2+1d0/4/ctw**2*vpaup**2*vmata**2)
     &   +d0cctataqsuszczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vpata**
     &   2*mta**2+1d0/2/ctw**2*vmaup**2*vpata**2*us-1d0/8/ctw**2*vmaup**2*
     &   vpata**2*qs+1d0/2/ctw**2*vpaup**2*vmata**2*mta**2+1d0/2/ctw**2*vp
     &   aup**2*vmata**2*us-1d0/8/ctw**2*vpaup**2*vmata**2*qs-1d0/2*sdet3c
     &   taus/ctw**2*vmaup**2*vmata**2-1d0/2*sdet3ctaus/ctw**2*vpaup**2*vp
     &   ata**2)
     &   +c0tataqswcw*dreal(propizqs)*(2*rwz)
     &   +c0tataqswcw*(-4*mw**2*rwz+15d0/2*mw**2*rtaw*rwz-3*mw**2*rtaw**2*
     &   rwz-1d0/2*mw**2*rtaw**3*rwz)
     &   +c0tataqsztaz*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vmata**2+1d0
     &   /2/ctw**2*vmaup**2*vpata**2+1d0/2/ctw**2*vpaup**2*vmata**2+1d0/2/
     &   ctw**2*vpaup**2*vpata**2)
     &   +c0tataqsztah*(-1d0/4/qs*mw**4*rtaw/rwz**2+1d0/2/qs*mw**4*rtaw/rw
     &   z*rhw-1d0/4/qs*mw**4*rtaw*rhw**2+mw**2*rtaw/rwz-mw**2*rtaw**2)
     &   +c0tataqstazta*(7*mw**2/rwz**2-18*mw**2/rwz+12*mw**2-5d0/2*mw**2*
     &   rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz-7d0/2*qs/rwz+9*qs-6*qs*rwz
     &   )
     &   +c0tataqstahta*(mw**2*rtaw**2)
     &   +c0tataqscwc*(-2*mw**2-mw**2*rtaw-1d0/2*mw**2*rtaw**2+qs)
     &   +c0ccqswcw*dreal(propizqs)*(2*rwz)
     &   +c0ccqswcw*(2/qs*mw**4*rwz-4*mw**2*rwz)
     &   +c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vmata**2+1d0/2/
     &   ctw**2*vmaup**2*vpata**2+1d0/2/ctw**2*vpaup**2*vmata**2+1d0/2/ctw
     &   **2*vpaup**2*vpata**2)
     &   +c0ccqscwc*(-vpadn/qs*mw**4+2*vpadn*mw**2-vpadn*qs)
     &   +c0ccqsczc*(-1d0/2/qs*mw**4/rwz**3+mw**2/rwz**2-1d0/2*qs/rwz+3d0/
     &   2*vpaup/qs*mw**4/rwz**3-3*vpaup*mw**2/rwz**2+3d0/2*vpaup*qs/rwz-3
     &   d0/2*vpaup**2/qs*mw**4/rwz**3+3*vpaup**2*mw**2/rwz**2-3d0/2*vpaup
     &   **2*qs/rwz)
     &   +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     &   -4*mw**2*rwz)
     &   +a0fw*(1d0/4+2/qs*mw**2*rwz+1d0/2*rwz+vpadn/qs*mw**2-3d0/2*vpadn)
     &   +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     &   d0/12*mw**2/rwz*rhw)
     &   +a0fz*(5d0/12/qs*mw**2/rwz**2+1d0/12/qs*mw**2/rwz*rhw-7d0/8/rwz-3
     &   d0/2*vpaup/qs*mw**2/rwz**2+9d0/4*vpaup/rwz+3d0/2*vpaup**2/qs*mw**
     &   2/rwz**2-9d0/4*vpaup**2/rwz)
     &   +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     &   +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     &   +a0fta*(3d0/2-1d0/2/rwz-rwz+1d0/4*rtaw)
     &   +b0ftawc*(-5d0/4+5d0/2*rwz-1d0/2*rtaw-3d0/2*rtaw*rwz)
     &   +b0ftazta*(-12-1d0/4/qs*mw**2*rtaw/rwz+1d0/4/qs*mw**2*rtaw*rhw+37
     &   d0/8/rwz+8*rwz)
     &   +b0ftahta*(1d0/4/qs*mw**2*rtaw/rwz-1d0/4/qs*mw**2*rtaw*rhw-1d0/8*
     &   rhw)
     &   +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     &   /3*mw**2-4*mw**2*rwz)
     &   +b0fqsww*dreal(propizqs)*(5d0/3/mw**2*rwz+1d0/4/mw**2*rtaw*rwz-1d
     &   0/12*qs/mw**4*rwz)
     &   +b0fqsww*(-4d0/3+2/qs*mw**2*rwz-1d0/12/rwz+rwz+3*rtaw*rwz+1d0/2*r
     &   taw**2*rwz+1d0/12*qs/mw**2-5d0/3*qs/mw**2*rwz-1d0/4*qs/mw**2*rtaw
     &   *rwz+1d0/12*qs**2/mw**4*rwz)
     &   +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     &   mw**2*rhw**2)
     &   +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     &   s*mw**2*rhw**2-1d0/12/rwz+1d0/2*rtaw)
     &   +b0fqstata*(27d0/2-21d0/4/rwz-9*rwz-1d0/4*rtaw)
     &   +b0fqscc*(3d0/2+1d0/2/qs*mw**2/rwz**2-3d0/4/rwz+1d0/4*rtaw+vpadn/
     &   qs*mw**2-3d0/2*vpadn-3d0/2*vpaup/qs*mw**2/rwz**2+9d0/4*vpaup/rwz+
     &   3d0/2*vpaup**2/qs*mw**2/rwz**2-9d0/4*vpaup**2/rwz)
     &   +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     &   /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     &   *mw**2-4*mw**2*rwz)
     &   +dreal(b0ptazta)*(-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2-7d0/4*m
     &   w**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz)
     &   +dreal(b0ptahta)*(-1d0/4*mw**2*rtaw*rhw+mw**2*rtaw**2)
     &   +dreal(b0ptacw)*(-1d0/2*mw**2+1d0/4*mw**2*rtaw+1d0/4*mw**2*rtaw**
     &   2)
     &   +b0d1tataz*(-3d0/2+1d0/2/rwz+rwz)
     &   +b0dwtacw*(-1+rwz)
     &   +47d0/9+1d0/stw**2*deltarhofer+1d0/stw**2*deltarhobos-143d0/72/rw
     &   z+caldzfer-2*deltarhofer-za1fer-2*deltarhobos-za1bos+2*rwz+3d0/4*
     &   rtaw-1d0/2*rtaw*rwz-vpadn+3d0/8*vpaup/rwz+3d0/4*vpaup-3d0/8*vpaup
     &   **2/rwz

        ff_ew_ql =
     &   +sdet3itataqs*c0tataqswcw*(-2/qs*mw**6+11d0/4*mw**4-13d0/2*mw**4*
     &   rtaw+11d0/4*mw**4*rtaw**2+1d0/2*mw**4*rtaw**3)
     &   +sdet3itataqs*c0tataqsztah*(-3d0/4*mw**4*rtaw/rwz**2-1d0/2*mw**4*
     &   rtaw/rwz*rhw+1d0/4*mw**4*rtaw*rhw**2+2*mw**4*rtaw**2/rwz-2*mw**4*
     &   rtaw**2*rhw+4*mw**4*rtaw**3)
     &   +sdet3itataqs*c0tataqstazta*(-3/qs*mw**6/rwz**3+4/qs*mw**6/rwz**2
     &   -7d0/2*mw**4/rwz**3+9*mw**4/rwz**2-6*mw**4/rwz-55d0/4*mw**4*rtaw/
     &   rwz**2+24*mw**4*rtaw/rwz-8*mw**4*rtaw)
     &   +sdet3itataqs*c0tataqstahta*(1d0/4*mw**4*rtaw*rhw**2-2*mw**4*rtaw
     &   **2*rhw)
     &   +sdet3itataqs*c0tataqscwc*(mw**4+11d0/2*mw**4*rtaw+6*mw**4*rtaw**
     &   2+3d0/2*mw**4*rtaw**3)
     &   +sdet3itataqs*b0ftawc*(2/qs*mw**4-9d0/4*mw**2+31d0/4*mw**2*rtaw+2
     &   *mw**2*rtaw**2)
     &   +sdet3itataqs*b0ftazta*(-3/qs*mw**4/rwz**2+4/qs*mw**4/rwz-7d0/2*m
     &   w**2/rwz**2+9*mw**2/rwz-6*mw**2-13*mw**2*rtaw/rwz+24*mw**2*rtaw-1
     &   d0/4*mw**2*rtaw*rhw-8*mw**2*rtaw*rwz+mw**2*rtaw**2)
     &   +sdet3itataqs*b0ftahta*(3d0/4*mw**2*rtaw/rwz-mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqsww*(-2/qs*mw**4+13d0/4*mw**2-13d0/4*mw**2*rtaw
     &   -1d0/2*mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqszh*(-3d0/2*mw**2*rtaw/rwz+1d0/2*mw**2*rtaw*rhw
     &   -2*mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqstata*(3/qs*mw**4/rwz**2-4/qs*mw**4/rwz+7d0/2*m
     &   w**2/rwz**2-9*mw**2/rwz+6*mw**2+55d0/4*mw**2*rtaw/rwz-24*mw**2*rt
     &   aw-1d0/4*mw**2*rtaw*rhw+8*mw**2*rtaw*rwz+2*mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqscc*(-mw**2-9d0/2*mw**2*rtaw-3d0/2*mw**2*rtaw**
     &   2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup*vmata**2*mta**4+1d0/ctw**2*vmaup*vmata**2*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup*vmata**2*mta**4-1d0/ctw**2*vmaup*vmata**2*ts*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup*vpata**2*mta**4+1d0/ctw**2*vmaup*vpata**2*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup*vpata**2*mta**4-1d0/ctw**2*vmaup*vpata**2*us*mta**2)
     &   +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(1
     &   d0/4/ctw**2*vmaup*vmata**2*us*mta**4-1d0/4/ctw**2*vmaup*vmata**2*
     &   ts*mta**4+1d0/4*sdet3ctats/ctw**2*vmaup*vmata**2*mta**4-1d0/4*sde
     &   t3ctats/ctw**2*vmaup*vmata**2*ts*mta**2+sdet3ctats**2/ctw**2*vmau
     &   p*vmata**2*mta**2+1d0/4*sdet3ctats**2/ctw**2*vmaup*vmata**2*qs)
     &   +sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(-
     &   1d0/4/ctw**2*vmaup*vpata**2*us*mta**4+1d0/4/ctw**2*vmaup*vpata**2
     &   *ts*mta**4+1d0/4*sdet3ctaus/ctw**2*vmaup*vpata**2*mta**4-1d0/4*sd
     &   et3ctaus/ctw**2*vmaup*vpata**2*us*mta**2+sdet3ctaus**2/ctw**2*vma
     &   up*vpata**2*mta**2+1d0/4*sdet3ctaus**2/ctw**2*vmaup*vpata**2*qs)
     &   +sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(sdet3ctat
     &   s/ctw**2*vmaup*vmata**2*mta**4+sdet3ctats/ctw**2*vmaup*vmata**2*t
     &   s*mta**2+1d0/4*sdet3ctats/ctw**2*vmaup*vmata**2*qs*mta**2+1d0/4*s
     &   det3ctats/ctw**2*vmaup*vmata**2*qs*ts+sdet3ctaus/ctw**2*vmaup*vpa
     &   ta**2*mta**4+sdet3ctaus/ctw**2*vmaup*vpata**2*us*mta**2+1d0/4*sde
     &   t3ctaus/ctw**2*vmaup*vpata**2*qs*mta**2+1d0/4*sdet3ctaus/ctw**2*v
     &   maup*vpata**2*qs*us)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(-1d0/2*sde
     &   t3ctats/ctw**2*vmaup*vmata**2*mta**4+1d0/2*sdet3ctats/ctw**2*vmau
     &   p*vmata**2*ts**2)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*pxx2zqsc*(-1d0/2*sde
     &   t3ctaus/ctw**2*vmaup*vpata**2*mta**4+1d0/2*sdet3ctaus/ctw**2*vmau
     &   p*vpata**2*us**2)
     &   +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**
     &   2*vmaup*vmata**2*qs*mta**4+1d0/4/ctw**2*vmaup*vmata**2*qs*ts*mta*
     &   *2-1d0/4/ctw**2*vmaup*vpata**2*qs*mta**4+1d0/4/ctw**2*vmaup*vpata
     &   **2*qs*us*mta**2+1d0/4*sdet3ctats**2/ctw**2*vmaup*vmata**2*mta**2
     &   -1d0/4*sdet3ctats**2/ctw**2*vmaup*vmata**2*ts+1d0/4*sdet3ctaus**2
     &   /ctw**2*vmaup*vpata**2*mta**2-1d0/4*sdet3ctaus**2/ctw**2*vmaup*vp
     &   ata**2*us)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(1d0/
     &   2/ctw**2*vmaup*vmata**2*mta**2+1d0/8*sdet3ctats/ctw**2*vmaup*vmat
     &   a**2)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc*(3d0/4/c
     &   tw**2*vmaup*vmata**2*mta**4-3d0/4/ctw**2*vmaup*vmata**2*ts**2-1d0
     &   /4/ctw**2*vmaup*vmata**2*qs*mta**2-1d0/2/ctw**2*vmaup*vpata*vmata
     &   *mta**4-1d0/2/ctw**2*vmaup*vpata*vmata*ts*mta**2-sdet3ctats/ctw**
     &   2*vmaup*vmata**2*mta**2)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/8/ctw**2*vm
     &   aup*vmata**2*qs*us*mta**2+1d0/8/ctw**2*vmaup*vmata**2*qs*ts*mta**
     &   2-1d0/8*sdet3ctats/ctw**2*vmaup*vmata**2*qs*mta**2+1d0/8*sdet3cta
     &   ts/ctw**2*vmaup*vmata**2*qs*ts)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(1d0/
     &   2/ctw**2*vmaup*vpata**2*mta**2+1d0/8*sdet3ctaus/ctw**2*vmaup*vpat
     &   a**2)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     &   ctw**2*vmaup*vpata*vmata*mta**4-1d0/2/ctw**2*vmaup*vpata*vmata*us
     &   *mta**2+3d0/4/ctw**2*vmaup*vpata**2*mta**4-3d0/4/ctw**2*vmaup*vpa
     &   ta**2*us**2-1d0/4/ctw**2*vmaup*vpata**2*qs*mta**2-sdet3ctaus/ctw*
     &   *2*vmaup*vpata**2*mta**2)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(1d0/8/ctw**2*vma
     &   up*vpata**2*qs*us*mta**2-1d0/8/ctw**2*vmaup*vpata**2*qs*ts*mta**2
     &   -1d0/8*sdet3ctaus/ctw**2*vmaup*vpata**2*qs*mta**2+1d0/8*sdet3ctau
     &   s/ctw**2*vmaup*vpata**2*qs*us)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(1d0/2/ctw**2
     &   *vmaup*vmata**2*mta**2+1d0/2/ctw**2*vmaup*vpata**2*mta**2)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vm
     &   ata**2*mta**4-1d0/2/ctw**2*vmaup*vmata**2*ts**2+1d0/2/ctw**2*vmau
     &   p*vpata**2*mta**4-1d0/2/ctw**2*vmaup*vpata**2*us**2)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(1d0/ctw**2*vmaup*vmata
     &   **2*ts*mta**2+1d0/ctw**2*vmaup*vmata**2*ts**2+1d0/ctw**2*vmaup*vp
     &   ata*vmata*mta**4+1d0/ctw**2*vmaup*vpata*vmata*ts*mta**2)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*(1d0/ctw**2*vmaup*vpata
     &   *vmata*mta**4+1d0/ctw**2*vmaup*vpata*vmata*us*mta**2+1d0/ctw**2*v
     &   maup*vpata**2*us*mta**2+1d0/ctw**2*vmaup*vpata**2*us**2)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vm
     &   aup*vmata**2*mta**2-1d0/4/ctw**2*vmaup*vmata**2*ts+1d0/4/ctw**2*v
     &   maup*vpata**2*mta**2-1d0/4/ctw**2*vmaup*vpata**2*us)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/2*sdet3ctats/ctw**2
     &   *vmaup*vmata**2*mta**2-1d0/2*sdet3ctats/ctw**2*vmaup*vmata**2*ts-
     &   sdet3ctats/ctw**2*vmaup*vpata*vmata*mta**2-sdet3ctaus/ctw**2*vmau
     &   p*vpata*vmata*mta**2-1d0/2*sdet3ctaus/ctw**2*vmaup*vpata**2*mta**
     &   2-1d0/2*sdet3ctaus/ctw**2*vmaup*vpata**2*us)
     &   +sdet4itatsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmata*
     &   *2*mta**2-1d0/2/ctw**2*vmaup*vmata**2*ts-1d0/2/ctw**2*vmaup*vpata
     &   **2*mta**2-1d0/2/ctw**2*vmaup*vpata**2*us)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vmata*
     &   *2*mta**2+1d0/2/ctw**2*vmaup*vmata**2*ts)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpata*
     &   *2*mta**2+1d0/2/ctw**2*vmaup*vpata**2*us)
     &   +d0cctataqstszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmata**2*
     &   mta**2-1d0/2/ctw**2*vmaup*vmata**2*mz**2-1d0/2/ctw**2*vmaup*vmata
     &   **2*ts-1d0/8/ctw**2*vmaup*vmata**2*qs+1d0/2*sdet3ctats/ctw**2*vma
     &   up*vpata**2)
     &   +d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**2*vmaup*
     &   vpata**2)
     &   +d0cctataqsuszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpata**2*
     &   mta**2-1d0/2/ctw**2*vmaup*vpata**2*us+1d0/8/ctw**2*vmaup*vpata**2
     &   *qs+1d0/2*sdet3ctaus/ctw**2*vmaup*vmata**2)
     &   +c0tataqswcw*(5d0/4/qs*mw**4-1d0/qs*mw**4*rtaw+1d0/4/qs*mw**4*rta
     &   w**2)
     &   +c0tataqsztaz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmata**2-1d0/2
     &   /ctw**2*vmaup*vpata**2)
     &   +c0tataqsztah*(-1d0/4/qs*mw**4*rtaw/rwz**2+1d0/2/qs*mw**4*rtaw/rw
     &   z*rhw-1d0/4/qs*mw**4*rtaw*rhw**2+mw**2*rtaw/rwz-mw**2*rtaw**2)
     &   +c0tataqstazta*(3/qs*mw**4/rwz**2-4/qs*mw**4/rwz+7*mw**2/rwz**2-1
     &   5*mw**2/rwz+8*mw**2-5d0/2*mw**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rta
     &   w*rwz-7d0/2*qs/rwz+6*qs-2*qs*rwz)
     &   +c0tataqstahta*(mw**2*rtaw**2)
     &   +c0tataqscwc*(-2*mw**2-mw**2*rtaw-1d0/2*mw**2*rtaw**2+qs)
     &   +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmata**2-1d0/2/ct
     &   w**2*vmaup*vpata**2)
     &   +c0ccqsczc*(-1d0/2/qs*mw**4/rwz**3+mw**2/rwz**2-1d0/2*qs/rwz+vpau
     &   p/qs*mw**4/rwz**3-2*vpaup*mw**2/rwz**2+vpaup*qs/rwz-1d0/2*vpaup**
     &   2/qs*mw**4/rwz**3+vpaup**2*mw**2/rwz**2-1d0/2*vpaup**2*qs/rwz)
     &   +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     &   -4*mw**2*rwz)
     &   +a0fw*(1d0/4-1d0/6/qs*mw**2+4/qs*mw**2*rwz)
     &   +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     &   d0/12*mw**2/rwz*rhw)
     &   +a0fz*(5d0/12/qs*mw**2/rwz**2+1d0/12/qs*mw**2/rwz*rhw-7d0/8/rwz-v
     &   paup/qs*mw**2/rwz**2+3d0/2*vpaup/rwz+1d0/2*vpaup**2/qs*mw**2/rwz*
     &   *2-3d0/4*vpaup**2/rwz)
     &   +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     &   +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     &   +a0fta*(-3d0/2/qs*mw**2/rwz+2/qs*mw**2-1d0/2/rwz+rwz+1d0/4*rtaw)
     &   +b0ftawc*(-5d0/4+3d0/4/qs*mw**2-1d0/4/qs*mw**2*rtaw-1d0/2*rtaw)
     &   +b0ftazta*(-9-1d0/4/qs*mw**2*rtaw/rwz+1d0/4/qs*mw**2*rtaw*rhw+37d
     &   0/8/rwz+4*rwz)
     &   +b0ftahta*(1d0/4/qs*mw**2*rtaw/rwz-1d0/4/qs*mw**2*rtaw*rhw-1d0/8*
     &   rhw)
     &   +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     &   /3*mw**2-4*mw**2*rwz)
     &   +b0fqsww*(1d0/6-11d0/12/qs*mw**2+4/qs*mw**2*rwz+1d0/4/qs*mw**2*rt
     &   aw-1d0/12/rwz+1d0/4*rtaw)
     &   +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     &   mw**2*rhw**2)
     &   +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     &   s*mw**2*rhw**2-1d0/12/rwz+1d0/2*rtaw)
     &   +b0fqstata*(9-3d0/2/qs*mw**2/rwz+2/qs*mw**2-21d0/4/rwz-3*rwz-1d0/
     &   4*rtaw)
     &   +b0fqscc*(3d0/2+1d0/2/qs*mw**2/rwz**2-3d0/4/rwz+1d0/4*rtaw-vpaup/
     &   qs*mw**2/rwz**2+3d0/2*vpaup/rwz+1d0/2*vpaup**2/qs*mw**2/rwz**2-3d
     &   0/4*vpaup**2/rwz)
     &   +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     &   /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     &   *mw**2-4*mw**2*rwz)
     &   +dreal(b0ptazta)*(-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2-7d0/4*m
     &   w**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz)
     &   +dreal(b0ptahta)*(-1d0/4*mw**2*rtaw*rhw+mw**2*rtaw**2)
     &   +dreal(b0ptacw)*(-1d0/2*mw**2+1d0/4*mw**2*rtaw+1d0/4*mw**2*rtaw**
     &   2)
     &   +b0d1tataz*(3d0/2/qs*mw**2/rwz-2/qs*mw**2+1d0/2/rwz-rwz)
     &   +b0dwtacw*(-1-1d0/qs*mw**2)
     &   +65d0/18-3d0/2/qs*mw**2/rwz+1d0/3/qs*mw**2+4/qs*mw**2*rwz+1d0/2/q
     &   s*mw**2*rtaw-143d0/72/rwz-pizgfer+caldzfer-deltarhofer-za1fer-del
     &   tarhobos-za1bos-rwz+3d0/4*rtaw+1d0/4*vpaup/rwz-1d0/8*vpaup**2/rwz
     &

        ff_ew_lq =
     &   +sdet3itataqs*c0tataqswcw*dreal(propizqs)*(-3d0/2/vmata*mw**2*rta
     &   w*rwz+1d0/vmata*mw**2*rtaw**2*rwz+1d0/2/vmata*mw**2*rtaw**3*rwz)
     &   +sdet3itataqs*c0tataqswcw*(7/vmata*mw**4*rtaw*rwz-12/vmata*mw**4*
     &   rtaw**2*rwz+3/vmata*mw**4*rtaw**3*rwz+2/vmata*mw**4*rtaw**4*rwz)
     &   +sdet3itataqs*c0tataqsztah*(-3d0/8/vmata*mw**4*rtaw/rwz**2-1d0/4/
     &   vmata*mw**4*rtaw/rwz*rhw+1d0/8/vmata*mw**4*rtaw*rhw**2+1d0/vmata*
     &   mw**4*rtaw**2/rwz-1d0/vmata*mw**4*rtaw**2*rhw+2/vmata*mw**4*rtaw*
     &   *3)
     &   +sdet3itataqs*c0tataqstazta*(-3d0/4/vmata*mw**4*rtaw/rwz**2-2*mw*
     &   *4/rwz**3+4*mw**4/rwz**2-2*mw**4/rwz-13d0/4*mw**4*rtaw/rwz**2+6*m
     &   w**4*rtaw/rwz)
     &   +sdet3itataqs*c0tataqstahta*(1d0/4/vmata*mw**4*rtaw*rhw**2-1d0/vm
     &   ata*mw**4*rtaw**2*rhw-1d0/4*mw**4*rtaw*rhw**2)
     &   +sdet3itataqs*c0tataqscwc*(3d0/2/vmata*mw**4*rtaw+2/vmata*mw**4*r
     &   taw**2+1d0/2/vmata*mw**4*rtaw**3)
     &   +sdet3itataqs*b0ftawc*dreal(propizqs)*(1d0/vmata*rtaw*rwz)
     &   +sdet3itataqs*b0ftawc*(2/vmata*mw**2*rtaw-7/vmata*mw**2*rtaw*rwz+
     &   1d0/vmata*mw**2*rtaw**2+3/vmata*mw**2*rtaw**2*rwz)
     &   +sdet3itataqs*b0ftazta*(-3d0/8/vmata*mw**2*rtaw/rwz-1d0/8/vmata*m
     &   w**2*rtaw*rhw+1d0/2/vmata*mw**2*rtaw**2-2*mw**2/rwz**2+4*mw**2/rw
     &   z-2*mw**2-13d0/4*mw**2*rtaw/rwz+6*mw**2*rtaw)
     &   +sdet3itataqs*b0ftahta*(3d0/8/vmata*mw**2*rtaw/rwz+1d0/8/vmata*mw
     &   **2*rtaw*rhw-1d0/2/vmata*mw**2*rtaw**2-1d0/4*mw**2*rtaw*rhw)
     &   +sdet3itataqs*b0fqsww*dreal(propizqs)*(-3d0/2/vmata*rtaw*rwz-1d0/
     &   2/vmata*rtaw**2*rwz)
     &   +sdet3itataqs*b0fqsww*(7/vmata*mw**2*rtaw*rwz-5/vmata*mw**2*rtaw*
     &   *2*rwz-2/vmata*mw**2*rtaw**3*rwz)
     &   +sdet3itataqs*b0fqszh*(-3d0/4/vmata*mw**2*rtaw/rwz+1d0/4/vmata*mw
     &   **2*rtaw*rhw-1d0/vmata*mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqstata*(3d0/4/vmata*mw**2*rtaw/rwz-1d0/4/vmata*m
     &   w**2*rtaw*rhw+1d0/vmata*mw**2*rtaw**2+2*mw**2/rwz**2-4*mw**2/rwz+
     &   2*mw**2+13d0/4*mw**2*rtaw/rwz-6*mw**2*rtaw+1d0/4*mw**2*rtaw*rhw)
     &   +sdet3itataqs*b0fqscc*(-3d0/2/vmata*mw**2*rtaw-1d0/2/vmata*mw**2*
     &   rtaw**2)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(-
     &   1d0/2/ctw**2*vmaup**2*vmata*ts*mta**2+1d0/2/ctw**2*vpaup**2*vpata
     &   **2/vmata*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup**2*vmata*ts*mta**2-1d0/ctw**2*vpaup**2*vpata**2/vmata*mta**4
     &   )
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup**2*vmata*ts*mta**2+1d0/ctw**2*vpaup**2*vpata**2/vmata*mta**4)
     &
     &   +sdet3ictats*c0ctatsczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**2*
     &   vmata*mta**2+1d0/2/ctw**2*vpaup**2*vpata**2/vmata*mta**2)
     &   +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*pxx2zqsc*(1
     &   d0/2/ctw**2*vmaup**2*vpata**2/vmata*us*mta**2-1d0/2/ctw**2*vpaup*
     &   *2*vmata*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup**2*vpata**2/vmata*mta**4-1d0/ctw**2*vpaup**2*vmata*us*mta**2
     &   )
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup**2*vpata**2/vmata*mta**4+1d0/ctw**2*vpaup**2*vmata*us*mta**2)
     &
     &   +sdet3ictaus*c0ctausczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*v
     &   pata**2/vmata*mta**2-1d0/2/ctw**2*vpaup**2*vmata*mta**2)
     &   +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(-
     &   1d0/4/ctw**2*vmaup**2*vmata*us*mta**4+1d0/4/ctw**2*vmaup**2*vmata
     &   *ts*mta**4-1d0/4*sdet3ctats/ctw**2*vpaup**2*vpata**2/vmata*mta**4
     &   +1d0/4*sdet3ctats/ctw**2*vpaup**2*vpata**2/vmata*ts*mta**2-sdet3c
     &   tats**2/ctw**2*vmaup**2*vmata*mta**2-1d0/4*sdet3ctats**2/ctw**2*v
     &   maup**2*vmata*qs)
     &   +sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(1
     &   d0/4/ctw**2*vpaup**2*vmata*us*mta**4-1d0/4/ctw**2*vpaup**2*vmata*
     &   ts*mta**4-1d0/4*sdet3ctaus/ctw**2*vmaup**2*vpata**2/vmata*mta**4+
     &   1d0/4*sdet3ctaus/ctw**2*vmaup**2*vpata**2/vmata*us*mta**2-sdet3ct
     &   aus**2/ctw**2*vpaup**2*vmata*mta**2-1d0/4*sdet3ctaus**2/ctw**2*vp
     &   aup**2*vmata*qs)
     &   +sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(-sdet3cta
     &   ts/ctw**2*vmaup**2*vmata*ts*mta**2-1d0/4*sdet3ctats/ctw**2*vmaup*
     &   *2*vmata*qs*ts-sdet3ctats/ctw**2*vpaup**2*vpata**2/vmata*mta**4-1
     &   d0/4*sdet3ctats/ctw**2*vpaup**2*vpata**2/vmata*qs*mta**2-sdet3cta
     &   us/ctw**2*vmaup**2*vpata**2/vmata*mta**4-1d0/4*sdet3ctaus/ctw**2*
     &   vmaup**2*vpata**2/vmata*qs*mta**2-sdet3ctaus/ctw**2*vpaup**2*vmat
     &   a*us*mta**2-1d0/4*sdet3ctaus/ctw**2*vpaup**2*vmata*qs*us)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(1d0/2*sdet
     &   3ctats/ctw**2*vmaup**2*vmata*ts*mta**2-1d0/2*sdet3ctats/ctw**2*vm
     &   aup**2*vmata*ts**2+1d0/2*sdet3ctats/ctw**2*vpaup**2*vpata**2/vmat
     &   a*mta**4-1d0/2*sdet3ctats/ctw**2*vpaup**2*vpata**2/vmata*ts*mta**
     &   2)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*pxx2zqsc*(1d0/2*sdet
     &   3ctaus/ctw**2*vmaup**2*vpata**2/vmata*mta**4-1d0/2*sdet3ctaus/ctw
     &   **2*vmaup**2*vpata**2/vmata*us*mta**2+1d0/2*sdet3ctaus/ctw**2*vpa
     &   up**2*vmata*us*mta**2-1d0/2*sdet3ctaus/ctw**2*vpaup**2*vmata*us**
     &   2)
     &   +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2
     &   *vmaup**2*vpata**2/vmata*qs*mta**4-1d0/4/ctw**2*vmaup**2*vpata**2
     &   /vmata*qs*us*mta**2+1d0/4/ctw**2*vpaup**2*vpata**2/vmata*qs*mta**
     &   4-1d0/4/ctw**2*vpaup**2*vpata**2/vmata*qs*ts*mta**2-1d0/4*sdet3ct
     &   ats**2/ctw**2*vmaup**2*vmata*mta**2+1d0/4*sdet3ctats**2/ctw**2*vm
     &   aup**2*vmata*ts-1d0/4*sdet3ctaus**2/ctw**2*vpaup**2*vmata*mta**2+
     &   1d0/4*sdet3ctaus**2/ctw**2*vpaup**2*vmata*us)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(-3d0
     &   /8/ctw**2*vmaup**2*vmata*mta**2-1d0/8/ctw**2*vpaup**2*vpata**2/vm
     &   ata*mta**2-1d0/8*sdet3ctats/ctw**2*vmaup**2*vmata)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc*(-1d0/4/
     &   ctw**2*vmaup**2*vmata*mta**4+3d0/4/ctw**2*vmaup**2*vmata*ts**2+1d
     &   0/2/ctw**2*vmaup**2*vpata*ts*mta**2+1d0/2/ctw**2*vpaup**2*vpata*m
     &   ta**4-1d0/2/ctw**2*vpaup**2*vpata**2/vmata*mta**4+1d0/4/ctw**2*vp
     &   aup**2*vpata**2/vmata*qs*mta**2+sdet3ctats/ctw**2*vpaup**2*vpata*
     &   *2/vmata*mta**2)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(1d0/8/ctw**2*vpa
     &   up**2*vpata**2/vmata*qs*us*mta**2-1d0/8/ctw**2*vpaup**2*vpata**2/
     &   vmata*qs*ts*mta**2+1d0/8*sdet3ctats/ctw**2*vmaup**2*vmata*qs*mta*
     &   *2-1d0/8*sdet3ctats/ctw**2*vmaup**2*vmata*qs*ts)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(-1d0
     &   /8/ctw**2*vmaup**2*vpata**2/vmata*mta**2-3d0/8/ctw**2*vpaup**2*vm
     &   ata*mta**2-1d0/8*sdet3ctaus/ctw**2*vpaup**2*vmata)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     &   tw**2*vmaup**2*vpata*mta**4-1d0/2/ctw**2*vmaup**2*vpata**2/vmata*
     &   mta**4+1d0/4/ctw**2*vmaup**2*vpata**2/vmata*qs*mta**2-1d0/4/ctw**
     &   2*vpaup**2*vmata*mta**4+3d0/4/ctw**2*vpaup**2*vmata*us**2+1d0/2/c
     &   tw**2*vpaup**2*vpata*us*mta**2+sdet3ctaus/ctw**2*vmaup**2*vpata**
     &   2/vmata*mta**2)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-1d0/8/ctw**2*vm
     &   aup**2*vpata**2/vmata*qs*us*mta**2+1d0/8/ctw**2*vmaup**2*vpata**2
     &   /vmata*qs*ts*mta**2+1d0/8*sdet3ctaus/ctw**2*vpaup**2*vmata*qs*mta
     &   **2-1d0/8*sdet3ctaus/ctw**2*vpaup**2*vmata*qs*us)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**
     &   2*vmaup**2*vmata*mta**2-1d0/4/ctw**2*vmaup**2*vpata**2/vmata*mta*
     &   *2-1d0/4/ctw**2*vpaup**2*vmata*mta**2-1d0/4/ctw**2*vpaup**2*vpata
     &   **2/vmata*mta**2)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**
     &   2*vmata*ts*mta**2+1d0/2/ctw**2*vmaup**2*vmata*ts**2-1d0/2/ctw**2*
     &   vmaup**2*vpata**2/vmata*mta**4+1d0/2/ctw**2*vmaup**2*vpata**2/vma
     &   ta*us*mta**2-1d0/2/ctw**2*vpaup**2*vmata*us*mta**2+1d0/2/ctw**2*v
     &   paup**2*vmata*us**2-1d0/2/ctw**2*vpaup**2*vpata**2/vmata*mta**4+1
     &   d0/2/ctw**2*vpaup**2*vpata**2/vmata*ts*mta**2)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-1d0/ctw**2*vmaup**2*v
     &   mata*ts**2-1d0/ctw**2*vmaup**2*vpata*ts*mta**2-1d0/ctw**2*vpaup**
     &   2*vpata*mta**4-1d0/ctw**2*vpaup**2*vpata**2/vmata*ts*mta**2)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*(-1d0/ctw**2*vmaup**2*v
     &   pata*mta**4-1d0/ctw**2*vmaup**2*vpata**2/vmata*us*mta**2-1d0/ctw*
     &   *2*vpaup**2*vmata*us**2-1d0/ctw**2*vpaup**2*vpata*us*mta**2)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vm
     &   aup**2*vmata*ts-1d0/4/ctw**2*vmaup**2*vpata**2/vmata*mta**2+1d0/4
     &   /ctw**2*vpaup**2*vmata*us-1d0/4/ctw**2*vpaup**2*vpata**2/vmata*mt
     &   a**2)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/2*sdet3ctats/ctw**2*
     &   vmaup**2*vmata*ts+sdet3ctats/ctw**2*vmaup**2*vpata*mta**2+1d0/2*s
     &   det3ctats/ctw**2*vpaup**2*vpata**2/vmata*mta**2+1d0/2*sdet3ctaus/
     &   ctw**2*vmaup**2*vpata**2/vmata*mta**2+1d0/2*sdet3ctaus/ctw**2*vpa
     &   up**2*vmata*us+sdet3ctaus/ctw**2*vpaup**2*vpata*mta**2)
     &   +sdet4itatsus*b0fqszz*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vmat
     &   a*ts+1d0/2/ctw**2*vmaup**2*vpata**2/vmata*mta**2+1d0/2/ctw**2*vpa
     &   up**2*vmata*us+1d0/2/ctw**2*vpaup**2*vpata**2/vmata*mta**2)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**2*vm
     &   ata*ts-1d0/2/ctw**2*vpaup**2*vpata**2/vmata*mta**2)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**2*vp
     &   ata**2/vmata*mta**2-1d0/2/ctw**2*vpaup**2*vmata*us)
     &   +d0cctataqstszczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vmata*m
     &   z**2+1d0/2/ctw**2*vmaup**2*vmata*ts+1d0/8/ctw**2*vmaup**2*vmata*q
     &   s+1d0/2/ctw**2*vmaup**2*vpata*mta**2-1d0/2/ctw**2*vpaup**2*vpata*
     &   mta**2+1d0/2/ctw**2*vpaup**2*vpata**2/vmata*mta**2-1d0/2*sdet3cta
     &   ts/ctw**2*vpaup**2*vmata)
     &   +d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vpaup**
     &   2*vmata)
     &   +d0cctataqsuszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**2*vpata*
     &   mta**2+1d0/2/ctw**2*vmaup**2*vpata**2/vmata*mta**2+1d0/2/ctw**2*v
     &   paup**2*vmata*us-1d0/8/ctw**2*vpaup**2*vmata*qs+1d0/2/ctw**2*vpau
     &   p**2*vpata*mta**2-1d0/2*sdet3ctaus/ctw**2*vmaup**2*vmata)
     &   +c0tataqswcw*(3d0/2/vmata*mw**2*rtaw*rwz-1d0/vmata*mw**2*rtaw**2*
     &   rwz-1d0/2/vmata*mw**2*rtaw**3*rwz)
     &   +c0tataqsztaz*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vmata+1d0/2/
     &   ctw**2*vpaup**2*vmata)
     &   +c0tataqsztah*(3d0/8/vmata/qs*mw**4*rtaw/rwz**2-1d0/4/vmata/qs*mw
     &   **4*rtaw/rwz*rhw-1d0/8/vmata/qs*mw**4*rtaw*rhw**2-1d0/2/vmata*mw*
     &   *2*rtaw**2-1d0/qs*mw**4*rtaw/rwz**2+1d0/qs*mw**4*rtaw/rwz*rhw+mw*
     &   *2*rtaw/rwz)
     &   +c0tataqstazta*(1d0/2/vmata*mw**2*rtaw/rwz+4*mw**2/rwz**2-8*mw**2
     &   /rwz+4*mw**2-7d0/2*mw**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz-2
     &   *qs/rwz+4*qs-2*qs*rwz)
     &   +c0tataqstahta*(mw**2*rtaw**2)
     &   +c0tataqscwc*(-1d0/vmata*mw**2*rtaw)
     &   +c0ccqswcw*(-2/qs**2*mw**6+4/qs*mw**4)
     &   +c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vmata+1d0/2/ctw
     &   **2*vpaup**2*vmata)
     &   +c0ccqscwc*(-vpadn/qs*mw**4+2*vpadn*mw**2-vpadn*qs+2*qdn/qs**2*mw
     &   **6-4*qdn/qs*mw**4+2*qdn/qs*mw**4*rwz+2*qdn*mw**2-4*qdn*mw**2*rwz
     &   +2*qdn*qs*rwz)
     &   +c0ccqsczc*(-1d0/2/qs*mw**4/rwz**3+mw**2/rwz**2-1d0/2*qs/rwz+3d0/
     &   2*vpaup/qs*mw**4/rwz**3-3*vpaup*mw**2/rwz**2+3d0/2*vpaup*qs/rwz-3
     &   d0/2*vpaup**2/qs*mw**4/rwz**3+3*vpaup**2*mw**2/rwz**2-3d0/2*vpaup
     &   **2*qs/rwz-qup/qs**2*mw**6/rwz**3+qup/qs*mw**4/rwz**2+qup*mw**2/r
     &   wz-qup*qs+2*qup*vpaup/qs**2*mw**6/rwz**3-2*qup*vpaup/qs*mw**4/rwz
     &   **2-2*qup*vpaup*mw**2/rwz+2*qup*vpaup*qs)
     &   +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     &   -4*mw**2*rwz)
     &   +a0fw*(-2/qs**2*mw**4+7d0/3/qs*mw**2+4/qs*mw**2*rwz+vpadn/qs*mw**
     &   2-3d0/2*vpadn-2*qdn/qs**2*mw**4+3*qdn/qs*mw**2-2*qdn/qs*mw**2*rwz
     &   +3*qdn*rwz)
     &   +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     &   d0/12*mw**2/rwz*rhw)
     &   +a0fz*(5d0/12/qs*mw**2/rwz**2+1d0/12/qs*mw**2/rwz*rhw-7d0/8/rwz-3
     &   d0/2*vpaup/qs*mw**2/rwz**2+9d0/4*vpaup/rwz+3d0/2*vpaup**2/qs*mw**
     &   2/rwz**2-9d0/4*vpaup**2/rwz+qup/qs**2*mw**4/rwz**2-1d0/2*qup/qs*m
     &   w**2/rwz-3d0/2*qup-2*qup*vpaup/qs**2*mw**4/rwz**2+qup*vpaup/qs*mw
     &   **2/rwz+3*qup*vpaup)
     &   +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     &   +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     &   +a0fta*(-1+1d0/4/rwz+rwz+1d0/4*rtaw)
     &   +b0ftawc*(-1d0/vmata*rtaw*rwz-1d0/4*rtaw)
     &   +b0ftazta*(-7+3d0/8/vmata/qs*mw**2*rtaw/rwz+1d0/8/vmata/qs*mw**2*
     &   rtaw*rhw-1d0/qs*mw**2*rtaw/rwz+25d0/8/rwz+4*rwz)
     &   +b0ftahta*(-3d0/8/vmata/qs*mw**2*rtaw/rwz-1d0/8/vmata/qs*mw**2*rt
     &   aw*rhw+1d0/qs*mw**2*rtaw/rwz-1d0/8*rhw)
     &   +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     &   /3*mw**2-4*mw**2*rwz)
     &   +b0fqsww*dreal(propizqs)*(1d0/4/vmata/mw**2*rtaw*rwz)
     &   +b0fqsww*(1d0/6+1d0/vmata*rtaw*rwz+1d0/2/vmata*rtaw**2*rwz-1d0/4/
     &   vmata*qs/mw**2*rtaw*rwz-2/qs**2*mw**4+7d0/3/qs*mw**2+4/qs*mw**2*r
     &   wz-1d0/12/rwz)
     &   +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     &   mw**2*rhw**2)
     &   +b0fqszh*(1d0/4/vmata*rtaw-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/
     &   rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/12/rwz)
     &   +b0fqstata*(6-1d0/4/vmata*rtaw-3/rwz-3*rwz+1d0/4*rtaw)
     &   +b0fqscc*(1d0/4/vmata*rtaw+1d0/2/qs*mw**2/rwz**2-3d0/4/rwz+vpadn/
     &   qs*mw**2-3d0/2*vpadn-3d0/2*vpaup/qs*mw**2/rwz**2+9d0/4*vpaup/rwz+
     &   3d0/2*vpaup**2/qs*mw**2/rwz**2-9d0/4*vpaup**2/rwz-2*qdn/qs**2*mw*
     &   *4+3*qdn/qs*mw**2-2*qdn/qs*mw**2*rwz+3*qdn*rwz+qup/qs**2*mw**4/rw
     &   z**2-1d0/2*qup/qs*mw**2/rwz-3d0/2*qup-2*qup*vpaup/qs**2*mw**4/rwz
     &   **2+qup*vpaup/qs*mw**2/rwz+3*qup*vpaup)
     &   +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     &   /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     &   *mw**2-4*mw**2*rwz)
     &   +dreal(b0ptazta)*(-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2-7d0/4*m
     &   w**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz)
     &   +dreal(b0ptahta)*(-1d0/4*mw**2*rtaw*rhw+mw**2*rtaw**2)
     &   +dreal(b0ptacw)*(-1d0/2*mw**2+1d0/4*mw**2*rtaw+1d0/4*mw**2*rtaw**
     &   2)
     &   +b0d1tataz*(1-1d0/4/rwz-rwz)
     &   +b0dwtacw*(-1d0/2)
     &   +19d0/9+1d0/2/vmata*rtaw-1d0/2/vmata*rtaw*rwz-2d0/3/qs*mw**2+4/qs
     &   *mw**2*rwz-89d0/72/rwz-pizgfer+caldzfer-deltarhofer-za1fer-deltar
     &   hobos-za1bos-rwz-1d0/4*rtaw-vpadn+3d0/8*vpaup/rwz+3d0/4*vpaup-3d0
     &   /8*vpaup**2/rwz+2*qdn/qs*mw**2+2*qdn*rwz-1d0/4*qup/qs*mw**2/rwz-3
     &   d0/2*qup/qs*mw**2-1d0/4*qup-3d0/2*qup*rwz+1d0/2*qup*vpaup/qs*mw**
     &   2/rwz+1d0/2*qup*vpaup

        ff_ew_qq =
     &   +sdet3itataqs*c0tataqswcw*(7d0/4/vmata*mw**4-3/vmata*mw**4*rtaw+3
     &   d0/4/vmata*mw**4*rtaw**2+1d0/2/vmata*mw**4*rtaw**3)
     &   +sdet3itataqs*c0tataqsztah*(-3d0/8/vmata*mw**4*rtaw/rwz**2-1d0/4/
     &   vmata*mw**4*rtaw/rwz*rhw+1d0/8/vmata*mw**4*rtaw*rhw**2+1d0/vmata*
     &   mw**4*rtaw**2/rwz-1d0/vmata*mw**4*rtaw**2*rhw+2/vmata*mw**4*rtaw*
     &   *3)
     &   +sdet3itataqs*c0tataqstazta*(-3d0/16/stw**2*mw**4+3d0/4/stw**2*mw
     &   **4*rtaw-3d0/4/vmata*mw**4*rtaw/rwz**2-2/qs*mw**6/rwz**3+2/qs*mw*
     &   *6/rwz**2-2*mw**4/rwz**3+45d0/16*mw**4/rwz**2-3d0/16*mw**4/rwz-13
     &   d0/4*mw**4*rtaw/rwz**2+11d0/4*mw**4*rtaw/rwz)
     &   +sdet3itataqs*c0tataqstahta*(1d0/16/stw**2*mw**4*rhw**2-1d0/4/stw
     &   **2*mw**4*rtaw*rhw**2+1d0/4/vmata*mw**4*rtaw*rhw**2-1d0/vmata*mw*
     &   *4*rtaw**2*rhw)
     &   +sdet3itataqs*c0tataqscwc*(3d0/2/vmata*mw**4*rtaw+2/vmata*mw**4*r
     &   taw**2+1d0/2/vmata*mw**4*rtaw**3)
     &   +sdet3itataqs*b0ftawc*(-7d0/4/vmata*mw**2+11d0/4/vmata*mw**2*rtaw
     &   +1d0/vmata*mw**2*rtaw**2)
     &   +sdet3itataqs*b0ftazta*(-3d0/16/stw**2*mw**2+3d0/4/stw**2*mw**2*r
     &   taw-3d0/8/vmata*mw**2*rtaw/rwz-1d0/8/vmata*mw**2*rtaw*rhw+1d0/2/v
     &   mata*mw**2*rtaw**2-2/qs*mw**4/rwz**2+2/qs*mw**4/rwz-2*mw**2/rwz**
     &   2+45d0/16*mw**2/rwz-13d0/4*mw**2*rtaw/rwz+2*mw**2*rtaw)
     &   +sdet3itataqs*b0ftahta*(1d0/16/stw**2*mw**2*rhw-1d0/4/stw**2*mw**
     &   2*rtaw*rhw+3d0/8/vmata*mw**2*rtaw/rwz+1d0/8/vmata*mw**2*rtaw*rhw-
     &   1d0/2/vmata*mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqsww*(7d0/4/vmata*mw**2-5d0/4/vmata*mw**2*rtaw-1
     &   d0/2/vmata*mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqszh*(-3d0/4/vmata*mw**2*rtaw/rwz+1d0/4/vmata*mw
     &   **2*rtaw*rhw-1d0/vmata*mw**2*rtaw**2)
     &   +sdet3itataqs*b0fqstata*(3d0/16/stw**2*mw**2-1d0/16/stw**2*mw**2*
     &   rhw-3d0/4/stw**2*mw**2*rtaw+1d0/4/stw**2*mw**2*rtaw*rhw+3d0/4/vma
     &   ta*mw**2*rtaw/rwz-1d0/4/vmata*mw**2*rtaw*rhw+1d0/vmata*mw**2*rtaw
     &   **2+2/qs*mw**4/rwz**2-2/qs*mw**4/rwz+2*mw**2/rwz**2-45d0/16*mw**2
     &   /rwz+13d0/4*mw**2*rtaw/rwz-2*mw**2*rtaw)
     &   +sdet3itataqs*b0fqscc*(-3d0/2/vmata*mw**2*rtaw-1d0/2/vmata*mw**2*
     &   rtaw**2)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(1
     &   d0/2/ctw**2*vmaup*vmata*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup*vmata*ts*mta**2)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup*vmata*ts*mta**2)
     &   +sdet3ictats*c0ctatsczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vmat
     &   a*mta**2)
     &   +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*pxx2zqsc*(-
     &   1d0/2/ctw**2*vmaup*vpata**2/vmata*us*mta**2)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup*vpata**2/vmata*mta**4)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup*vpata**2/vmata*mta**4)
     &   +sdet3ictaus*c0ctausczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpa
     &   ta**2/vmata*mta**2)
     &   +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(1
     &   d0/4/ctw**2*vmaup*vmata*us*mta**4-1d0/4/ctw**2*vmaup*vmata*ts*mta
     &   **4+sdet3ctats**2/ctw**2*vmaup*vmata*mta**2+1d0/4*sdet3ctats**2/c
     &   tw**2*vmaup*vmata*qs)
     &   +sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(1
     &   d0/4*sdet3ctaus/ctw**2*vmaup*vpata**2/vmata*mta**4-1d0/4*sdet3cta
     &   us/ctw**2*vmaup*vpata**2/vmata*us*mta**2)
     &   +sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(sdet3ctat
     &   s/ctw**2*vmaup*vmata*ts*mta**2+1d0/4*sdet3ctats/ctw**2*vmaup*vmat
     &   a*qs*ts+sdet3ctaus/ctw**2*vmaup*vpata**2/vmata*mta**4+1d0/4*sdet3
     &   ctaus/ctw**2*vmaup*vpata**2/vmata*qs*mta**2)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(-1d0/2*sde
     &   t3ctats/ctw**2*vmaup*vmata*ts*mta**2+1d0/2*sdet3ctats/ctw**2*vmau
     &   p*vmata*ts**2)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*pxx2zqsc*(-1d0/2*sde
     &   t3ctaus/ctw**2*vmaup*vpata**2/vmata*mta**4+1d0/2*sdet3ctaus/ctw**
     &   2*vmaup*vpata**2/vmata*us*mta**2)
     &   +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**
     &   2*vmaup*vpata**2/vmata*qs*mta**4+1d0/4/ctw**2*vmaup*vpata**2/vmat
     &   a*qs*us*mta**2+1d0/4*sdet3ctats**2/ctw**2*vmaup*vmata*mta**2-1d0/
     &   4*sdet3ctats**2/ctw**2*vmaup*vmata*ts)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(3d0/
     &   8/ctw**2*vmaup*vmata*mta**2+1d0/8*sdet3ctats/ctw**2*vmaup*vmata)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc*(1d0/4/c
     &   tw**2*vmaup*vmata*mta**4-3d0/4/ctw**2*vmaup*vmata*ts**2-1d0/2/ctw
     &   **2*vmaup*vpata*ts*mta**2)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/8*sdet3ctat
     &   s/ctw**2*vmaup*vmata*qs*mta**2+1d0/8*sdet3ctats/ctw**2*vmaup*vmat
     &   a*qs*ts)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(1d0/
     &   8/ctw**2*vmaup*vpata**2/vmata*mta**2)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     &   ctw**2*vmaup*vpata*mta**4+1d0/2/ctw**2*vmaup*vpata**2/vmata*mta**
     &   4-1d0/4/ctw**2*vmaup*vpata**2/vmata*qs*mta**2-sdet3ctaus/ctw**2*v
     &   maup*vpata**2/vmata*mta**2)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(1d0/8/ctw**2*vma
     &   up*vpata**2/vmata*qs*us*mta**2-1d0/8/ctw**2*vmaup*vpata**2/vmata*
     &   qs*ts*mta**2)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2
     &   *vmaup*vmata*mta**2+1d0/4/ctw**2*vmaup*vpata**2/vmata*mta**2)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vm
     &   ata*ts*mta**2-1d0/2/ctw**2*vmaup*vmata*ts**2+1d0/2/ctw**2*vmaup*v
     &   pata**2/vmata*mta**4-1d0/2/ctw**2*vmaup*vpata**2/vmata*us*mta**2)
     &
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(1d0/ctw**2*vmaup*vmata
     &   *ts**2+1d0/ctw**2*vmaup*vpata*ts*mta**2)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*(1d0/ctw**2*vmaup*vpata
     &   *mta**4+1d0/ctw**2*vmaup*vpata**2/vmata*us*mta**2)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**2*v
     &   maup*vmata*ts+1d0/4/ctw**2*vmaup*vpata**2/vmata*mta**2)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/2*sdet3ctats/ctw**2
     &   *vmaup*vmata*ts-sdet3ctats/ctw**2*vmaup*vpata*mta**2-1d0/2*sdet3c
     &   taus/ctw**2*vmaup*vpata**2/vmata*mta**2)
     &   +sdet4itatsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmata*
     &   ts-1d0/2/ctw**2*vmaup*vpata**2/vmata*mta**2)
     &   +sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vmata*
     &   ts)
     &   +sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpata*
     &   *2/vmata*mta**2)
     &   +d0cctataqstszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmata*mz*
     &   *2-1d0/2/ctw**2*vmaup*vmata*ts-1d0/8/ctw**2*vmaup*vmata*qs-1d0/2/
     &   ctw**2*vmaup*vpata*mta**2)
     &   +d0cctataqsuszczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpata*mta*
     &   *2-1d0/2/ctw**2*vmaup*vpata**2/vmata*mta**2+1d0/2*sdet3ctaus/ctw*
     &   *2*vmaup*vmata)
     &   +c0tataqswcw*(-7d0/4/vmata/qs*mw**4+3d0/2/vmata/qs*mw**4*rtaw+1d0
     &   /4/vmata/qs*mw**4*rtaw**2)
     &   +c0tataqsztaz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmata)
     &   +c0tataqsztah*(3d0/8/vmata/qs*mw**4*rtaw/rwz**2-1d0/4/vmata/qs*mw
     &   **4*rtaw/rwz*rhw-1d0/8/vmata/qs*mw**4*rtaw*rhw**2-1d0/2/vmata*mw*
     &   *2*rtaw**2-1d0/qs*mw**4*rtaw/rwz**2+1d0/qs*mw**4*rtaw/rwz*rhw+mw*
     &   *2*rtaw/rwz)
     &   +c0tataqstazta*(3d0/16/stw**2/qs*mw**4-1d0/2/stw**2/qs*mw**4*rtaw
     &   -1d0/2/stw**2*mw**2*rtaw+1d0/2/vmata*mw**2*rtaw/rwz+51d0/16/qs*mw
     &   **4/rwz**2-61d0/16/qs*mw**4/rwz-5d0/2/qs*mw**4*rtaw/rwz+4/qs*mw**
     &   4*rtaw+4*mw**2/rwz**2-6*mw**2/rwz+2*mw**2-7d0/2*mw**2*rtaw/rwz+4*
     &   mw**2*rtaw-2*qs/rwz+2*qs)
     &   +c0tataqstahta*(-1d0/16/stw**2/qs*mw**4*rhw**2+1d0/stw**2/qs*mw**
     &   4*rtaw**2+1d0/stw**2*mw**2*rtaw**2)
     &   +c0tataqscwc*(-1d0/vmata*mw**2*rtaw)
     &   +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmata)
     &   +c0ccqsczc*(-1d0/2/stw**2/qs**2*mw**6+1d0/2/stw**2/qs*mw**4+1d0/2
     &   /stw**2*mw**2-1d0/2/stw**2*qs+1d0/stw**2*vpaup/qs**2*mw**6-1d0/st
     &   w**2*vpaup/qs*mw**4-1d0/stw**2*vpaup*mw**2+1d0/stw**2*vpaup*qs-1d
     &   0/2/stw**2*vpaup**2/qs**2*mw**6+1d0/2/stw**2*vpaup**2/qs*mw**4+1d
     &   0/2/stw**2*vpaup**2*mw**2-1d0/2/stw**2*vpaup**2*qs-1d0/2/qs**2*mw
     &   **6/rwz**3-1d0/2/qs**2*mw**6/rwz**2-1d0/2/qs**2*mw**6/rwz-1d0/2/q
     &   s*mw**4/rwz**3+1d0/2/qs*mw**4/rwz**2+1d0/2/qs*mw**4/rwz+mw**2/rwz
     &   **2+1d0/2*mw**2/rwz-1d0/2*qs/rwz+vpaup/qs**2*mw**6/rwz**3+vpaup/q
     &   s**2*mw**6/rwz**2+vpaup/qs**2*mw**6/rwz+vpaup/qs*mw**4/rwz**3-vpa
     &   up/qs*mw**4/rwz**2-vpaup/qs*mw**4/rwz-2*vpaup*mw**2/rwz**2-vpaup*
     &   mw**2/rwz+vpaup*qs/rwz-1d0/2*vpaup**2/qs**2*mw**6/rwz**3-1d0/2*vp
     &   aup**2/qs**2*mw**6/rwz**2-1d0/2*vpaup**2/qs**2*mw**6/rwz-1d0/2*vp
     &   aup**2/qs*mw**4/rwz**3+1d0/2*vpaup**2/qs*mw**4/rwz**2+1d0/2*vpaup
     &   **2/qs*mw**4/rwz+vpaup**2*mw**2/rwz**2+1d0/2*vpaup**2*mw**2/rwz-1
     &   d0/2*vpaup**2*qs/rwz)
     &   +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     &   -4*mw**2*rwz)
     &   +a0fw*(-4/qs**2*mw**4+8d0/3/qs*mw**2+4/qs*mw**2*rwz)
     &   +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     &   d0/12*mw**2/rwz*rhw)
     &   +a0fz*(1d0/2/stw**2/qs**2*mw**4-3d0/8/stw**2/qs*mw**2-7d0/8/stw**
     &   2-1d0/stw**2*vpaup/qs**2*mw**4+1d0/2/stw**2*vpaup/qs*mw**2+3d0/2/
     &   stw**2*vpaup+1d0/2/stw**2*vpaup**2/qs**2*mw**4-1d0/4/stw**2*vpaup
     &   **2/qs*mw**2-3d0/4/stw**2*vpaup**2+1d0/2/qs**2*mw**4/rwz**2+1d0/2
     &   /qs**2*mw**4/rwz+5d0/12/qs*mw**2/rwz**2-3d0/8/qs*mw**2/rwz+1d0/12
     &   /qs*mw**2/rwz*rhw-7d0/8/rwz-vpaup/qs**2*mw**4/rwz**2-vpaup/qs**2*
     &   mw**4/rwz-vpaup/qs*mw**2/rwz**2+1d0/2*vpaup/qs*mw**2/rwz+3d0/2*vp
     &   aup/rwz+1d0/2*vpaup**2/qs**2*mw**4/rwz**2+1d0/2*vpaup**2/qs**2*mw
     &   **4/rwz+1d0/2*vpaup**2/qs*mw**2/rwz**2-1d0/4*vpaup**2/qs*mw**2/rw
     &   z-3d0/4*vpaup**2/rwz)
     &   +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     &   +a0fh*(-1d0/8/stw**2/qs*mw**2*rhw-1d0/8/stw**2*rhw+1d0/12/qs*mw**
     &   2/rwz*rhw-1d0/12/qs*mw**2*rhw**2)
     &   +a0fta*(-1+1d0/4/stw**2/qs*mw**2+1d0/4/stw**2/qs*mw**2*rtaw+1d0/4
     &   /stw**2+1d0/4/stw**2*rtaw+1d0/4/qs*mw**2/rwz-1d0/qs*mw**2+1d0/4/r
     &   wz)
     &   +b0ftawc*(-1d0/4/stw**2/qs*mw**2*rtaw-1d0/4/stw**2*rtaw+7d0/4/vma
     &   ta/qs*mw**2+1d0/4/vmata/qs*mw**2*rtaw)
     &   +b0ftazta*(-4+5d0/16/stw**2/qs*mw**2+1d0/8/stw**2+3d0/8/vmata/qs*
     &   mw**2*rtaw/rwz+1d0/8/vmata/qs*mw**2*rtaw*rhw+37d0/16/qs*mw**2/rwz
     &   -4/qs*mw**2-1d0/qs*mw**2*rtaw/rwz+25d0/8/rwz)
     &   +b0ftahta*(-3d0/16/stw**2/qs*mw**2*rhw-1d0/8/stw**2*rhw-3d0/8/vma
     &   ta/qs*mw**2*rtaw/rwz-1d0/8/vmata/qs*mw**2*rtaw*rhw+1d0/qs*mw**2*r
     &   taw/rwz)
     &   +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     &   /3*mw**2-4*mw**2*rwz)
     &   +b0fqsww*(-7d0/4/vmata/qs*mw**2+1d0/4/vmata/qs*mw**2*rtaw+1d0/4/v
     &   mata*rtaw-4/qs**2*mw**4+17d0/3/qs*mw**2+4/qs*mw**2*rwz-1d0/12/rwz
     &   )
     &   +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     &   mw**2*rhw**2)
     &   +b0fqszh*(1d0/4/vmata*rtaw-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/
     &   rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/12/rwz)
     &   +b0fqstata*(3-3d0/16/stw**2/qs*mw**2+1d0/16/stw**2/qs*mw**2*rhw+1
     &   d0/4/stw**2/qs*mw**2*rtaw+1d0/4/stw**2*rtaw-1d0/4/vmata*rtaw-35d0
     &   /16/qs*mw**2/rwz+3/qs*mw**2-3/rwz)
     &   +b0fqscc*(1d0/2/stw**2/qs**2*mw**4-1d0/4/stw**2/qs*mw**2-3d0/4/st
     &   w**2-1d0/stw**2*vpaup/qs**2*mw**4+1d0/2/stw**2*vpaup/qs*mw**2+3d0
     &   /2/stw**2*vpaup+1d0/2/stw**2*vpaup**2/qs**2*mw**4-1d0/4/stw**2*vp
     &   aup**2/qs*mw**2-3d0/4/stw**2*vpaup**2+1d0/4/vmata*rtaw+1d0/2/qs**
     &   2*mw**4/rwz**2+1d0/2/qs**2*mw**4/rwz+1d0/2/qs*mw**2/rwz**2-1d0/4/
     &   qs*mw**2/rwz-3d0/4/rwz-vpaup/qs**2*mw**4/rwz**2-vpaup/qs**2*mw**4
     &   /rwz-vpaup/qs*mw**2/rwz**2+1d0/2*vpaup/qs*mw**2/rwz+3d0/2*vpaup/r
     &   wz+1d0/2*vpaup**2/qs**2*mw**4/rwz**2+1d0/2*vpaup**2/qs**2*mw**4/r
     &   wz+1d0/2*vpaup**2/qs*mw**2/rwz**2-1d0/4*vpaup**2/qs*mw**2/rwz-3d0
     &   /4*vpaup**2/rwz)
     &   +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     &   /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     &   *mw**2-4*mw**2*rwz)
     &   +dreal(b0ptazta)*(-1d0/4/stw**2/qs*mw**4+1d0/4/stw**2/qs*mw**4*rt
     &   aw-1d0/4/stw**2*mw**2+1d0/4/stw**2*mw**2*rtaw-5d0/4/qs*mw**4/rwz*
     &   *2+7d0/4/qs*mw**4/rwz-7d0/4/qs*mw**4*rtaw/rwz+4/qs*mw**4*rtaw-5d0
     &   /4*mw**2/rwz**2+7d0/4*mw**2/rwz-7d0/4*mw**2*rtaw/rwz+4*mw**2*rtaw
     &   )
     &   +dreal(b0ptahta)*(-1d0/4/stw**2/qs*mw**4*rtaw*rhw+1d0/stw**2/qs*m
     &   w**4*rtaw**2-1d0/4/stw**2*mw**2*rtaw*rhw+1d0/stw**2*mw**2*rtaw**2
     &   )
     &   +dreal(b0ptacw)*(-1d0/2/stw**2/qs*mw**4+1d0/4/stw**2/qs*mw**4*rta
     &   w+1d0/4/stw**2/qs*mw**4*rtaw**2-1d0/2/stw**2*mw**2+1d0/4/stw**2*m
     &   w**2*rtaw+1d0/4/stw**2*mw**2*rtaw**2)
     &   +b0d1tataz*(1-1d0/4/stw**2/qs*mw**2-1d0/4/stw**2-1d0/4/qs*mw**2/r
     &   wz+1d0/qs*mw**2-1d0/4/rwz)
     &   +b0dwtacw*(-1d0/2/stw**2/qs*mw**2-1d0/2/stw**2)
     &   +1-1d0/8/stw**2/qs*mw**2-1d0/stw**2/qs*mw**2*za1bos-1d0/4/stw**2/
     &   qs*mw**2*rtaw-1d0/8/stw**2-1d0/stw**2*deltarhofer-1d0/stw**2*delt
     &   arhobos-1d0/stw**2*za1bos-1d0/4/stw**2*rtaw+1d0/4/stw**2*vpaup/qs
     &   *mw**2+1d0/4/stw**2*vpaup-1d0/8/stw**2*vpaup**2/qs*mw**2-1d0/8/st
     &   w**2*vpaup**2+1d0/2/vmata/qs*mw**2*rtaw+1d0/2/vmata*rtaw-4/qs**2*
     &   mw**4-9d0/8/qs*mw**2/rwz+11d0/3/qs*mw**2+4/qs*mw**2*rwz-89d0/72/r
     &   wz-2*pizgfer+caldzfer-za1fer+1d0/4*vpaup/qs*mw**2/rwz+1d0/4*vpaup
     &   /rwz-1d0/8*vpaup**2/qs*mw**2/rwz-1d0/8*vpaup**2/rwz

        ff_ew_ld =
     &   +det3itataqs*sdet4itatsus*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(
     &   -1d0/8/ctw**2*vmaup**2*vmata**2*qs*mta**2+1d0/8/ctw**2*vmaup**2*v
     &   mata**2*qs*ts+1d0/8/ctw**2*vmaup**2*vpata**2*qs*mta**2-1d0/8/ctw*
     &   *2*vmaup**2*vpata**2*qs*us-1d0/8/ctw**2*vpaup**2*vmata**2*qs*mta*
     &   *2+1d0/8/ctw**2*vpaup**2*vmata**2*qs*us+1d0/8/ctw**2*vpaup**2*vpa
     &   ta**2*qs*mta**2-1d0/8/ctw**2*vpaup**2*vpata**2*qs*ts)
     &   +det3itataqs*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/4/ctw**2*
     &   vmaup**2*vmata**2*qs*mta**2-1d0/4/ctw**2*vmaup**2*vmata**2*qs*ts-
     &   1d0/4/ctw**2*vmaup**2*vpata**2*qs*mta**2+1d0/4/ctw**2*vmaup**2*vp
     &   ata**2*qs*us+1d0/4/ctw**2*vpaup**2*vmata**2*qs*mta**2-1d0/4/ctw**
     &   2*vpaup**2*vmata**2*qs*us-1d0/4/ctw**2*vpaup**2*vpata**2*qs*mta**
     &   2+1d0/4/ctw**2*vpaup**2*vpata**2*qs*ts)
     &   +det3itataqs*sdet4itatsus*b0fqszz*dreal(propizqs)*(-1d0/4/ctw**2*
     &   vmaup**2*vmata**2*qs*mta**2+1d0/4/ctw**2*vmaup**2*vmata**2*qs*ts+
     &   1d0/4/ctw**2*vmaup**2*vpata**2*qs*mta**2-1d0/4/ctw**2*vmaup**2*vp
     &   ata**2*qs*us-1d0/4/ctw**2*vpaup**2*vmata**2*qs*mta**2+1d0/4/ctw**
     &   2*vpaup**2*vmata**2*qs*us+1d0/4/ctw**2*vpaup**2*vpata**2*qs*mta**
     &   2-1d0/4/ctw**2*vpaup**2*vpata**2*qs*ts)
     &   +sdet3itataqs**2*c0tataqswcw*dreal(propizqs)*(-3*mw**2*rtaw*rwz+6
     &   *mw**2*rtaw**2*rwz-3*mw**2*rtaw**3*rwz)
     &   +sdet3itataqs**2*c0tataqswcw*(12*mw**4*rwz-18*mw**4*rtaw*rwz-12*m
     &   w**4*rtaw**2*rwz+30*mw**4*rtaw**3*rwz-12*mw**4*rtaw**4*rwz)
     &   +sdet3itataqs**2*c0tataqstazta*(27*mw**4/rwz**3-90*mw**4/rwz**2+1
     &   08*mw**4/rwz-48*mw**4+9d0/2*mw**4*rtaw/rwz**2-6*mw**4*rtaw/rwz)
     &   +sdet3itataqs**2*c0tataqstahta*(9d0/2*mw**4*rtaw*rhw**2-6*mw**4*r
     &   taw*rwz*rhw**2)
     &   +sdet3itataqs**2*c0tataqscwc*(6*mw**4+15*mw**4*rtaw+12*mw**4*rtaw
     &   **2+3*mw**4*rtaw**3)
     &   +sdet3itataqs**2*b0ftawc*(6*mw**2-12*mw**2*rwz+12*mw**2*rtaw+6*mw
     &   **2*rtaw*rwz+6*mw**2*rtaw**2*rwz)
     &   +sdet3itataqs**2*b0ftazta*(27*mw**2/rwz**2-90*mw**2/rwz+108*mw**2
     &   -48*mw**2*rwz+9d0/2*mw**2*rtaw/rwz-6*mw**2*rtaw)
     &   +sdet3itataqs**2*b0ftahta*(9d0/2*mw**2*rtaw*rhw-6*mw**2*rtaw*rwz*
     &   rhw)
     &   +sdet3itataqs**2*b0fqsww*dreal(propizqs)*(-3*rtaw*rwz+3*rtaw**2*r
     &   wz)
     &   +sdet3itataqs**2*b0fqsww*(12*mw**2*rwz-6*mw**2*rtaw*rwz-18*mw**2*
     &   rtaw**2*rwz+12*mw**2*rtaw**3*rwz)
     &   +sdet3itataqs**2*b0fqstata*(-27*mw**2/rwz**2+90*mw**2/rwz-108*mw*
     &   *2+48*mw**2*rwz-9d0/2*mw**2*rtaw/rwz+6*mw**2*rtaw-9d0/2*mw**2*rta
     &   w*rhw+6*mw**2*rtaw*rwz*rhw)
     &   +sdet3itataqs**2*b0fqscc*(-6*mw**2-9*mw**2*rtaw-3*mw**2*rtaw**2)
     &   +sdet3itataqs*c0tataqswcw*dreal(propizqs)*(2*rwz-3*rtaw*rwz+rtaw*
     &   *2*rwz)
     &   +sdet3itataqs*c0tataqswcw*(-4*mw**2*rwz+17*mw**2*rtaw*rwz-20*mw**
     &   2*rtaw**2*rwz+7*mw**2*rtaw**3*rwz)
     &   +sdet3itataqs*c0tataqsztah*(-3d0/2*mw**2/rwz**2+2*mw**2/rwz-3d0/2
     &   *mw**2/rwz*rhw+2*mw**2*rhw+6*mw**2*rtaw/rwz-8*mw**2*rtaw)
     &   +sdet3itataqs*c0tataqstazta*(-24*mw**2/rwz**2+68*mw**2/rwz-72*mw*
     &   *2+32*mw**2*rwz-3d0/2*mw**2*rtaw/rwz+2*mw**2*rtaw)
     &   +sdet3itataqs*c0tataqstahta*(-9d0/2*mw**2*rtaw*rhw+6*mw**2*rtaw*r
     &   wz*rhw)
     &   +sdet3itataqs*c0tataqscwc*(-8*mw**2-8*mw**2*rtaw-mw**2*rtaw**2)
     &   +sdet3itataqs*a0fw*(1-4/qs*mw**2+8/qs*mw**2*rwz-rwz)
     &   +sdet3itataqs*a0fz*(-1-18/qs*mw**2/rwz**2+60/qs*mw**2/rwz-72/qs*m
     &   w**2+32/qs*mw**2*rwz+3d0/4/rwz)
     &   +sdet3itataqs*a0fh*(3d0/4*rhw-rwz*rhw)
     &   +sdet3itataqs*a0fta*(15-9d0/2/rwz-18*rwz+8*rwz**2-3d0/2*rtaw+2*rt
     &   aw*rwz)
     &   +sdet3itataqs*b0ftawc*dreal(propizqs)*(-1d0/mw**2*rwz)
     &   +sdet3itataqs*b0ftawc*(-5-4/qs*mw**2+8/qs*mw**2*rwz+5*rwz-5*rtaw*
     &   rwz)
     &   +sdet3itataqs*b0ftazta*(35-18/qs*mw**2/rwz**2+60/qs*mw**2/rwz-72/
     &   qs*mw**2+32/qs*mw**2*rwz-51d0/4/rwz-36*rwz+16*rwz**2)
     &   +sdet3itataqs*b0ftahta*(-2+3d0/2/rwz+3d0/4*rhw-rwz*rhw-3*rtaw+4*r
     &   taw*rwz)
     &   +sdet3itataqs*b0fqsww*dreal(propizqs)*(2/mw**2*rwz-1d0/2/mw**2*rt
     &   aw*rwz)
     &   +sdet3itataqs*b0fqsww*(-6*rwz+12*rtaw*rwz-5*rtaw**2*rwz)
     &   +sdet3itataqs*b0fqszh*(4-3/rwz)
     &   +sdet3itataqs*b0fqstata*(-23+21d0/2/rwz+18*rwz-8*rwz**2+3d0/2*rta
     &   w-2*rtaw*rwz)
     &   +sdet3itataqs*b0fqscc*(5+1d0/2*rtaw)
     &   +sdet3itataqs*(-14+9d0/2/rwz+20*rwz-8*rwz**2+3d0/2*rtaw-rtaw*rwz)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(1
     &   d0/2/ctw**2*vmaup**2*vmata**2*ts-1d0/2/ctw**2*vpaup**2*vpata**2*t
     &   s)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup**2*vmata**2*ts-1d0/ctw**2*vpaup**2*vpata**2*ts)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup**2*vmata**2*ts+1d0/ctw**2*vpaup**2*vpata**2*ts)
     &   +sdet3ictats*c0ctatsczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*v
     &   mata**2-1d0/2/ctw**2*vpaup**2*vpata**2)
     &   +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*pxx2zqsc*(-
     &   1d0/2/ctw**2*vmaup**2*vpata**2*us+1d0/2/ctw**2*vpaup**2*vmata**2*
     &   us)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup**2*vpata**2*us+1d0/ctw**2*vpaup**2*vmata**2*us)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup**2*vpata**2*us-1d0/ctw**2*vpaup**2*vmata**2*us)
     &   +sdet3ictaus*c0ctausczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**2*
     &   vpata**2+1d0/2/ctw**2*vpaup**2*vmata**2)
     &   +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(1
     &   d0/2*sdet3ctats/ctw**2*vmaup**2*vmata**2*ts-1d0/2*sdet3ctats/ctw*
     &   *2*vpaup**2*vpata**2*ts)
     &   +sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(-
     &   1d0/2*sdet3ctaus/ctw**2*vmaup**2*vpata**2*us+1d0/2*sdet3ctaus/ctw
     &   **2*vpaup**2*vmata**2*us)
     &   +sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(-1d0/2*sd
     &   et3ctats/ctw**2*vmaup**2*vmata**2*mta**2+1d0/2*sdet3ctats/ctw**2*
     &   vmaup**2*vmata**2*ts+1d0/2*sdet3ctats/ctw**2*vpaup**2*vpata**2*mt
     &   a**2-1d0/2*sdet3ctats/ctw**2*vpaup**2*vpata**2*ts+1d0/2*sdet3ctau
     &   s/ctw**2*vmaup**2*vpata**2*mta**2-1d0/2*sdet3ctaus/ctw**2*vmaup**
     &   2*vpata**2*us-1d0/2*sdet3ctaus/ctw**2*vpaup**2*vmata**2*mta**2+1d
     &   0/2*sdet3ctaus/ctw**2*vpaup**2*vmata**2*us)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(-sdet3ctat
     &   s/ctw**2*vmaup**2*vmata**2*ts+sdet3ctats/ctw**2*vpaup**2*vpata**2
     &   *ts)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*pxx2zqsc*(sdet3ctaus
     &   /ctw**2*vmaup**2*vpata**2*us-sdet3ctaus/ctw**2*vpaup**2*vmata**2*
     &   us)
     &   +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/2/ctw**
     &   2*vmaup**2*vmata**2*qs*ts+1d0/2/ctw**2*vmaup**2*vpata**2*qs*us-1d
     &   0/2/ctw**2*vpaup**2*vmata**2*qs*us+1d0/2/ctw**2*vpaup**2*vpata**2
     &   *qs*ts)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     &   ctw**2*vmaup**2*vmata**2*mta**2-1d0/2/ctw**2*vmaup**2*vpata*vmata
     &   *ts+1d0/2/ctw**2*vpaup**2*vpata*vmata*ts+1d0/2/ctw**2*vpaup**2*vp
     &   ata**2*mta**2+5d0/4*sdet3ctats/ctw**2*vmaup**2*vmata**2-5d0/4*sde
     &   t3ctats/ctw**2*vpaup**2*vpata**2)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/4*sdet3ctat
     &   s/ctw**2*vmaup**2*vmata**2*qs+1d0/4*sdet3ctats/ctw**2*vpaup**2*vp
     &   ata**2*qs)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     &   tw**2*vmaup**2*vpata*vmata*us+1d0/2/ctw**2*vmaup**2*vpata**2*mta*
     &   *2-1d0/2/ctw**2*vpaup**2*vmata**2*mta**2-1d0/2/ctw**2*vpaup**2*vp
     &   ata*vmata*us-5d0/4*sdet3ctaus/ctw**2*vmaup**2*vpata**2+5d0/4*sdet
     &   3ctaus/ctw**2*vpaup**2*vmata**2)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(1d0/4*sdet3ctaus
     &   /ctw**2*vmaup**2*vpata**2*qs-1d0/4*sdet3ctaus/ctw**2*vpaup**2*vma
     &   ta**2*qs)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**
     &   2*vmaup**2*vmata**2+1d0/4/ctw**2*vmaup**2*vpata**2-1d0/4/ctw**2*v
     &   paup**2*vmata**2+1d0/4/ctw**2*vpaup**2*vpata**2)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(1d0/ctw**2*vmaup**2*v
     &   mata**2*ts+1d0/4/ctw**2*vmaup**2*vmata**2*qs+1d0/2/ctw**2*vmaup**
     &   2*vpata*vmata*us-1d0/2/ctw**2*vmaup**2*vpata*vmata*ts-1d0/ctw**2*
     &   vmaup**2*vpata**2*us-1d0/4/ctw**2*vmaup**2*vpata**2*qs+1d0/ctw**2
     &   *vpaup**2*vmata**2*us+1d0/4/ctw**2*vpaup**2*vmata**2*qs-1d0/2/ctw
     &   **2*vpaup**2*vpata*vmata*us+1d0/2/ctw**2*vpaup**2*vpata*vmata*ts-
     &   1d0/ctw**2*vpaup**2*vpata**2*ts-1d0/4/ctw**2*vpaup**2*vpata**2*qs
     &   )
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup**2
     &   *vmata**2*mta**2-3d0/2/ctw**2*vmaup**2*vmata**2*ts+1d0/ctw**2*vma
     &   up**2*vpata*vmata*ts-1d0/ctw**2*vpaup**2*vpata*vmata*ts+1d0/2/ctw
     &   **2*vpaup**2*vpata**2*mta**2+3d0/2/ctw**2*vpaup**2*vpata**2*ts)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*(-1d0/ctw**2*vmaup**2*v
     &   pata*vmata*us+1d0/2/ctw**2*vmaup**2*vpata**2*mta**2+3d0/2/ctw**2*
     &   vmaup**2*vpata**2*us-1d0/2/ctw**2*vpaup**2*vmata**2*mta**2-3d0/2/
     &   ctw**2*vpaup**2*vmata**2*us+1d0/ctw**2*vpaup**2*vpata*vmata*us)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**2*v
     &   maup**2*vmata**2+1d0/4/ctw**2*vmaup**2*vpata**2-1d0/4/ctw**2*vpau
     &   p**2*vmata**2+1d0/4/ctw**2*vpaup**2*vpata**2)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/4/ctw**2*vmaup**2*v
     &   mata**2*qs+1d0/2/ctw**2*vmaup**2*vpata*vmata*us-1d0/2/ctw**2*vmau
     &   p**2*vpata*vmata*ts+1d0/4/ctw**2*vmaup**2*vpata**2*qs-1d0/4/ctw**
     &   2*vpaup**2*vmata**2*qs-1d0/2/ctw**2*vpaup**2*vpata*vmata*us+1d0/2
     &   /ctw**2*vpaup**2*vpata*vmata*ts+1d0/4/ctw**2*vpaup**2*vpata**2*qs
     &   +1d0/2*sdet3ctats/ctw**2*vmaup**2*vmata**2-1d0/2*sdet3ctats/ctw**
     &   2*vpaup**2*vpata**2-1d0/2*sdet3ctaus/ctw**2*vmaup**2*vpata**2+1d0
     &   /2*sdet3ctaus/ctw**2*vpaup**2*vmata**2)
     &   +d0cctataqstszczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vmata**
     &   2-1d0/2/ctw**2*vmaup**2*vpata*vmata+1d0/2/ctw**2*vpaup**2*vpata*v
     &   mata-1d0/2/ctw**2*vpaup**2*vpata**2)
     &   +d0cctataqsuszczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup**2*vpata*v
     &   mata-1d0/2/ctw**2*vmaup**2*vpata**2+1d0/2/ctw**2*vpaup**2*vmata**
     &   2-1d0/2/ctw**2*vpaup**2*vpata*vmata)
     &   +c0tataqswcw*(-2*rwz+3*rtaw*rwz-rtaw**2*rwz)
     &   +c0tataqsztah*(3d0/2/qs*mw**2/rwz**2-2/qs*mw**2/rwz-3d0/2/qs*mw**
     &   2/rwz*rhw+2/qs*mw**2*rhw)
     &   +c0tataqstazta*(-4+3/rwz)
     &   +c0tataqscwc*(2)
     &   +b0ftawc*(1d0/mw**2*rwz)
     &   +b0ftazta*(3d0/2/qs/rwz-2/qs)
     &   +b0ftahta*(-3d0/2/qs/rwz+2/qs)
     &   +b0fqsww*(-2/mw**2*rwz+1d0/2/mw**2*rtaw*rwz)
     &   +b0d1tataz*(9d0/2/qs/rwz-15/qs+18/qs*rwz-8/qs*rwz**2)
     &   +b0dwtacw*(1d0/qs-2/qs*rwz)

        ff_ew_qd =
     &   +det3itataqs*sdet4itatsus*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(
     &   1d0/8/ctw**2*vmaup*vmata**2*qs*mta**2-1d0/8/ctw**2*vmaup*vmata**2
     &   *qs*ts-1d0/8/ctw**2*vmaup*vpata**2*qs*mta**2+1d0/8/ctw**2*vmaup*v
     &   pata**2*qs*us)
     &   +det3itataqs*sdet4itatsus*b0ftazta*dreal(propizqs)*(-1d0/4/ctw**2
     &   *vmaup*vmata**2*qs*mta**2+1d0/4/ctw**2*vmaup*vmata**2*qs*ts+1d0/4
     &   /ctw**2*vmaup*vpata**2*qs*mta**2-1d0/4/ctw**2*vmaup*vpata**2*qs*u
     &   s)
     &   +det3itataqs*sdet4itatsus*b0fqszz*dreal(propizqs)*(1d0/4/ctw**2*v
     &   maup*vmata**2*qs*mta**2-1d0/4/ctw**2*vmaup*vmata**2*qs*ts-1d0/4/c
     &   tw**2*vmaup*vpata**2*qs*mta**2+1d0/4/ctw**2*vmaup*vpata**2*qs*us)
     &
     &   +sdet3itataqs**2*c0tataqswcw*(-12/qs*mw**6-9d0/2*mw**4-3*mw**4*rt
     &   aw+15d0/2*mw**4*rtaw**2-3*mw**4*rtaw**3)
     &   +sdet3itataqs**2*c0tataqstazta*(30/qs*mw**6/rwz**3-72/qs*mw**6/rw
     &   z**2+48/qs*mw**6/rwz+27*mw**4/rwz**3-123d0/2*mw**4/rwz**2+36*mw**
     &   4/rwz+9d0/2*mw**4*rtaw/rwz**2)
     &   +sdet3itataqs**2*c0tataqstahta*(-3d0/2*mw**4*rhw**2+9d0/2*mw**4*r
     &   taw*rhw**2)
     &   +sdet3itataqs**2*c0tataqscwc*(6*mw**4+15*mw**4*rtaw+12*mw**4*rtaw
     &   **2+3*mw**4*rtaw**3)
     &   +sdet3itataqs**2*b0ftawc*(12/qs*mw**4+15d0/2*mw**2+27d0/2*mw**2*r
     &   taw)
     &   +sdet3itataqs**2*b0ftazta*(30/qs*mw**4/rwz**2-72/qs*mw**4/rwz+48/
     &   qs*mw**4+27*mw**2/rwz**2-123d0/2*mw**2/rwz+36*mw**2+9d0/2*mw**2*r
     &   taw/rwz)
     &   +sdet3itataqs**2*b0ftahta*(-3d0/2*mw**2*rhw+9d0/2*mw**2*rtaw*rhw)
     &   +sdet3itataqs**2*b0fqsww*(-12/qs*mw**4-3d0/2*mw**2-9d0/2*mw**2*rt
     &   aw+3*mw**2*rtaw**2)
     &   +sdet3itataqs**2*b0fqstata*(-30/qs*mw**4/rwz**2+72/qs*mw**4/rwz-4
     &   8/qs*mw**4-27*mw**2/rwz**2+123d0/2*mw**2/rwz-36*mw**2+3d0/2*mw**2
     &   *rhw-9d0/2*mw**2*rtaw/rwz-9d0/2*mw**2*rtaw*rhw)
     &   +sdet3itataqs**2*b0fqscc*(-6*mw**2-9*mw**2*rtaw-3*mw**2*rtaw**2)
     &   +sdet3itataqs*c0tataqswcw*(17d0/2/qs*mw**4+7d0/2*mw**2-25d0/8*mw*
     &   *2*rtaw+mw**2*rtaw**2)
     &   +sdet3itataqs*c0tataqsztah*(-3d0/2*mw**2/rwz**2+2*mw**2/rwz-3d0/2
     &   *mw**2/rwz*rhw+2*mw**2*rhw+6*mw**2*rtaw/rwz-8*mw**2*rtaw)
     &   +sdet3itataqs*c0tataqstazta*(-45d0/2/qs*mw**4/rwz**2+48/qs*mw**4/
     &   rwz-32/qs*mw**4-24*mw**2/rwz**2+89d0/2*mw**2/rwz-24*mw**2-3d0/2*m
     &   w**2*rtaw/rwz)
     &   +sdet3itataqs*c0tataqstahta*(3d0/2/qs*mw**4*rhw**2+3d0/2*mw**2*rh
     &   w-9d0/2*mw**2*rtaw*rhw)
     &   +sdet3itataqs*c0tataqscwc*(-8*mw**2-8*mw**2*rtaw-mw**2*rtaw**2)
     &   +sdet3itataqs*a0fw*(1-8/qs**2*mw**4-3/qs*mw**2)
     &   +sdet3itataqs*a0fz*(-20/qs**2*mw**4/rwz**2+48/qs**2*mw**4/rwz-32/
     &   qs**2*mw**4-18/qs*mw**2/rwz**2+41/qs*mw**2/rwz-24/qs*mw**2+3d0/4/
     &   rwz)
     &   +sdet3itataqs*a0fh*(1d0/qs*mw**2*rhw+3d0/4*rhw)
     &   +sdet3itataqs*a0fta*(21d0/2-5/qs*mw**2/rwz+12/qs*mw**2-8/qs*mw**2
     &   *rwz-9d0/2/rwz-6*rwz-3d0/2*rtaw)
     &   +sdet3itataqs*b0ftawc*(-47d0/8-8/qs**2*mw**4-21d0/2/qs*mw**2)
     &   +sdet3itataqs*b0ftazta*(22-20/qs**2*mw**4/rwz**2+48/qs**2*mw**4/r
     &   wz-32/qs**2*mw**4-18/qs*mw**2/rwz**2+57d0/2/qs*mw**2/rwz-16/qs*mw
     &   **2*rwz-51d0/4/rwz-12*rwz)
     &   +sdet3itataqs*b0ftahta*(-1+5d0/2/qs*mw**2*rhw+3d0/2/rwz+3d0/4*rhw
     &   -3*rtaw)
     &   +sdet3itataqs*b0fqsww*(15d0/8+15d0/2/qs*mw**2-1d0/2*rtaw)
     &   +sdet3itataqs*b0fqszh*(4-3/rwz)
     &   +sdet3itataqs*b0fqstata*(-29d0/2+15d0/2/qs*mw**2/rwz-12/qs*mw**2-
     &   3d0/2/qs*mw**2*rhw+8/qs*mw**2*rwz+21d0/2/rwz+6*rwz+3d0/2*rtaw)
     &   +sdet3itataqs*b0fqscc*(5+1d0/2*rtaw)
     &   +sdet3itataqs*(-37d0/4+5/qs*mw**2/rwz-14/qs*mw**2+8/qs*mw**2*rwz+
     &   9d0/2/rwz+6*rwz+3d0/2*rtaw)
     &   +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(-
     &   1d0/2/ctw**2*vmaup*vmata**2*ts)
     &   +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup*vmata**2*ts)
     &   +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup*vmata**2*ts)
     &   +sdet3ictats*c0ctatsczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vma
     &   ta**2)
     &   +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*pxx2zqsc*(1
     &   d0/2/ctw**2*vmaup*vpata**2*us)
     &   +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     &   aup*vpata**2*us)
     &   +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/ctw**2*v
     &   maup*vpata**2*us)
     &   +sdet3ictaus*c0ctausczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpat
     &   a**2)
     &   +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc**2*(-
     &   1d0/2*sdet3ctats/ctw**2*vmaup*vmata**2*ts)
     &   +sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc**2*(1
     &   d0/2*sdet3ctaus/ctw**2*vmaup*vpata**2*us)
     &   +sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(1d0/2*sde
     &   t3ctats/ctw**2*vmaup*vmata**2*mta**2-1d0/2*sdet3ctats/ctw**2*vmau
     &   p*vmata**2*ts-1d0/2*sdet3ctaus/ctw**2*vmaup*vpata**2*mta**2+1d0/2
     &   *sdet3ctaus/ctw**2*vmaup*vpata**2*us)
     &   +sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*pxx2zqsc*(sdet3ctats
     &   /ctw**2*vmaup*vmata**2*ts)
     &   +sdet4itatsus**2*c0ctausczta*dreal(propizqs)*pxx2zqsc*(-sdet3ctau
     &   s/ctw**2*vmaup*vpata**2*us)
     &   +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/2/ctw**2
     &   *vmaup*vmata**2*qs*ts-1d0/2/ctw**2*vmaup*vpata**2*qs*us)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     &   tw**2*vmaup*vmata**2*mta**2+1d0/2/ctw**2*vmaup*vpata*vmata*ts-5d0
     &   /4*sdet3ctats/ctw**2*vmaup*vmata**2)
     &   +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(1d0/4*sdet3ctats
     &   /ctw**2*vmaup*vmata**2*qs)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     &   ctw**2*vmaup*vpata*vmata*us-1d0/2/ctw**2*vmaup*vpata**2*mta**2+5d
     &   0/4*sdet3ctaus/ctw**2*vmaup*vpata**2)
     &   +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-1d0/4*sdet3ctau
     &   s/ctw**2*vmaup*vpata**2*qs)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2
     &   *vmaup*vmata**2-1d0/4/ctw**2*vmaup*vpata**2)
     &   +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(-1d0/ctw**2*vmaup*vma
     &   ta**2*ts-1d0/4/ctw**2*vmaup*vmata**2*qs-1d0/2/ctw**2*vmaup*vpata*
     &   vmata*us+1d0/2/ctw**2*vmaup*vpata*vmata*ts+1d0/ctw**2*vmaup*vpata
     &   **2*us+1d0/4/ctw**2*vmaup*vpata**2*qs)
     &   +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vma
     &   ta**2*mta**2+3d0/2/ctw**2*vmaup*vmata**2*ts-1d0/ctw**2*vmaup*vpat
     &   a*vmata*ts)
     &   +sdet4itatsus*c0ctausczta*dreal(propizqs)*(1d0/ctw**2*vmaup*vpata
     &   *vmata*us-1d0/2/ctw**2*vmaup*vpata**2*mta**2-3d0/2/ctw**2*vmaup*v
     &   pata**2*us)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vm
     &   aup*vmata**2-1d0/4/ctw**2*vmaup*vpata**2)
     &   +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/4/ctw**2*vmaup*vmata
     &   **2*qs-1d0/2/ctw**2*vmaup*vpata*vmata*us+1d0/2/ctw**2*vmaup*vpata
     &   *vmata*ts-1d0/4/ctw**2*vmaup*vpata**2*qs-1d0/2*sdet3ctats/ctw**2*
     &   vmaup*vmata**2+1d0/2*sdet3ctaus/ctw**2*vmaup*vpata**2)
     &   +d0cctataqstszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmata**2+
     &   1d0/2/ctw**2*vmaup*vpata*vmata)
     &   +d0cctataqsuszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpata*vma
     &   ta+1d0/2/ctw**2*vmaup*vpata**2)
     &   +c0tataqswcw*(-3d0/2/qs*mw**2+1d0/8/qs*mw**2*rtaw)
     &   +c0tataqsztah*(3d0/2/qs*mw**2/rwz**2-2/qs*mw**2/rwz-3d0/2/qs*mw**
     &   2/rwz*rhw+2/qs*mw**2*rhw)
     &   +c0tataqstazta*(-2+3d0/2/qs*mw**2/rwz+3/rwz)
     &   +c0tataqstahta*(-3d0/2/qs*mw**2*rhw)
     &   +c0tataqscwc*(2)
     &   +a0fta*(-1d0/2/qs)
     &   +b0ftawc*(-1d0/8/qs)
     &   +b0ftazta*(3d0/2/qs/rwz-2/qs)
     &   +b0ftahta*(-3d0/2/qs/rwz+1d0/qs)
     &   +b0fqsww*(1d0/8/qs)
     &   +b0fqstata*(1d0/2/qs)
     &   +b0d1tataz*(5/qs**2*mw**2/rwz-12/qs**2*mw**2+8/qs**2*mw**2*rwz+9d
     &   0/2/qs/rwz-10/qs+6/qs*rwz)
     &   +b0dwtacw*(2/qs**2*mw**2+1d0/qs)
     &   +1d0/4/qs

        ffarray(1,1) = ff_qed_ll
        ffarray(1,2) = ff_ew_ll
        ffarray(1,3) = ff_qed_lq
        ffarray(1,4) = ff_ew_lq
        ffarray(1,5) = ff_qed_ql
        ffarray(1,6) = ff_ew_ql
        ffarray(1,7) = ff_qed_qq
        ffarray(1,8) = ff_ew_qq
        ffarray(1,9) = ff_qed_ld
        ffarray(1,10) = ff_ew_ld
        ffarray(1,11) = ff_qed_qd
        ffarray(1,12) = ff_ew_qd
        ffarray(1,13) = ff_qed_gg

        return
      end
